// ppaction.cpp    PURRPUSS  Dev.from C.B.Gunn 22/4/93   jha: 4aug98-24jly01
// BodyEye action merges BodyMove and EyeMove. 23oct99
// Landmarks 14mar01

#include "c:\Program Files\Borland\CBuilder3\examples\foodrink\ppheader.hpp"

extern robot_info *s;
extern pp_info *pp;
extern world w;
extern TWindFile  *wf;
extern char *event_type_names[];     // in ppworld.cpp
extern char *template_names[];       // in ppworld.cpp
extern char *stream_names[];         // in ppworld.cpp

// ***** FUNCTION: get_stimuli_HN() *****
// DESCRIPTION: Loads stimuli into the current field for each type.
//     If (H&N), get stimuli from get_stimulus_from_world().
// NOTE: Can set more than one type in a stream in H&N if
//       get_stimulus_from_world() supplies more.
void get_stimuli_HN()
{ short strm, typ, j;
  unsigned long evnt, evntor;
  wipe_events( ST );   			// in ppstm.cpp
  wf->DisplayAndFile("\nH+N Stim:", 0);
  for (strm=s->nastreams; strm<s->nstreams;  strm++)    // For each s stream
	{for (j=0; j<s->streams[strm].nevtypes; j++ )
	  {typ =s->streams[strm].event_type[j];
	   if (w.diag & 8)
		 {sprintf(wf->wBuf, " %d:", typ);
		  wf->DisplayAndFile(wf->wBuf, 0);
		 }
       if (strm == DESTR) wf->DisplayAndFile("\n", 0);  // next line
       evnt = get_stimulus_from_world(typ);
       if (s->events[typ].tim) s->events[typ].tim_shift_reg[0] = evnt;
	   if (s->events[typ].thr)   // && (evnt != NULLEVENT))
			                   s->events[typ].thr_shift_reg[0] = evnt;
       if (typ == HEAR)
         {s->events[HEARSF].tim_shift_reg[0] = (evnt >> 16) & 0X0000FFFF;
          s->events[HEAROR].tim_shift_reg[0] = evntor = evnt & 0X0000FFFF;
          if (evntor == ULONG_DADASH)
           {s->events[HEARFO].tim_shift_reg[0] = (evnt >> 16) & 0X0000FFFF; // HEARSF
           }
          else
            {s->events[HEARFO].tim_shift_reg[0] = evntor; // HEAROR
// duplicates         if (evntor == ULONG_SG) reward(ULONG_GD);  // not in TT
            }
         }
	  }
	}
}

// ***** FUNCTION: get_stimuli_TT() *****
// DESCRIPTION: Loads stimuli into the current field for each type.
//     If (T&T), get stimuli from s->current_stimulus[].
void get_stimuli_TT()
{ short strm, type, j;
  unsigned long evnt, evntor;
  wipe_events( ST );   			// in ppstm.cpp
  if (!w.no_display_or_file) wf->DisplayAndFile("\nT+T Stim:", 0);
  for (strm=s->nastreams; strm<s->nstreams;  strm++)    // For each s stream
	{evnt = s->current_stimulus[strm].event;
     type = s->current_stimulus[strm].type;
	 if ( evnt != NULLEVENT )
	  {if (s->events[type].tim) s->events[type].tim_shift_reg[0] = evnt;
	   if (s->events[type].thr) s->events[type].thr_shift_reg[0] = evnt;
       if (!w.no_display_or_file)
		{event_to_string(type, evnt);
		 wf->DisplayAndFile(wf->wBuf, 0);
		}
	   if ( type == HEAR )
        {s->events[HEARSF].tim_shift_reg[0] = (evnt >> 16) & 0X0000FFFF;
         s->events[HEAROR].tim_shift_reg[0] = evntor = evnt & 0X0000FFFF;
         if (evntor == ULONG_DADASH)
          {s->events[HEARFO].tim_shift_reg[0]
                                 = (evnt >> 16) & 0X0000FFFF; // HEARSF
          }
         else s->events[HEARFO].tim_shift_reg[0] = evntor; // HEAROR
        }
	  }
     else {if (!w.no_display_or_file)
			   {sprintf(wf->wBuf, " str%d,no stim ", strm);
				wf->DisplayAndFile(wf->wBuf, 0);
	           }
           if (strm != DESTR) //   && (strm != LMSTR)
			   pp->t_t_termination = ON;
	      }
	}
}

// *****  FUNCTION: get_stimulus_from_world()  *****
unsigned long get_stimulus_from_world(short type)
{ unsigned long hear_other, new_desire;
  switch (type)
	 {case TOUCH 		:
			s->touch_evty.event = get_feeling_event();
			event_to_string(s->touch_evty.type, s->touch_evty.event);
			wf->DisplayAndFile(wf->wBuf, 0);
			return(s->touch_evty.event);
	  case PROPRIOCEP :
			s->propriocep_evty.event = get_proprioception_event();
			event_to_string(s->propriocep_evty.type, s->propriocep_evty.event);
			wf->DisplayAndFile(wf->wBuf, 0);
			return(s->propriocep_evty.event);
	  case FOVEA 		:                          // event-type 12
			s->fovea_evty.event = get_fovea_event();
			event_to_string(s->fovea_evty.type, s->fovea_evty.event);
			wf->DisplayAndFile(wf->wBuf, 0);
			return(s->fovea_evty.event);
	  case WIDE       :                          // event-type 14
			s->wide_evty.event = get_wide_event();
			event_to_string(s->wide_evty.type, s->wide_evty.event);
			wf->DisplayAndFile(wf->wBuf, 0);
			extra_events_from_wide( s->wide_evty.event, 0);
			return(s->wide_evty.event);
	  case DIRECTION :                          // event-type 14
			s->dirn_evty.event = get_dirn_event();
			event_to_string(s->dirn_evty.type, s->dirn_evty.event);
			wf->DisplayAndFile(wf->wBuf, 0);
			return(s->dirn_evty.event);
	  case HEAR       :
			s->hear_evty.event = get_hearing_event();
            hear_other = s->hear_evty.event & 0X0000FFFF;
			event_to_string(s->hear_evty.type, s->hear_evty.event);
			wf->DisplayAndFile(wf->wBuf, 0);
			if ((s->current_action[SASTR].event == NULLEVENT)
                 && (hear_other != ULONG_DADASH))
			  {s->events[SAY].tim_shift_reg[0] = s->current_action[SASTR].event
				 		 = hear_other; // heard other
//			   if (w.robot == 'A') store_heard_sound_as_action(); not needed as update_ltmA follows
			  }
			return(s->hear_evty.event);
	  case DESIRE :
            new_desire = get_desire_event();
//			if (s->events[DESIRE].thr_shift_reg[1] == new_desire)
//               s->desire_evty.event = NULLEVENT;
//            else
               s->desire_evty.event = new_desire;
			event_to_string(s->desire_evty.type, s->desire_evty.event);
			wf->DisplayAndFile(wf->wBuf, 0);
			return(s->desire_evty.event);
	  default : error("Stimulus isn't propriocep, fovea, wide, or direction.");
	 } return(0);       // To remove compiler warning.
}

// ***** FUNCTION: get_actions_HN() *****
void get_actions_HN()
{ short strm, ty, i, nod, clr;
  unsigned long ev, evb, eve;
//  struct choice_listA *chptr;
  struct choice_A *adrchA;   // chA
//  wf->DisplayAndFile("\nEntering get_actions.", 2);
  wipe_events( AC );
  if ( w.robot == 'B' )     // Has robot B got too much structure here???
	{for (strm=0; strm<s->nastreams; strm++)       // for each action stream
	  {s->last_action[strm].type = s->current_action[strm].type;   // replaces
	   s->last_action[strm].event = s->current_action[strm].event; // etcopy
	   if ( strm == BESTR )       // body_move_stream
		 {ty = s->current_action[strm].type = BODYEYE;
		  ev = s->events[ty].tim_shift_reg[0] = s->current_action[strm].event
					   					 = subsumption_body_eye_move();
		  evb = (ev >> 8) & 0X000000FF;
		  s->events[BODYMOVE].tim_shift_reg[0] = evb;
		  s->subsumption_counter++; // counts total number of subsumption actions
		  switch ( evb )
			{case ( ULONG_F ): s->events[FORWARD].tim_shift_reg[0] = evb; break;
			 case ( ULONG_L ): s->events[LEFT].tim_shift_reg[0] = evb;
										s->events[TURN].tim_shift_reg[0] = evb; break;
			 case ( ULONG_R ): s->events[RIGHT].tim_shift_reg[0] = evb; break;
			 default : error("Subsumption action is not F, L or R.", evb);
			}
		  eve = ev & 0X000000FF;
		  s->events[EYEMOVE].tim_shift_reg[0] = eve;
		  switch ( eve )
			{case ( ULONG_Y ): s->events[EYESTAY].tim_shift_reg[0] = eve; break;
			 case ( ULONG_N  ): s->events[EYENORTH].tim_shift_reg[0] = eve;
										 s->events[NOTYEYEMOVE].tim_shift_reg[0] = eve; break;
			 case ( ULONG_E  ): s->events[EYEEAST].tim_shift_reg[0] = eve;
										 s->events[NOTYEYEMOVE].tim_shift_reg[0] = eve; break;
			 case ( ULONG_S  ): s->events[EYESOUTH].tim_shift_reg[0] = eve;
										 s->events[NOTYEYEMOVE].tim_shift_reg[0] = eve; break;
			 case ( ULONG_W  ): s->events[EYEWEST].tim_shift_reg[0] = eve;
										 s->events[NOTYEYEMOVE].tim_shift_reg[0] = eve; break;
			 default : error("Subsumption action is not ST,N,E,S or W.", eve);
			}
		  if (!w.no_display_or_file)
		    {sprintf(wf->wBuf,"\nSubs %s %c%c",
  						  event_type_names[ty],charof(evb),charof(eve));
			 wf->DisplayAndFile(wf->wBuf, 0);
		    }
		  }
		if ( strm == SASTR )       // say stream
		  {ty = s->current_action[strm].type = SAY;
		   ev = s->events[ty].tim_shift_reg[0] = s->current_action[strm].event
		   									 = subsumption_speechB();
		   if (!w.no_display_or_file)
			  {sprintf(wf->wBuf, "\nSubs %s:%c%c", event_type_names[ty],
												  charof(( ev >>  8 ) & 0X000000FF),
												  charof(ev & 0X000000FF));
			   wf->DisplayAndFile(wf->wBuf, 0);
              }
		   do_action_in_world( s->current_action[strm] );
		  }
//		do_action_in_world( s->current_action[strm] );
	  }
	}
  else   // robot A
  {wipe_choice_listsA();
   pp->t_t_termination = FALSE;
   for (strm=0; strm<s->nastreams; strm++)       // for each action stream
	 {wipe_best_predsA(strm);
      s->streams[strm].last_expectation = s->streams[strm].current_expectation;
	  s->streams[strm].current_expectation = 0;
      make_choice_listA(strm, EXPNWORTHONLY);
	  if (w.diag & 2)
		 wf->DisplayAndFile("\nAfter make_choice_list in get_actions.", 2);
	  s->last_action[strm].type  = s->current_action[strm].type;  // replaces
	  s->last_action[strm].event = s->current_action[strm].event; // etcopy
      if (w.diag & 2)
		{sprintf(wf->wBuf,"\nActn predns,stream %d", strm);
		 wf->DisplayAndFile(wf->wBuf, 0);
		 for (i=0; i<MAX_CHOICES; i++)   // scan best choice list
		   {if (pp->choice_listsA[strm].charray[i].event.event == NULLEVENT)
					break;
			event_to_string(pp->choice_listsA[strm].charray[i].event.type,
									 pp->choice_listsA[strm].charray[i].event.event);
			wf->DisplayAndFile(wf->wBuf, 2);
		   } // End of printing predictions
		}
	   adrchA = choose_best_from_listA_HN(strm, EXPNWORTHONLY);
	   if ( adrchA->event.event != NULLEVENT ) 	// If best found, print it.
		 {if (w.diag & 2)
		    {wf->DisplayAndFile(" Best=", 0);
			 event_to_string(adrchA->event.type, adrchA->event.event);
			 wf->DisplayAndFile(wf->wBuf, 0);
			 if (adrchA->worth)
			   	sprintf(wf->wBuf,",worth=%.2f,last_worth=%.2f,from nodes:",
										  adrchA->worth,s->streams[strm].last_worth );
			 else if (adrchA->age_worth)
				sprintf(wf->wBuf,",age_worth=%.2f,last_worth=%.2f,from nodes:",
										  adrchA->age_worth,s->streams[strm].last_worth);
			 wf->DisplayAndFile(wf->wBuf, 0);
			 for (i=0; i<MAX_NODES_PER_CHOICE; i++)
				{nod = adrchA->chnodesA[i].node;
				 if (nod == NULLNODE) break;
				 clr = adrchA->chnodesA[i].cluster;
				 display_node(nod, pp->clustersA[clr].assA[nod].temp, 0);
				}
			}
		  if ((s->mode == H_N ) && (adrchA->worth))
			{if ((strm == BESTR) && (adrchA->worth < s->streams[strm].last_worth))
			   {s->boredom_inc = ON;  // Don't do this with SASTR
                if (w.diag & 2) wf->DisplayAndFile(" ***B-inc", 0);
			   }
			 s->streams[strm].last_worth = adrchA->worth;
			}
		  else if ((s->mode == H_N ) && (!adrchA->worth))  // if age-worth
			{if ((strm == BESTR) && (adrchA->age_worth < s->streams[strm].last_worth))
			   {s->boredom_inc = ON;  // Don't do this with SASTR
                if (w.diag& 2) wf->DisplayAndFile(" ****B-inc", 0);
			   }
			 s->streams[strm].last_worth = adrchA->age_worth;
			}
// copy one struct choice_list onto s->best_predictions[STREAM]
		  add_to_best_listA(strm, adrchA); // Used in test_for_TT_term.
		 }
							 //----IF CAN'T choose an action----
	   if ( (s->mode == H_N ) && ((adrchA->event.event == NULLEVENT) ||
			  (s->resource_f < w.sublevel) || (s->resource_d < w.sublevel) ||
							 ( s->disapproval == ON ) ||
					  ( (adrchA->worth  <= 0  ) && (adrchA->age_worth <= 0) )) )
		 {if ( strm == BESTR )       // body_move_stream
		  {ty = s->current_action[strm].type = BODYEYE;
			ev = s->events[ty].tim_shift_reg[0] = s->current_action[strm].event
								  		 = subsumption_body_eye_move();
			evb = (ev >> 8) & 0X000000FF;
			s->events[BODYMOVE].tim_shift_reg[0] = evb;
			s->subsumption_counter++;
			switch ( evb )
			  {case ( ULONG_F ): s->events[FORWARD].tim_shift_reg[0] = evb; break;
			   case ( ULONG_L ): s->events[LEFT].tim_shift_reg[0] = evb;
										s->events[TURN].tim_shift_reg[0] = evb; break;
			   case ( ULONG_R ): s->events[RIGHT].tim_shift_reg[0] = evb; break;
			   default : error("Subsumption action is not F, L or R.", evb);
			  }
			eve = ev & 0X000000FF;
			s->events[EYEMOVE].tim_shift_reg[0] = eve;
			switch ( eve )
			  {case ( ULONG_Y ): s->events[EYESTAY].tim_shift_reg[0] = eve; break;
			   case ( ULONG_N  ): s->events[EYENORTH].tim_shift_reg[0] = eve;
										 s->events[NOTYEYEMOVE].tim_shift_reg[0] = eve; break;
			   case ( ULONG_E  ): s->events[EYEEAST].tim_shift_reg[0] = eve;
										 s->events[NOTYEYEMOVE].tim_shift_reg[0] = eve; break;
			   case ( ULONG_S  ): s->events[EYESOUTH].tim_shift_reg[0] = eve;
										 s->events[NOTYEYEMOVE].tim_shift_reg[0] = eve; break;
			   case ( ULONG_W  ): s->events[EYEWEST].tim_shift_reg[0] = eve;
										 s->events[NOTYEYEMOVE].tim_shift_reg[0] = eve; break;
			   default : error("Subsumption action is not ST,N,E,S or W.", eve);
			  }
		    if (!w.no_display_or_file)
			  {sprintf(wf->wBuf,"\nSubs: %s %c%c",
												event_type_names[ty],charof(evb),charof(eve));
			   wf->DisplayAndFile(wf->wBuf, 0);
			  }
		  }
		  if (strm == SASTR)
			 {ty = s->current_action[strm].type = SAY;
			  ev = s->events[ty].tim_shift_reg[0] = s->current_action[strm].event
					   	= NULLEVENT; // No subsumption speech for robot A
		      if (!w.no_display_or_file)
			    {sprintf(wf->wBuf, "\nSubs %s:%c%c", event_type_names[ty],
												  charof(( ev >>  8 ) & 0X000000FF),
												  charof(ev & 0X000000FF));
			     wf->DisplayAndFile(wf->wBuf, 0);
                }
			  do_action_in_world( s->current_action[strm] ); // i.e. null event
			 }
  //		  do_action_in_world(s->current_action[strm]);
		 }
		else             //----If CAN choose an action----
		 if ( ( s->disapproval == OFF ) && (adrchA->event.event != NULLEVENT) &&
					 ( (adrchA->worth  > 0 ) || (adrchA->age_worth > 0 ) ) )
		  {if (!w.no_display_or_file)
			 {wf->DisplayAndFile("\nH+N: PP ", 0);
			  event_to_string(adrchA->event.type, adrchA->event.event);
			  wf->DisplayAndFile(wf->wBuf, 0);
		      for (i=0; i<MAX_NODES_PER_CHOICE; i++)
			    {nod = adrchA->chnodesA[i].node;
			     if (nod == NULLNODE) break;
			     clr = adrchA->chnodesA[i].cluster;
			     display_node(nod, pp->clustersA[clr].assA[nod].temp, 0);
			    }
			 }
		   if (w.diag & 2)
			 {if (adrchA->worth)
				sprintf(wf->wBuf," Worth=%.2f,strm %d", adrchA->worth, strm);
			  else if (adrchA->age_worth)
				sprintf(wf->wBuf," Age_worth=%.2f,strm %d",adrchA->age_worth,strm);
			  wf->DisplayAndFile(wf->wBuf, 2);
			 }
		   ty = s->current_action[strm].type  = adrchA->event.type;	// replaces
		   ev = s->current_action[strm].event = adrchA->event.event;	// etcopy()
		   s->events[ty].tim_shift_reg[0] = ev;
		   if ( strm == BESTR )
			  if (ty == BODYEYE)
				{evb = (ev >> 8) & 0X000000FF;
				 s->events[BODYMOVE].tim_shift_reg[0] = evb;
				 switch ( evb )
					{case ( ULONG_F ): s->events[FORWARD].tim_shift_reg[0]=evb; break;
					 case ( ULONG_L ): s->events[LEFT].tim_shift_reg[0] = evb;
											 s->events[TURN].tim_shift_reg[0] = evb; break;
					 case ( ULONG_R ): s->events[RIGHT].tim_shift_reg[0] = evb; break;
					 default : error("Chosen action is not F, L or R.", evb);
					}
				 eve = ev & 0X000000FF;
				 s->events[EYEMOVE].tim_shift_reg[0] = eve;
				 switch ( eve )
					{case ( ULONG_Y ): s->events[EYESTAY].tim_shift_reg[0] = eve; break;
					 case ( ULONG_N  ): s->events[EYENORTH].tim_shift_reg[0]= eve;
											  s->events[NOTYEYEMOVE].tim_shift_reg[0] = eve; break;
					 case ( ULONG_E  ): s->events[EYEEAST].tim_shift_reg[0] = eve;
											  s->events[NOTYEYEMOVE].tim_shift_reg[0] = eve; break;
					 case ( ULONG_S  ): s->events[EYESOUTH].tim_shift_reg[0]= eve;
											  s->events[NOTYEYEMOVE].tim_shift_reg[0] = eve; break;
					 case ( ULONG_W  ): s->events[EYEWEST].tim_shift_reg[0] = eve;
											  s->events[NOTYEYEMOVE].tim_shift_reg[0] = eve; break;
					 default : error("Chosen action is not staY,N,E,S or W.", eve);
					}
				}
		   else if ( strm != SASTR)
				error("Stream isn't BESTR or SASTR but ", ty);
		   do_action_in_world(s->current_action[strm]);
		  }
} }  }

// ***** FUNCTION: get_actions_TT() *****
void get_actions_TT()
{ short strm, ty, i, nod, clr;
  short alts = FALSE, madechoice = FALSE;
  unsigned long ev, evb, eve;
//  struct choice_listA *chptr;
  struct choice_A *adrchA;   // chA
//  wf->DisplayAndFile("\nEntering get_actions.", 2);
  wipe_events( AC );
  wipe_choice_listsA();
  pp->t_t_termination = FALSE;
  for (strm=0; strm<s->nastreams; strm++)       // for each action stream
	{wipe_best_predsA(strm);
	 s->streams[strm].last_expectation = s->streams[strm].current_expectation;
	 s->streams[strm].current_expectation = 0;
//	 if (strm == BESTR)
//	   {
     while ( (!(make_choice_listA(strm, EXPNWORTHONLY)) )
							&& ( s->mode == T_T )
							&& ( alts = there_are_alternative_stimuli() ) ) ;
	 if (w.diag & 2)
		  wf->DisplayAndFile("\nAfter make_choice_list in get_actions.", 2);
	 s->last_action[strm].type  = s->current_action[strm].type;  // replaces
	 s->last_action[strm].event = s->current_action[strm].event; // etcopy
//		if (strm == BESTR)
//		chptr = pp->choice_listsA[strm];               // best choice list pointer
//		 {
     if (w.diag & 2)
	   {sprintf(wf->wBuf,"\nActn predns,stream %d", strm);
		wf->DisplayAndFile(wf->wBuf, 0);
		for (i=0; i<MAX_CHOICES; i++)   // scan best choice list
		  {if (pp->choice_listsA[strm].charray[i].event.event == NULLEVENT)
					break;
		   event_to_string(pp->choice_listsA[strm].charray[i].event.type,
									 pp->choice_listsA[strm].charray[i].event.event);
		   wf->DisplayAndFile(wf->wBuf, 2);
		  } // End of printing predictions
	   }
	 adrchA = choose_best_from_listA_TT(strm, EXPNWORTHONLY);
	 if ( adrchA->event.event != NULLEVENT ) 	// If best found, print it.
	   {if (w.diag & 2)
		 {wf->DisplayAndFile(" Best=", 0);
		  event_to_string(adrchA->event.type, adrchA->event.event);
		  wf->DisplayAndFile(wf->wBuf, 0);
		  if (adrchA->worth)
			sprintf(wf->wBuf,",worth=%.2f,last_worth=%.2f,from nodes:",
			 						  adrchA->worth,s->streams[strm].last_worth );
		  else if (adrchA->age_worth)
			sprintf(wf->wBuf,",age_worth=%.2f,last_worth=%.2f,from nodes:",
										  adrchA->age_worth,s->streams[strm].last_worth);
		  wf->DisplayAndFile(wf->wBuf, 0);
		  for (i=0; i<MAX_NODES_PER_CHOICE; i++)
			{nod = adrchA->chnodesA[i].node;
			 if (nod == NULLNODE) break;
			 clr = adrchA->chnodesA[i].cluster;
			 display_node(nod, pp->clustersA[clr].assA[nod].temp, 0);
			}
		 }
// copy one struct choice_list onto s->best_predictions[STREAM]
		add_to_best_listA(strm, adrchA); // Used in test_for_TT_term.
	   }
//		if ((strm == BESTR) && (test_for_tt_terminationA(strm)))
	 if (test_for_tt_terminationA(strm)) // Can terminate with SASTR
	   {pp->t_t_termination = TRUE;
//			  stay_in_or_restore_h_n();  // Not here:it shorts the cycle 10sep99
		break;
	   }
						 //----If CAN choose an action----
	 if ( ( s->disapproval == OFF ) && (adrchA->event.event != NULLEVENT) &&
					 ( (adrchA->worth  > 0 ) || (adrchA->age_worth > 0 ) ) )
	   {if (!w.no_display_or_file)
		  {wf->DisplayAndFile("\nT+T: PP ", 0);
		   event_to_string(adrchA->event.type, adrchA->event.event);
		   wf->DisplayAndFile(wf->wBuf, 0);
		  }
		if (w.diag & 2)
		  {if (adrchA->worth)
		     sprintf(wf->wBuf," Worth=%.2f,strm %d", adrchA->worth, strm);
		   else if (adrchA->age_worth)
		   	 sprintf(wf->wBuf," Age_worth=%.2f,strm %d",adrchA->age_worth,strm);
		   wf->DisplayAndFile(wf->wBuf, 2);
		  }
		ty = s->current_action[strm].type  = adrchA->event.type;	// replaces
		ev = s->current_action[strm].event = adrchA->event.event;	// etcopy()
		s->events[ty].tim_shift_reg[0] = ev;
		if ( strm == BESTR )
		  if (ty == BODYEYE)
			{evb = (ev >> 8) & 0X000000FF;
			 s->events[BODYMOVE].tim_shift_reg[0] = evb;
			 switch ( evb )
			   {case ( ULONG_F ): s->events[FORWARD].tim_shift_reg[0]=evb; break;
				case ( ULONG_L ): s->events[LEFT].tim_shift_reg[0] = evb;
											 s->events[TURN].tim_shift_reg[0] = evb; break;
				case ( ULONG_R ): s->events[RIGHT].tim_shift_reg[0] = evb; break;
				default : error("Chosen action is not F, L or R.", evb);
			   }
			 eve = ev & 0X000000FF;
			 s->events[EYEMOVE].tim_shift_reg[0] = eve;
			 switch ( eve )
			   {case ( ULONG_Y ): s->events[EYESTAY].tim_shift_reg[0] = eve; break;
				case ( ULONG_N  ): s->events[EYENORTH].tim_shift_reg[0]= eve;
											  s->events[NOTYEYEMOVE].tim_shift_reg[0] = eve; break;
				case ( ULONG_E  ): s->events[EYEEAST].tim_shift_reg[0] = eve;
										  s->events[NOTYEYEMOVE].tim_shift_reg[0] = eve; break;
				case ( ULONG_S  ): s->events[EYESOUTH].tim_shift_reg[0]= eve;
											  s->events[NOTYEYEMOVE].tim_shift_reg[0] = eve; break;
				case ( ULONG_W  ): s->events[EYEWEST].tim_shift_reg[0] = eve;
											  s->events[NOTYEYEMOVE].tim_shift_reg[0] = eve; break;
				default : error("Chosen action is not staY,N,E,S or W.", eve);
			   }
			}
		  else if (strm != SASTR)
              error("Stream isn't BESTR or SASTR but ", ty);
//c 			update_canvas_by_action(evb);
//c 			update_canvas_by_action(eve);
	   }
}    }

