// ppcycle.cpp    PURRPUSS    Dev.from C.B.Gunn 22/4/93    jha:8aug98-26jly01
//  Speech additions suppressed  here  16sep99
//  Adding new fovea-predicting template [Wide,BodyMove,EyeMove >> Fovea] 23sp99
//  Calculation of numbers of events at end of ppworld.cpp.
//  Feel removed and body-eye moves merged. 23oct99
//  Touch restored 12feb00.
//  16feb00: Touch-predicting context template enlarged and new canvas stimuli
//   for predicting wide (in new canvwide directory)
//  20mar00: FovNoEye replaced by Fovea in context of template BE.
//  Adding Proprioception to the BE context. 10apr00
//  Adding reward counters to predictionA's.  18apr00
//  Increased resolution of propriocep to 5x5 cells inside NN,EE,SS,WW. 20apr00
//  No learning 26apr00
//  Leakback limit set to 3000 nodes.  27apr00
//  Leakback calculation from list of reward and novelty nodes. 1may00
//  Decreasing value of past memory by increasing quantum. 20may00
//  Doubling quantum,not just linear.  26may00
//  Win32 dos window version   13feb01
//  15feb01 DOS window and forgetting programs from SideBy Win32 programs.
//  16feb01 First successful run. sp16fb01.m   zz*.dat
//  17feb01 Counting to 10k steps  yy*.dat
//  18feb01 Restricting memory xx*.dat ctxtsA 2200, ctxtsS 3300, predsA&S 6000
//            ptrprbs 9000, bptrs 9000, linksA&S 7000
//  22feb01 Restricting ctxts only ww*.dat ctxtsA 2000, ctxtsS 300, predsA&S 7000
//            ptrprbs 10000, bptrs 10000, linksA&S 8000
//  27,28feb01 TellMove with BE context Wide,Fovea,Direction,Touch,Hear and
//            SA context Wide,Fovea,Direction,Touch. d:\ppdata\tellmove\zz27fb01.zip
//  28feb01 Dropped Touch from SA context to allow PP to learn alternative speech
//          actions. Also allowing PP to say even when no drive. tellmove\yy*.dat
//  05mar01 HEAR, HEARSF, HEAROR, HEARFO stimuli to enable PP to distinguish sounds
//          it has made itself from outside sounds.
//  07mar01 Everything being forgotten more than 4000 steps back, so increased
//          limits on nodes from A2000,S3000 to A5000,S5000
//  08mar01 Proprioception added to contexts of Touch and Wide. Unable to get
//          of subsumption level.
//  09mar01 Proprioception removed again from contexts of Touch and Wide to
//          check that nothing else keeping it from rising above subsumption
//          level. OK, so changed eye algorithm to prefer moving to wide over
//          staying on fovea when object or robot there.
//  13mar01 Changed resource decrements to proportional to make them nonlinear
//          and make the system less likely to drop below subsumption-only level.
//  26mar01 Routine in update_nodeS to remove preds without current landmark.
//  02apr01 Dumping etc determined by step series.
//  09apr01 Landmarks adjusted only if a drive is on.
//  10apr01 Nov=2,4,6 not now a criterion for a landmark.
//  12apr01 Inc/dec of landmark-tAge reduced to 1 from quantum,
//          and mark is 2,4,6   ww*.dat
//  17apr01 Increasing reward-rate-threshold but only 50% chance of
//          novelty-removal if below threshold. Also reduced MAX_NODES_A to 5000
//          as only 6000 nodes used up to about 3.5m steps. vv*.dat
//  24apr01 Moved from examples\landmark to examples\foodrink to try
//          moving update_ltmA to after get_stimuli_HN so that "GOOD"
//          reward can affect storing. Should also simplify mimic-speech.
//  25apr01 Robot B is telling A to make moves when not hungry/thirsty.
//          Remember that I am letting robot B see if A is hungry/thirsty!!<<<<
//  04may01 w.ul_B_told_A not nulled properly in xx1may01 run. Corrected in zz.
//  07may01 Found a mistake in DN template and corrected this. Changed DE. yy*.dat
//  08may01 Computer had turned itself off several times. Switched right off,
//          defragmented and restarted.  xx*.dat
//  09may01 Error again probably due to screensaver. Turned off screensaver and
//          power-saving screen-turn-off. Will do it manually. Added Desire event
//          type to W, F and DN templates, BodyMove to DE. zz*.dat again
//  12may01 9May run had trouble with predicting desire so have changed it to timing
//          Also robot B tells A to turn to enable B to squash object. yy*.dat
//  15may01 zz*.dat
//  18may01 Removed Touch replaces Desire in F,W,DN temp. No landmarks. yy*.dat
//  24may01 Found that shifting ppltmA invalidated mark checking. zz*.dat
//  29may01 More corrections to get mark-checking and plans to GOOD right yy*.dat
//  01jun01 Wipe_all_marks missing nodes. Corrected. zz*.dat
//  06jun01 Marks must be set to NULLMARK (= 0).  yy*.dat
//  07jun01 Good run with GOOD reward for single action copy. yy*.dat
//  10jun01 Reward for 2 consecutive action copies by robot A. zz*.dat
//  22jun01 Changed program so that extra graph line can be obtained.
//  25jun01 ClSS associations had been unintentionally restricted in 10jun01 run,
//       so node limit increased from 50 to 200, pred limit from 100 to 1000.
//  13jly01 HEAR added to SA and replaces HEARFO in BE template   xx*.dat
//       This is not as good a run as 25jun01 in spite of better plans at step
//       500k. My guess is that BE and SA clusters need more associations.
//  16jly01 Upper template to predict DIRECTION. HEARFO back in BE, HEAR out of
//       SA. ww*.dat
//  26jly01 Corrected marking proc in Ppreda.cpp, otherwise same 16jly01 vv*.dat

#include "c:\Program Files\Borland\CBuilder3\examples\foodrink\ppheader.hpp"

extern robot_info *s;
extern robot_info *sa;
extern robot_info *sb;
extern pp_info *pp;
extern world w;
extern TWindFile	*wf;
extern char *event_type_names[];     // in ppworld.cpp
extern char *template_names[];       // in ppworld.cpp
extern char *cluster_namesA[];        // in ppworld.cpp
extern char *cluster_namesS[];        // in ppworld.cpp
extern char *stream_names[];         // in ppworld.cpp
step_series[MAX_FILE_LINES] =
		  {1,2,3,4,5,6,7,8,9,10,11,12,13,15,17,20,23,26,30,35,40,45,50,55,60,
            70,80,90,100,110,120,130,150,170,200,230,260,300,350,400,450,500,
            550,600,700,800,900,1000,1100,1200,1300,1500,1700,2000,2300,2600,
            3000,3500,4000,4500,5000,5500,6000,7000,8000,9000,10000,11000,12000,
            13000,15000,17000,20000,23000,26000,30000,35000,40000,45000,50000};
char *kindofpred_string[] = {"", "choice", "recency"};

// ***** FUNCTION: world_data() *****
void world_data()
{ char bufd[10], buft[10];
  short i;
  long robmem, ppmem, worldmem;
  w.filechar--;          // New doubled character for file names in each re-run
  if (w.filechar < 97) exit(EXIT_SUCCESS);
  wf->mainFileCount = 0;
  w.no_display_or_file = FALSE;
  wf->ChangeMainFile();
  wf->DisplayAndFile("\nSQUASH-POP World with PURR-PUSS and another robot."
							"\nJohn H Andreae  "
							"University of Canterbury, Christchurch, New Zealand.", 0);
  w.seed = 12321;
  srand(w.seed);
  sprintf(wf->wBuf, "\n   First Data File: %s"
						  "\n   Run starting on %s at %s with seed %d" ,
							  wf->File->Main, _strdate(bufd), _strtime(buft), w.seed);
  wf->DisplayAndFile(wf->wBuf, 0);
  w.change_file_step = wf->maxStepsInFile;
  w.help = 0;
  for (i=0; i<MAX_FILE_LINES; i++) w.m_step_cycles[i] = step_series[i];
  w.m_file_line = 0;
  w.food  = FOOD;
  w.drink = DRINK;
  w.plus  = PLUS;
  w.good  = GOOD;
  w.reward_count =0;
  w.rewards_between_goal_change = 20;
  w.current_goal = ULONG_O;
  w.fooddec  = 0.9997;  //  food resource decrement due to forward move
  w.drinkdec = 0.99992; //  drink resource decrement due to any move
  w.foodinc =  1.3;     //  food resource increment due to reward
  w.drinkinc = 1.3;     //  drink resource increment due to reward
  w.sat_up = 95.0;      //  level of resource above which drive vanishes
  w.sat_down = 80.0;    //  level of resource below which drive comes on
  w.sublevel = 10.0,    //  level of resource below which actions are subsumption
  w.step_cycle_before_counters_zeroed = 10000; // Must be multiple of steps in file.
  if (w.step_cycle_before_counters_zeroed%wf->maxStepsInFile)
	 error("step_cycle_before_counters_zeroed must be multiple of maxStepsInFile");
  w.step_for_restart_with_different_file_name = 10200002;//2200002; // Length of each run
  w.leakback_node_limit = 2*MAX_NODES_A;  // Max nodes for incremental process/cluster/step
  w.leakback_level_limit = 20;    // Max levels for complete process/cluster/step
  w.leakback_frequency = 10;        // Whole Leakback process every nth step.
  w.quantum = QUANTUM;		// in ppheader.hpp
  w.discount_factor = 0.95;
  w.mark_up_factor  = 2;
  w.deterministic   = 7;
  w.probabilistic   = 10;
  w.leakback_threshold = 0.01;
  w.expectation_for_good = 0.5;         // 1;
  w.expectation_for_novelty = 0.3;         // 1;
  w.holding_reward_getting_associations = FALSE;
  w.novelty_with_leakback_only = TRUE;
  w.plans_remove_novelty = TRUE;
  w.expn_calc_omits_ptrs_to_same_node = 0; // bkptr/ptrprob to same node in lkbk
  w.robot_B_helps = TRUE;
  w.robot_B_tells = TRUE;
  w.ul_B_told_A = NULLEVENT;
  w.ul_B_told_A_prev = NULLEVENT;
  w.number_step_cycles = 0;
  w.diag = 0;        // No diagnostics to be printed      // needed in Dump
  w.sound_A = ULONG_DADASH;
  w.sound_B = ULONG_DADASH;
  w.object_squashed = FALSE;  // A variable used by ppworld.cpp
  // REMEMBER wf->wBuf has a capacity of only 256 characters! <<<<<!!!!!
  for ( i=0; i<MAX_FILE_LINES; i++ )
	  {w.m_file[i].number_step_cycles = 0;
		w.m_file[i].A_subacts = 0;
		w.m_file[i].A_steps_below_sub = 0;
		w.m_file[i].A_reward_fs = 0;
		w.m_file[i].A_reward_ds = 0;
		w.m_file[i].A_total_fs = 0;
		w.m_file[i].A_total_ds = 0;
		w.m_file[i].A_reward_gs = 0;
		w.m_file[i].B_reward_fs = 0;
		w.m_file[i].B_reward_ds = 0;
		w.m_file[i].B_total_fs = 0;
		w.m_file[i].B_total_ds = 0;
		w.m_file[i].B_rewards_nofd = 0;
		w.m_file[i].B_steps_below_sub = 0;
		w.m_file[i].number_of_B_tells = 0;
		w.m_file[i].number_BE_associations = 0;
		w.m_file[i].number_f_rewarded_BE_associations = 0;
		w.m_file[i].number_d_rewarded_BE_associations = 0;
		w.m_file[i].number_fd_rewarded_BE_associations = 0;
		w.m_file[i].number_novelty_BE_associations = 0;
		w.m_file[i].number_plans_followed = 0;
		w.m_file[i].number_TCH_associations = 0;
		w.m_file[i].number_PR_associations = 0;
		w.m_file[i].number_F_associations = 0;
		w.m_file[i].number_W_associations = 0;
		w.m_file[i].number_DN_associations = 0;
	  }
  robmem =  100 + 6*MAX_EVENT_TYPES + (54 + 6*MAX_EVENTS_IN_STREAM)*MAX_STREAMS;
  ppmem =   49 + 2*MAX_CLUSTERS + 2*LKBK_LISTS_LENGTH + 4*MAX_REWARDED_PLANS
	  + MAX_A_CLUSTERS*(12 + CLUSTER_NAME_LENGTH + 31 + 2*MAX_REWARD_NOVELTY
      + 18*MAX_CONTEXT_LINKS_A + 30*MAX_NODES_A + 29*MAX_PREDICTIONS_A
      + 10*MAX_POINTER_PROBS + 6*MAX_BACK_POINTERS + 6 + MAX_TEMPS_IN_CLUSTER)
	  + MAX_S_CLUSTERS*(4 + CLUSTER_NAME_LENGTH + 19 + 18*MAX_CONTEXT_LINKS_S
	  + 22*MAX_NODES_S + 14*MAX_PREDICTIONS_S + 6 + MAX_TEMPS_IN_CLUSTER)
	  + MAX_TEMPLATES*(TEMPLATE_NAME_LENGTH + 19 + MAX_TEMP_PREDICTION_TYPES
	  + 6*MAX_CONTEXT_EVENTS)
	  + MAX_STREAMS*(6 + (10 + 4*MAX_NODES_PER_CHOICE)*(MAX_CHOICES + 1))
	  + MAX_A_CLUSTERS*(CLUSTER_NAME_LENGTH + 31 + 2*MAX_REWARD_NOVELTY
      + 18*MAX_CONTEXT_LINKS_A + 30*MAX_NODES_A + 29*MAX_PREDICTIONS_A
      + 10*MAX_POINTER_PROBS + 6*MAX_BACK_POINTERS + 6 + MAX_TEMPS_IN_CLUSTER)
	  + MAX_S_CLUSTERS*(CLUSTER_NAME_LENGTH + 19 + 18*MAX_CONTEXT_LINKS_S
	  + 22*MAX_NODES_S + 14*MAX_PREDICTIONS_S + 6 + MAX_TEMPS_IN_CLUSTER)
	  + MAX_A_STREAMS*((14 + 4 * MAX_NODES_PER_CHOICE)*(MAX_CHOICES + 1))
	  + 24 + 8*MAX_NODES_PER_CHOICE + 4*MAX_NODES_A
      + MAX_LEAKBACK_CLUSTERS*(4 + 2*LKBK_LISTS_LENGTH)
	  + 14 + 14*MAX_REWARD_GETTING_ASSOCIATIONS
	  + 20*MAX_S_CLUSTERS + 6*(MAX_S_STREAMS + MAX_A_STREAMS)
      + ((3 + 8*MAX_EVENT_SHIFTS)*MAX_EVENT_TYPES) + 8*MAX_A_STREAMS + 1;
  worldmem = 152 + 4*BOARD_CELLS + 78*MAX_FILE_LINES;
  sprintf(wf->wBuf, "\nRobot memory=%d, pp memory =%d, world memory = %d ",
					 robmem, ppmem, worldmem);
  wf->FileOnly(wf->wBuf);
  FileOnly_world_data();
}

void FileOnly_world_data()
{ char bufd[10], buft[10];
  short i;
  sprintf(wf->wBuf, "\nzFile: %s on %s at %s. " ,
					wf->File->Main, _strdate(bufd), _strtime(buft) );
  wf->FileOnly(wf->wBuf);
  sprintf(wf->wBuf,
     "\nzRandom seed = %d "
//	 "\nzInverse_prob_of_raising_hand_from_object = %d "
	 "\nzResource food/drink dec = %.2f/%.2f, food/drink inc = %.1f/%.1f "
	 "\nzResource sat_up/down = %.1f/%.1f, subsumption level = %.1f ",
     w.seed,
//	 w.inverse_prob_of_raising_hand_from_object,
	  w.fooddec, w.drinkdec, w.foodinc, w.drinkinc,
	 w.sat_up, w.sat_down, w.sublevel);
  wf->FileOnly(wf->wBuf);
  sprintf(wf->wBuf,
	 "\nzStep for restart with different file name = %d " // Length of each run
	 "\nzWhole Leakback process every %d th step "
	 "\nzStep cycle: %d steps before counters zeroed ",
	 w.step_for_restart_with_different_file_name, w.leakback_frequency,
	 w.step_cycle_before_counters_zeroed);
  wf->FileOnly(wf->wBuf);
  sprintf(wf->wBuf,
	 "\nzdiscount_factor=%f\nzmark_up_factor=%d"
	 "\nzdeterministic=%d\nzprobabilistic=%d",
	  w.discount_factor, w.mark_up_factor, w.deterministic, w.probabilistic);
  wf->FileOnly(wf->wBuf);
  sprintf(wf->wBuf,
	 "\nzexpectation_for_novelty/good=%f/%f"
	 "\nzleakback_node/level_limit=%d/%d\nzleakback_threshold=%f",
	 w.expectation_for_novelty, w.expectation_for_good,
     w.leakback_node_limit, w.leakback_level_limit,
	 w.leakback_threshold);
  wf->FileOnly(wf->wBuf);
  if (w.novelty_with_leakback_only)
	 wf->FileOnly("\nzPlans terminated by Novelty in leakback clusters only.");
  else wf->FileOnly("\nzPlans terminated by Novelty in all clusters.");
  if (w.plans_remove_novelty)
	 wf->FileOnly("\nzPlans remove novelty.");
  else wf->FileOnly("\nzPlans don't remove novelty.");
  if (w.holding_reward_getting_associations)
	 wf->FileOnly("\nzholding reward-getting associations.");
  else wf->FileOnly("\nzNot holding reward-getting associations.");
  if (w.expn_calc_omits_ptrs_to_same_node == 1)
	 wf->FileOnly("\nzExpectation calculation omits ptrs to same node.");
  else wf->FileOnly("\nzExpectation calculation uses ptrs to same node.");
  if (w.robot_B_helps)
	  wf->FileOnly("\nzRobot B's subsumption moves help Robot A.");
  else wf->FileOnly("\nzRobot B's moves don't help Robot A.");
  if (w.robot_B_tells)
	  wf->FileOnly("\nzRobot B tells robot A some moves to make.");
  else wf->FileOnly("\nzRobot B doesn't tell robot A some moves to make.");
}


void robot_data()
{ short i,j,k;
  if (w.robot == 'A') wf->DisplayAndFile("\n\nStoring Robot Data for A: ", 2);
	 else wf->DisplayAndFile("\n\nStoring Robot Data for B: ", 2);
  s->mode = H_N;
  s->step             = 0;
  s->steps_with_f_drive_and_O = 0;
  s->steps_with_d_drive_and_Q = 0;
  s->steps_below_sublevel = 0;
  s->boredom          = 0;
  s->boredom_inc      = OFF;
  s->frustration      = 0;
  s->drive            = 0;
  s->reward           = 0;
  s->disapproval      = 0;
  s->reward_counter_f = 0;
  s->rewards_without_drivefd = 0;
  s->reward_counter_d = 0;
  s->reward_counter_gd = 0;
  s->number_of_B_tells = 0;
  s->resource_f       = 80;
  s->resource_d       = 80;
  s->subsumption_counter = 0;
// Define events **** EVENT TYPE IS s->events argument
// which matches event_type_constants above and  event_type_names in ppworld.cpp
  s->events[BODYMOVE].acst = AC;   s->events[BODYMOVE].tim = TRUE;
  s->events[FORWARD].acst = AC;    s->events[FORWARD].tim = TRUE;
  s->events[LEFT].acst = AC;       s->events[LEFT].tim = TRUE;
  s->events[RIGHT].acst = AC;      s->events[RIGHT].tim = TRUE;
  s->events[TURN].acst = AC;       s->events[TURN].tim = TRUE;
  s->events[EYEMOVE].acst = AC;    s->events[EYEMOVE].tim = TRUE;
  s->events[EYESTAY].acst = AC;    s->events[EYESTAY].tim = TRUE;
  s->events[EYENORTH].acst = AC;   s->events[EYENORTH].tim = TRUE;
  s->events[EYEEAST].acst = AC;    s->events[EYEEAST].tim = TRUE;
  s->events[EYESOUTH].acst = AC;   s->events[EYESOUTH].tim = TRUE;
  s->events[EYEWEST].acst = AC;    s->events[EYEWEST].tim = TRUE;
  s->events[NOTYEYEMOVE].acst = AC; s->events[NOTYEYEMOVE].tim = TRUE;
  s->events[BODYEYE].acst = AC;    s->events[BODYEYE].tim = TRUE;
  s->events[SAY].acst = AC;        s->events[SAY].tim = TRUE;
//  s->events[ALTERDRIVE].acst = AC; s->events[ALTERDRIVE].tim = TRUE;
  s->events[TOUCH].acst = ST;      s->events[TOUCH].tim = TRUE;
  s->events[PROPRIOCEP].acst = ST; s->events[PROPRIOCEP].tim = TRUE;
  s->events[FOVEA].acst = ST;      s->events[FOVEA].tim = TRUE;
  s->events[WIDE].acst = ST;       s->events[WIDE].tim = TRUE;
  s->events[WIDENONLY].acst = ST;  s->events[WIDENONLY].tim = TRUE;
  s->events[WIDEEONLY].acst = ST;  s->events[WIDEEONLY].tim = TRUE;
  s->events[WIDESONLY].acst = ST;  s->events[WIDESONLY].tim = TRUE;
  s->events[WIDEWONLY].acst = ST;  s->events[WIDEWONLY].tim = TRUE;
  s->events[DIRECTION].acst = ST;  s->events[DIRECTION].tim = TRUE;
  s->events[HEAR].acst = ST;       s->events[HEAR].tim = TRUE;
  s->events[HEARSF].acst = ST;     s->events[HEARSF].tim = TRUE;
  s->events[HEAROR].acst = ST;     s->events[HEAROR].tim = TRUE;
  s->events[HEARFO].acst = ST;     s->events[HEARFO].tim = TRUE;
  s->events[DESIRE].acst = ST;     s->events[DESIRE].tim = TRUE;
  i=0;                  // Count number of event_types.
  while ( strcmp(event_type_names[i],"MARKER") ) i++;  // 0 if same!
  s->nevtypes = i;
  sprintf(wf->wBuf, "\nThere are %d event types. ", i);
  wf->DisplayAndFile(wf->wBuf, 2);
// Use event-type = NULLTYPE as a non-event-type (instead of 0 which is valid)
// Use event = NULLEVENT as a non-event and BE SURE IT IS NOT A VALID ONE!
  for (i = 0; i < s->nevtypes; i++)
	{ s->events[i].thr = FALSE;
	  if ( s->events[i].tim == TRUE )
		for (j = 0; j < MAX_EVENT_SHIFTS; j++)
		  { s->events[i].tim_shift_reg[j] = NULLEVENT; }
	  if ( s->events[i].thr == TRUE )     // redundant in this case
		for (j = 0; j < MAX_EVENT_SHIFTS; j++)
		  { s->events[i].thr_shift_reg[j] = NULLEVENT; }
	}

  if (s->nevtypes > MAX_EVENT_TYPES)
	  error("Increase MAX_EVENT_TYPES to ", s->nevtypes);

  wf->DisplayAndFile("\nEvent types are: ", 2);
  for (i = 0; i < s->nevtypes; i++)
	 {if ( !(i%7) ) wf->DisplayAndFile("\n   ", 2);
	  sprintf(wf->wBuf,"  %d:%s",i,event_type_names[i]);
	  wf->DisplayAndFile(wf->wBuf, 2);
	 }
  s->hear_evty.type =       HEAR;
  s->touch_evty.type =      TOUCH;
  s->propriocep_evty.type = PROPRIOCEP;
  s->fovea_evty.type  =     FOVEA;
  s->wide_evty.type =       WIDE;
  s->dirn_evty.type =       DIRECTION;
  s->desire_evty.type =     DESIRE;

//  Define Streams - action streams
  s->streams[BESTR].event_type[0] = BODYEYE;
  s->streams[BESTR].nevtypes = 1;
  s->streams[SASTR].event_type[0] = SAY;
  s->streams[SASTR].nevtypes = 1;
  s->nastreams = 2;
//                 - stimulus streams
  s->streams[TCHSTR].event_type[0] = TOUCH;
  s->streams[TCHSTR].nevtypes = 1;
  s->streams[PROPSTR].event_type[0] = PROPRIOCEP;
  s->streams[PROPSTR].nevtypes = 1;
  s->streams[FOVSTR].event_type[0] = FOVEA;
  s->streams[FOVSTR].nevtypes = 1;
  s->streams[WIDESTR].event_type[0] = WIDE;
  s->streams[WIDESTR].nevtypes = 1;
  s->streams[DIRNSTR].event_type[0] = DIRECTION;
  s->streams[DIRNSTR].nevtypes = 1;
  s->streams[SSSTR].event_type[0] = HEAR;
  s->streams[SSSTR].nevtypes = 1;
  s->streams[DESTR].event_type[0] = DESIRE;
  s->streams[DESTR].nevtypes = 1;
  s->nsstreams = 7;
  s->nstreams = s->nastreams + s->nsstreams;
  i=0;
  while ( strcmp(stream_names[i],"NOSTREAM") ) i++;  // 0 if same!
  if (s->nstreams == i)				// Works out number of streams
  	 {sprintf(wf->wBuf, "\nThere are %d streams. ", i);
	  wf->DisplayAndFile(wf->wBuf, 2);
	 }
  else error("Wrong number of streams given: ", s->nstreams);

  if (s->nastreams > MAX_A_STREAMS)
	 error("Increase MAX_A_STREAMS to ", s->nastreams);
  if (s->nsstreams > MAX_S_STREAMS)
	 error("Increase MAX_S_STREAMS to ", s->nsstreams);
  if (s->nstreams > MAX_STREAMS)
	 error("Increase MAX_STREAMS to ", s->nstreams);
  for (k=0; k < s->nstreams; k++)
	 {s->streams[k].template_priority = NULL;
	  s->current_stimulus[k].type = NULLTYPE;
	  s->current_stimulus[k].event = NULLEVENT;
	  s->predicted_stimulus[k].type = NULLTYPE;
	  s->predicted_stimulus[k].event = NULLEVENT;
	  s->current_action[k].type = NULLTYPE;
	  s->current_action[k].event = NULLEVENT;
	  s->last_action[k].type = NULLTYPE;
	  s->last_action[k].event = NULLEVENT;
	  s->predicted_action[k].type = NULLTYPE;
	  s->predicted_action[k].event = NULLEVENT;
	  s->streams[k].last_expectation = 0;
	  s->streams[k].current_expectation = 0;
	  s->streams[k].last_worth = 0;
	  if (s->streams[k].nevtypes > MAX_EVENTS_IN_STREAM)
		 error("Increase MAX_EVENTS_IN_STREAM to %d. ",s->streams[k].nevtypes);
	  sprintf(wf->wBuf, "\nStream %s includes event types:", stream_names[k]);
	  wf->DisplayAndFile(wf->wBuf, 2);
	  for (i=0; i < s->streams[k].nevtypes; i++)
		{sprintf(wf->wBuf,"%s,",event_type_names[s->streams[k].event_type[i]]);
		 wf->DisplayAndFile(wf->wBuf, 2);
		}
	 }
}

void pp_data()
{ long i,j,k;
  struct temp_priority_entry	*priptr0, *priptr1;
  struct context_link *clptr;
  if (w.robot == 'A') wf->DisplayAndFile("\n\nStoring PP_Data for Robot A: ", 2);
	 else wf->DisplayAndFile("\n\nStoring Data for Robot B: ", 2);
  pp->not_learning = FALSE;
  if (pp->not_learning)wf->DisplayAndFile("\nPP not learning or planning ", 2);
  pp->t_t_termination  = TRUE;
  pp->path_steps_to_go = -1;
  pp->path_step = -1;
  pp->tt_paths_longer_than_2 = 0;
  pp->tt_paths_longer_than_5 = 0;
  pp->paths_longer_than_2_followed   = 0;
  pp->path_length      = 0;
  pp->marks_seen       = 0;
  pp->highest_reward_getting_association = -1;
  pp->max_nov = MAX_REWARD_NOVELTY;
  pp->reward_rate_threshold = 30;  // but 50% chance of removal 17apr01
  for (i=0; i<MAX_A_CLUSTERS; i++)
    {pp->maxnodeA[i] = MAX_NODES_A;    // defaults
     pp->maxpredA[i] = MAX_PREDICTIONS_A;
     pp->maxprobA[i] = MAX_POINTER_PROBS;
     pp->maxbkptA[i] = MAX_BACK_POINTERS;
    }
  for (i=0; i<MAX_S_CLUSTERS; i++)
    {pp->maxnodeS[i] = MAX_NODES_S;    // defaults
     pp->maxpredS[i] = MAX_PREDICTIONS_S;
    }
// Insert default overrides here.
  pp->maxnodeS[CLPR] = 350;
  pp->maxpredS[CLPR] = 400;
  pp->maxnodeS[CLSS] = 200;
  pp->maxpredS[CLSS] = 1000;
  pp->maxnodeS[CLDE] = 3000;
  pp->maxpredS[CLDE] = 4000;
  for (i=0; i<MAX_REWARDED_PLANS; i++) pp->rewarded_plans[i] = 0;
  for (i=0; i<MAX_REWARD_GETTING_ASSOCIATIONS; i++) pp->rgass[i].node = NULLNODE;
  for (i=0; i<LKBK_LISTS_LENGTH; i++) pp->node_register[i] = FALSE;
  pp->last_rewarded_plan_number = 0;           // 20dec99
  pp->lkbck_counter  = 0;
  pp->nodes_displayed = 0;
  pp->lkbkst.level = 0;
  pp->lkbkst.actvel = 0;
  pp->lkbkst.endactel = 0;
  pp->lkbkst.emptyel = 0;
  pp->lkbkst.lkbkcl = 0;
  s->touch_evty.event = get_feeling_event();  // To prime robot A.

//  Define Templates  - most critical events put first to speed checking

// ["BE", "CH", {WIDE,1 FOVEA,1 DIRECTION,1 TOUCH,1 PROPRIOCEP,1 HEARFO,1} >>{BODYEYE,0}]
  pp->templates[BE].kindofpred = CHOICE;
  pp->templates[BE].eventdef[0] = reg_type_delay(WIDE,1);
  pp->templates[BE].eventdef[1] = reg_type_delay(FOVEA,1);
  pp->templates[BE].eventdef[2] = reg_type_delay(DIRECTION,1);
  pp->templates[BE].eventdef[3] = reg_type_delay(TOUCH,1);
  pp->templates[BE].eventdef[4] = reg_type_delay(PROPRIOCEP,1);
  pp->templates[BE].eventdef[5] = reg_type_delay(HEARFO,1);
  pp->templates[BE].eventdeftype[0]  = WIDE;
  pp->templates[BE].eventdefdelay[0] = 1;   // 1 	  delay
  pp->templates[BE].eventdeftype[1]  = FOVEA;
  pp->templates[BE].eventdefdelay[1] = 1;   // 1 	  delay
  pp->templates[BE].eventdeftype[2]  = DIRECTION;
  pp->templates[BE].eventdefdelay[2] = 1;   // 1 	  delay
  pp->templates[BE].eventdeftype[3]  = TOUCH;
  pp->templates[BE].eventdefdelay[3] = 1;   // 1 	  delay
  pp->templates[BE].eventdeftype[4]  = PROPRIOCEP;
  pp->templates[BE].eventdefdelay[4] = 1;   // 1 	  delay
  pp->templates[BE].eventdeftype[5]  = HEARFO;
  pp->templates[BE].eventdefdelay[5] = 1;   // 1 	  delay
  pp->templates[BE].noEvTypesInContext = 6;    // number of event-types in context
  pp->templates[BE].predict_event_type[0] = BODYEYE; // first pred event
  pp->templates[BE].acst = s->events[BODYEYE].acst;  // first pred event is AC
  pp->templates[BE].npreds = 1;                // number of pred event-types

// ["SA", "CH", {WIDE,1 FOVEA,1 DIRECTION,1 TOUCH,1 PROPRIOCEP,1 BODYMOVE,0} >>{SAY,0}]
  pp->templates[SA].kindofpred = CHOICE;
  pp->templates[SA].eventdef[0] = reg_type_delay(WIDE,1);
  pp->templates[SA].eventdef[1] = reg_type_delay(FOVEA,1);
  pp->templates[SA].eventdef[2] = reg_type_delay(DIRECTION,1);
  pp->templates[SA].eventdef[3] = reg_type_delay(TOUCH,1);
  pp->templates[SA].eventdef[4] = reg_type_delay(PROPRIOCEP,1);
  pp->templates[SA].eventdef[5] = reg_type_delay(BODYMOVE,0);
  pp->templates[SA].eventdeftype[0]  = WIDE;
  pp->templates[SA].eventdefdelay[0] = 1;   // 1 	  delay
  pp->templates[SA].eventdeftype[1]  = FOVEA;
  pp->templates[SA].eventdefdelay[1] = 1;   // 1 	  delay
  pp->templates[SA].eventdeftype[2]  = DIRECTION;
  pp->templates[SA].eventdefdelay[2] = 1;   // 1 	  delay
  pp->templates[SA].eventdeftype[3]  = TOUCH;
  pp->templates[SA].eventdefdelay[3] = 1;   // 1 	  delay
  pp->templates[SA].eventdeftype[4]  = PROPRIOCEP;
  pp->templates[SA].eventdefdelay[4] = 1;   // 1 	  delay
  pp->templates[SA].eventdeftype[5]  = BODYMOVE;
  pp->templates[SA].eventdefdelay[5] = 0;   // 0 	  delay
  pp->templates[SA].noEvTypesInContext = 6; // number of event-types in context
  pp->templates[SA].predict_event_type[0] = SAY; // first pred event
  pp->templates[SA].acst = s->events[SAY].acst;  // first pred event is AC
  pp->templates[SA].npreds = 1;                // number of pred event-types


// [ "TCH", "CH", {WIDE,1 FOVEA,1 TOUCH,1 BODYMOVE,0} >> {TOUCH,0}]
  pp->templates[TCH].kindofpred = CHOICE;
  pp->templates[TCH].eventdef[0] = reg_type_delay(WIDE,1);
  pp->templates[TCH].eventdef[1] = reg_type_delay(FOVEA,1);
  pp->templates[TCH].eventdef[2] = reg_type_delay(TOUCH,1);
  pp->templates[TCH].eventdef[3] = reg_type_delay(BODYMOVE,0);
  pp->templates[TCH].eventdeftype[0]  = WIDE;
  pp->templates[TCH].eventdefdelay[0] = 1;   // 1    delay
  pp->templates[TCH].eventdeftype[1]  = FOVEA;
  pp->templates[TCH].eventdefdelay[1] = 1;   // 1    delay
  pp->templates[TCH].eventdeftype[2]  = TOUCH;
  pp->templates[TCH].eventdefdelay[2] = 1;   // 1    delay
  pp->templates[TCH].eventdeftype[3]  = BODYMOVE;
  pp->templates[TCH].eventdefdelay[3] = 0;   // 0 	  delay
  pp->templates[TCH].noEvTypesInContext = 4;    // number of event-types in context
  pp->templates[TCH].predict_event_type[0] = TOUCH; // first pred event
  pp->templates[TCH].acst = s->events[TOUCH].acst;  // first pred event is AC
  pp->templates[TCH].npreds = 1;                 // number of pred event-types


// [ "PR", "CH", {PROPRIOCEP,1  BODYEYE,0} >> {PROPRIOCEP,0}]
  pp->templates[PR].kindofpred = CHOICE;
  pp->templates[PR].eventdef[0] = reg_type_delay(PROPRIOCEP,1);
  pp->templates[PR].eventdef[1] = reg_type_delay(BODYEYE,0);
  pp->templates[PR].eventdeftype[0]  = PROPRIOCEP;
  pp->templates[PR].eventdefdelay[0] = 1;   // 1    delay
  pp->templates[PR].eventdeftype[1]  = BODYEYE;
  pp->templates[PR].eventdefdelay[1] = 0;   // 0 	  delay
  pp->templates[PR].noEvTypesInContext = 2;    // number of event-types in context
  pp->templates[PR].predict_event_type[0] = PROPRIOCEP; // first pred event
  pp->templates[PR].acst = s->events[PROPRIOCEP].acst;  // first pred event is AC
  pp->templates[PR].npreds = 1;                 // number of pred event-types

// ["F", "CH", {WIDE,1 FOVEA,1 DIRECTION,1 TOUCH,1 BODYEYE,0} >> {FOVEA,0}]
  pp->templates[F].kindofpred = CHOICE;
  pp->templates[F].eventdef[0] = reg_type_delay(WIDE,1);
  pp->templates[F].eventdef[1] = reg_type_delay(FOVEA,1);
  pp->templates[F].eventdef[2] = reg_type_delay(DIRECTION,1);
  pp->templates[F].eventdef[3] = reg_type_delay(TOUCH,1);
  pp->templates[F].eventdef[4] = reg_type_delay(BODYEYE,0);
  pp->templates[F].eventdeftype[0]  = WIDE;
  pp->templates[F].eventdefdelay[0] = 1;   // 1    delay
  pp->templates[F].eventdeftype[1]  = FOVEA;
  pp->templates[F].eventdefdelay[1] = 1;   // 1    delay
  pp->templates[F].eventdeftype[2]  = DIRECTION;
  pp->templates[F].eventdefdelay[2] = 1;   // 1 	  delay
  pp->templates[F].eventdeftype[3]  = TOUCH;
  pp->templates[F].eventdefdelay[3] = 1;   // 1 	  delay
  pp->templates[F].eventdeftype[4]  = BODYEYE;
  pp->templates[F].eventdefdelay[4] = 0;   // 0 	  delay
  pp->templates[F].noEvTypesInContext = 5;    // number of event-types in context
  pp->templates[F].predict_event_type[0] = FOVEA; // first pred event
  pp->templates[F].acst = s->events[FOVEA].acst;  // first pred event is AC
  pp->templates[F].npreds = 1;                 // number of pred event-types


// ["W", "CH", {WIDE,1 FOVEA,1  DIRECTION,1 TOUCH,1 BODYEYE,0} >> {WIDE,0}]
  pp->templates[W].kindofpred = CHOICE;
  pp->templates[W].eventdef[0] = reg_type_delay(WIDE,1);
  pp->templates[W].eventdef[1] = reg_type_delay(FOVEA,1);  // added 4aug00
  pp->templates[W].eventdef[2] = reg_type_delay(DIRECTION,1);
  pp->templates[W].eventdef[3] = reg_type_delay(TOUCH,1);
  pp->templates[W].eventdef[4] = reg_type_delay(BODYEYE,0);
  pp->templates[W].eventdeftype[0]  = WIDE;
  pp->templates[W].eventdefdelay[0] = 1;   // 1    delay
  pp->templates[W].eventdeftype[1]  = FOVEA;
  pp->templates[W].eventdefdelay[1] = 1;   // 1    delay
  pp->templates[W].eventdeftype[2]  = DIRECTION;
  pp->templates[W].eventdefdelay[2] = 1;   // 1 	delay
  pp->templates[W].eventdeftype[3]  = TOUCH;
  pp->templates[W].eventdefdelay[3] = 1;   // 1 	delay
  pp->templates[W].eventdeftype[4]  = BODYEYE;
  pp->templates[W].eventdefdelay[4] = 0;   // 0 	delay
  pp->templates[W].noEvTypesInContext = 5;    // number of event-types in context
  pp->templates[W].predict_event_type[0] = WIDE; // first pred event
  pp->templates[W].acst = s->events[WIDE].acst;  // first pred event is AC
  pp->templates[W].npreds = 1;                 // number of pred event-types


// ["DN", "CH", {WIDE,1  FOVEA,1  DIRECTION,1 TOUCH,1 BODYMOVE,0} >> {DIRECTION,0}]
  pp->templates[DN].kindofpred = CHOICE;
  pp->templates[DN].eventdef[0] = reg_type_delay(WIDE,1);
  pp->templates[DN].eventdef[1] = reg_type_delay(FOVEA,1);
  pp->templates[DN].eventdef[2] = reg_type_delay(DIRECTION,1);
  pp->templates[DN].eventdef[3] = reg_type_delay(TOUCH,1);
  pp->templates[DN].eventdef[4] = reg_type_delay(BODYMOVE,0);
  pp->templates[DN].eventdeftype[0]  = WIDE;
  pp->templates[DN].eventdefdelay[0] = 1;   // 1 	delay
  pp->templates[DN].eventdeftype[1]  = FOVEA;
  pp->templates[DN].eventdefdelay[1] = 1;   // 1 	delay
  pp->templates[DN].eventdeftype[2]  = DIRECTION;
  pp->templates[DN].eventdefdelay[2] = 1;   // 1 	delay
  pp->templates[DN].eventdeftype[3]  = TOUCH;
  pp->templates[DN].eventdefdelay[3] = 1;   // 1 	delay
  pp->templates[DN].eventdeftype[4]  = BODYMOVE;
  pp->templates[DN].eventdefdelay[4] = 0;   // 0 	delay
  pp->templates[DN].noEvTypesInContext = 5;    // number of event-types in context
  pp->templates[DN].predict_event_type[0] = DIRECTION; // first pred event
  pp->templates[DN].acst = s->events[DIRECTION].acst;  // first pred event is AC
  pp->templates[DN].npreds = 1;                 // number of pred event-types

// Upper level template designed to capture A's telling B what action to do.
// ["DNU", "CH", {SAY,0  DESIRE,1  DIRECTION,1 BODYMOVE,0} >> {DIRECTION,0}]
  pp->templates[DNU].kindofpred = CHOICE;
  pp->templates[DNU].eventdef[0] = reg_type_delay(SAY,0);
  pp->templates[DNU].eventdef[1] = reg_type_delay(DESIRE,1);
  pp->templates[DNU].eventdef[2] = reg_type_delay(DIRECTION,1);
  pp->templates[DNU].eventdef[3] = reg_type_delay(BODYMOVE,0);
  pp->templates[DNU].eventdeftype[0]  = SAY;
  pp->templates[DNU].eventdefdelay[0] = 0;   // 0 	delay
  pp->templates[DNU].eventdeftype[1]  = DESIRE;
  pp->templates[DNU].eventdefdelay[1] = 1;   // 1 	delay
  pp->templates[DNU].eventdeftype[2]  = DIRECTION;
  pp->templates[DNU].eventdefdelay[2] = 1;   // 1 	delay
  pp->templates[DNU].eventdeftype[3]  = BODYMOVE;
  pp->templates[DNU].eventdefdelay[3] = 0;   // 0 	delay
  pp->templates[DNU].noEvTypesInContext = 4;    // number of event-types in context
  pp->templates[DNU].predict_event_type[0] = DIRECTION; // first pred event
  pp->templates[DNU].acst = s->events[DIRECTION].acst;  // first pred event is AC
  pp->templates[DNU].npreds = 1;                 // number of pred event-types

// ["SS", "CH", {HEAR,1 SAY,0} >>{HEAR,0}]
  pp->templates[SS].kindofpred = CHOICE;
  pp->templates[SS].eventdef[0] = reg_type_delay(HEAR,1);
  pp->templates[SS].eventdef[1] = reg_type_delay(SAY,0);
  pp->templates[SS].eventdeftype[0]  = HEAR;
  pp->templates[SS].eventdefdelay[0] = 1;   // 1 	  delay
  pp->templates[SS].eventdeftype[1]  = SAY;
  pp->templates[SS].eventdefdelay[1] = 0;   // 0 	  delay
  pp->templates[SS].noEvTypesInContext = 2;    // number of event-types in context
  pp->templates[SS].predict_event_type[0] = HEAR; // first pred event
  pp->templates[SS].acst = s->events[HEAR].acst;  // first pred event is ST
  pp->templates[SS].npreds = 1;                // number of pred event-types

// ["DE", "CH", {TOUCH,1  DESIRE,1 BODYMOVE,0} >>{DESIRE,0}]
  pp->templates[DE].kindofpred = CHOICE;
  pp->templates[DE].eventdef[0] = reg_type_delay(TOUCH,1);
  pp->templates[DE].eventdef[1] = reg_type_delay(DESIRE,1);
  pp->templates[DE].eventdef[2] = reg_type_delay(BODYMOVE,0);
  pp->templates[DE].eventdeftype[0]  = TOUCH;
  pp->templates[DE].eventdefdelay[0] = 1;   // 1 	  delay
  pp->templates[DE].eventdeftype[1]  = DESIRE;
  pp->templates[DE].eventdefdelay[1] = 1;   // 1 	  delay
  pp->templates[DE].eventdeftype[2]  = BODYMOVE;
  pp->templates[DE].eventdefdelay[2] = 0;   // 0 	delay
  pp->templates[DE].noEvTypesInContext = 3;  // number of event-types in context
  pp->templates[DE].predict_event_type[0] = DESIRE; // first pred event
  pp->templates[DE].acst = s->events[DESIRE].acst;  // first pred event is AC
  pp->templates[DE].npreds = 1;                // number of pred event-types

  i=0;
  while ( strcmp(template_names[i],"NOTEMP") ) i++;  // 0 if same!
  pp->ntemplates = i;				// Works out number of templates
  sprintf(wf->wBuf, "\nThere are %d templates. ", i);
  wf->DisplayAndFile(wf->wBuf, 2);
  for (i=0; i < pp->ntemplates;i++)
	  {pp->templates[i].base = NULLNODE;
		strcpy( pp->templates[i].tname, template_names[i] );
		if ( pp->templates[i].noEvTypesInContext > MAX_CONTEXT_EVENTS )
		  error("Increase MAX_CONTEXT_EVENTS to %d ",
												pp->templates[i].noEvTypesInContext);
		if ( pp->templates[i].npreds > MAX_TEMP_PREDICTION_TYPES )
		  error("Increase MAX_TEMP_PREDICTION_TYPES to %d ",
												pp->templates[i].npreds);
		sprintf(wf->wBuf,"\nTemplate(%d)%s %s:", i,pp->templates[i].tname,
							kindofpred_string[pp->templates[i].kindofpred]);
		wf->DisplayAndFile(wf->wBuf, 2);
		for (j=0; j < pp->templates[i].noEvTypesInContext; j++)
			display_type_and_shift(pp->templates[i].eventdef[j]);
		wf->DisplayAndFile("\n  >>", 2);
		for (j=0; j < pp->templates[i].npreds; j++)
			{sprintf(wf->wBuf, " %s",
						  event_type_names[pp->templates[i].predict_event_type[j]]);
			 wf->DisplayAndFile(wf->wBuf, 2);
			}
	  }
  if (pp->ntemplates > MAX_TEMPLATES)
	 error("Increase MAX_TEMPLATES to ", pp->ntemplates);

  pp->null_choiceA.event.event = NULLEVENT;
  pp->null_choiceA.event.type  = NULLTYPE;
  pp->null_choiceA.worth = 0;
  pp->null_choiceA.age_worth = 0;
  pp->null_choiceA.chnodesA[0].node = NULLNODE;
  pp->null_choiceS.event.event = NULLEVENT;
  pp->null_choiceS.event.type  = NULLTYPE;
  pp->null_choiceS.age_worth = 0;
  pp->null_choiceS.chnodesS[0].node = NULLNODE;

  for (k=0; k < s->nastreams; k++)
	 {//pp->choice_listsA[k] = *new choice_listA;
	  for (i=0; i<MAX_CHOICES; i++)
		  {//pp->choice_listsA[k].charray[i] = new choice_A;
			pp->choice_listsA[k].charray[i].event.event = NULLEVENT;
			pp->choice_listsA[k].charray[i].event.type  = NULLTYPE;
			for (j=0; j<MAX_NODES_PER_CHOICE; j++)
			  pp->choice_listsA[k].charray[i].chnodesA[j].node = NULLNODE;
		  }
	  pp->best_predictionsA[k].worth = NULLWORTH;
	  pp->best_predictionsA[k].event.type = NULLTYPE;
	  pp->best_predictionsA[k].event.event = NULLEVENT;
	  for (j=0; j<MAX_NODES_PER_CHOICE; j++)
		  pp->best_predictionsA[k].chnodesA[j].node = NULLNODE;
	 }
  for (k=0; k < s->nstreams; k++) // not nsstreams until a&s streams separated.
	 {//pp->choice_listsS[k] = *new choice_listS;
	  for (i=0; i<MAX_CHOICES; i++)
		  {//pp->choice_listsS[k].charray[i] = new choice_S;
			pp->choice_listsS[k].charray[i].event.event = NULLEVENT;
			pp->choice_listsS[k].charray[i].event.type  = NULLTYPE;
			for (j=0; j<MAX_NODES_PER_CHOICE; j++)
			  pp->choice_listsS[k].charray[i].chnodesS[j].node = NULLNODE;
		  }
//	  pp->best_predictionsS[k].worth = NULLWORTH;
	  pp->best_predictionsS[k].event.type = NULLTYPE;
	  pp->best_predictionsS[k].event.event = NULLEVENT;
	  for (j=0; j<MAX_NODES_PER_CHOICE; j++)
		  pp->best_predictionsS[k].chnodesS[j].node = NULLNODE;
	 }

// #define_ac_priority [] = {"[(BE)]" "[(SA)]"]"}
  priptr0 = s->streams[BESTR].template_priority = new struct temp_priority_entry;
  if (!priptr0) error("No space for temp_priority_entry.");
  priptr0->temp = BE;		   // template "BE"
  priptr0->match = priptr0->nomatch = NULL;
  priptr0 = s->streams[SASTR].template_priority = new struct temp_priority_entry;
  if (!priptr0) error("No space for temp_priority_entry.");
  priptr0->temp = SA;		   // template "SA"
  priptr0->match = priptr0->nomatch = NULL;
// #define_st_priority [] = {{"[(TCH)]"}{"[(PR)]"}{"[(F)]"}{"[(W)]"}}
  priptr0 = s->streams[TCHSTR].template_priority = new struct temp_priority_entry;
  if (!priptr0) error("No space for temp_priority_entry.");
  priptr0->temp = TCH;		// template "PR"
  priptr0->match = priptr0->nomatch = NULL;
  priptr0 = s->streams[PROPSTR].template_priority = new struct temp_priority_entry;
  if (!priptr0) error("No space for temp_priority_entry.");
  priptr0->temp = PR;		// template "PR"
  priptr0->match = priptr0->nomatch = NULL;
  priptr0 = s->streams[FOVSTR].template_priority = new struct temp_priority_entry;
  if (!priptr0) error("No space for temp_priority_entry.");
  priptr0->temp = F;  	// template "F"
  priptr0->match = priptr0->nomatch = NULL;
  priptr0 = s->streams[WIDESTR].template_priority = new struct temp_priority_entry;
  if (!priptr0) error("No space for temp_priority_entry.");
  priptr0->temp = W;    // template "W"
  priptr0->match = priptr0->nomatch = NULL;
  priptr0 = s->streams[DIRNSTR].template_priority = new struct temp_priority_entry;
  if (!priptr0) error("No space for temp_priority_entry.");
  priptr0->temp = DN;		// template "DN"
  priptr0->match = priptr0->nomatch = priptr1 = new struct temp_priority_entry;
  priptr1->temp = DNU;		// template "DNU       // Use DNU even if DN fails.
  priptr1->match = priptr1->nomatch = NULL;
  priptr0 = s->streams[SSSTR].template_priority = new struct temp_priority_entry;
  if (!priptr0) error("No space for temp_priority_entry.");
  priptr0->temp = SS;		   // template "SS"
  priptr0->match = priptr0->nomatch = NULL;
  priptr0 = s->streams[DESTR].template_priority = new struct temp_priority_entry;
  if (!priptr0) error("No space for temp_priority_entry.");
  priptr0->temp = DE;		   // template "DE"
  priptr0->match = priptr0->nomatch = NULL;
  for (i=0; i < s->nstreams; i++ )
	  {priptr0 = s->streams[i].template_priority;
		 if ( priptr0 )
			{sprintf(wf->wBuf, "\nPriority of templates for Stream %d:\n 0,%s",
								 i, pp->templates[priptr0->temp].tname);
			 wf->DisplayAndFile(wf->wBuf, 2);
			 display_priority(priptr0, 1, "\t");
			}
		 else
			{sprintf(wf->wBuf, "\nNo Priority of templates for Stream %d:\n 0,%s",
								 i, pp->templates[priptr0->temp].tname);
				 wf->DisplayAndFile(wf->wBuf, 2);
			}
	  }

//			    {{"BE"}
//               {"SA"}
//               {"PR"}
//				 {"F"}
//               {"W"}
//               {"DN"}
//               {"SS"}};
  pp->clustersA[CLBE].ntemps  = 1;
  pp->clustersA[CLBE].tem[0]  = BE;    // "BE"
  pp->clustersA[CLSA].ntemps  = 1;
  pp->clustersA[CLSA].tem[0]  = SA;    // "SA"
  pp->naclusters = 2;
  i = 0;
  while ( strcmp(cluster_namesA[i],"NOCLUSTERA") ) i++;  // 0 if same!
	if (pp->naclusters != i) error("Total Number of ClustersA Should Be ", i);
  sprintf(wf->wBuf, "\nThere are %d clustersA. ", i);
  if (pp->naclusters > MAX_A_CLUSTERS)
	 error("Increase MAX_A_CLUSTERS to ", pp->naclusters);
  wf->DisplayAndFile(wf->wBuf, 2);
  pp->clustersS[CLTCH].ntemps = 1;
  pp->clustersS[CLTCH].tem[0] = TCH;  // "TCH"
  pp->clustersS[CLPR].ntemps  = 1;
  pp->clustersS[CLPR].tem[0]  = PR;   // "PR"
  pp->clustersS[CLF].ntemps   = 1;
  pp->clustersS[CLF].tem[0]   = F;	  // "F"
  pp->clustersS[CLW].ntemps   = 1;
  pp->clustersS[CLW].tem[0]   = W;	  // "W"
  pp->clustersS[CLDN].ntemps  = 1;
  pp->clustersS[CLDN].tem[0]  = DN;   // "DN"
  pp->clustersS[CLDNU].ntemps = 1;
  pp->clustersS[CLDNU].tem[0] = DNU;  // "DNU"
  pp->clustersS[CLSS].ntemps  = 1;
  pp->clustersS[CLSS].tem[0]  = SS;   // "SS"
  pp->clustersS[CLDE].ntemps  = 1;
  pp->clustersS[CLDE].tem[0]  = DE;   // "DE"
  pp->nsclusters = 8;
  i = 0;                  // 9may00
  while ( strcmp(cluster_namesS[i],"NOCLUSTERS") ) i++;  // 0 if same!
	if (pp->nsclusters != i) error("Total Number of ClustersS Should Be ", i);
  sprintf(wf->wBuf, "\nThere are %d clustersS. ", i);
  wf->DisplayAndFile(wf->wBuf, 2);
  if (pp->nsclusters > MAX_S_CLUSTERS)
	 error("Increase MAX_S_CLUSTERS to ", pp->nsclusters);
  pp->nclusters = pp->naclusters + pp->nsclusters;
  if (pp->nclusters > MAX_CLUSTERS)
	 error("Increase MAX_CLUSTERS to ", pp->nclusters);

  for (j=0; j < pp->naclusters; j++)        // to replace clust_from_temp
	 {strcpy(pp->clustersA[j].cname, cluster_namesA[j]);
	  pp->clustersA[j].last_node = NULLNODE;
	  pp->clustersA[j].highest_node = NULLNODE;
	  pp->clustersA[j].empty_assA_list = 0; // Empty list points to first
	  pp->clustersA[j].empty_prdA_list = 0; // Empty list points to first
	  pp->clustersA[j].empty_pprb_list = 0; // Empty list points to first
	  pp->clustersA[j].empty_bkptr_list = 0; // Empty list points to first
	  pp->clustersA[j].last_event.type = NULLTYPE;
	  pp->clustersA[j].last_event.event = NULLEVENT;
	  pp->clustersA[j].leakback_cluster_no = -1;
	  if (pp->clustersA[j].ntemps > MAX_TEMPS_IN_CLUSTER)
		 error("Increase MAX_TEMPS_IN_CLUSTER to number in ", j);
	  sprintf(wf->wBuf, "\nClusterA %s includes templates ", cluster_namesA[j]);
	  wf->DisplayAndFile(wf->wBuf, 2);
	  for (k=0; k < pp->clustersA[j].ntemps; k++)
		 {i = pp->clustersA[j].tem[k];
		  pp->templates[i].clust = j;
		  sprintf(wf->wBuf, " %s", pp->templates[i].tname);
		  wf->DisplayAndFile(wf->wBuf, 2);
		 }
      pp->clustersA[j].empty_ctxtA_list = 0;  // All context links on empty list
      for (k=0; k < MAX_CONTEXT_LINKS_A; k++)
	     {clptr = &pp->clustersA[j].ctxtA[k];
		  clptr->event.event = NULLEVENT;
		  clptr->event.type = NULLTYPE;
		  clptr->next_list = NULLLONG;
		  clptr->linkbk = NULLLONG;
		  clptr->next = k+1;
		  if (k == (MAX_CONTEXT_LINKS_A - 1)) clptr->next = NULLLONG;
		 }
	  for (k=0; k < MAX_NODES_A; k++)
		 {pp->clustersA[j].assA[k].cntxt_no = k;
		  pp->clustersA[j].assA[k].pei      = NULLLONG;
		  pp->clustersA[j].assA[k].back     = NULLLONG;
		  pp->clustersA[j].assA[k].step_last_used = NULLSTEP; // Shows it's on empty list
		  pp->clustersA[j].assA[k].next     = k+1;  // Last one overwritten below
		 }
	  pp->clustersA[j].assA[pp->maxnodeA[j] - 1].next = NULLNODE; // End empty list
	  for (k=0; k < MAX_PREDICTIONS_A; k++)
		 {pp->clustersA[j].prdA[k].mark = NULLMARK;
		  pp->clustersA[j].prdA[k].event.event = NULLEVENT;
		  pp->clustersA[j].prdA[k].ptr_prob = NULLNODE;
		  pp->clustersA[j].prdA[k].next     = k+1;
		 }
	  pp->clustersA[j].prdA[pp->maxpredA[j] - 1].next = NULLLONG; // End empty list
	  for (k=0; k < MAX_POINTER_PROBS; k++)
		 {pp->clustersA[j].pprb[k].node = NULLNODE;
		  pp->clustersA[j].pprb[k].prob = 0;
		  pp->clustersA[j].pprb[k].next = k+1;
		 }
	  pp->clustersA[j].pprb[pp->maxprobA[j] - 1].next = NULLLONG; // End empty list
      for (k=0; k < MAX_BACK_POINTERS; k++)
         {pp->clustersA[j].bptr[k].node = NULLNODE;
          pp->clustersA[j].bptr[k].next = k+1;      // Last one overwritten below
         }
	  pp->clustersA[j].bptr[pp->maxbkptA[j] - 1].next = NULLLONG;
      for (k=0; k < MAX_MARKS_A; k++)
         pp->clustersA[j].marksA[k] = NULLNODE;
	 }
  for (j=0; j < pp->nsclusters; j++)        // to replace clust_from_temp
	  {strcpy(pp->clustersS[j].cname, cluster_namesS[j]);
		pp->clustersS[j].last_node = NULLNODE;
		pp->clustersS[j].highest_node = NULLNODE;
		pp->clustersS[j].empty_assS_list = 0; // Empty list points to first
		pp->clustersS[j].empty_prdS_list = 0; // Empty list points to first
		pp->clustersS[j].last_event.type = NULLTYPE;
		pp->clustersS[j].last_event.event = NULLEVENT;
		if (pp->clustersS[j].ntemps > MAX_TEMPS_IN_CLUSTER)
		  error("Increase MAX_TEMPS_IN_CLUSTER to number in ", j);
		sprintf(wf->wBuf, "\nClusterS %s includes templates ", cluster_namesS[j]);
		wf->DisplayAndFile(wf->wBuf, 2);
		for (k=0; k < pp->clustersS[j].ntemps; k++)
			{i = pp->clustersS[j].tem[k];
			 pp->templates[i].clust = j;
			 sprintf(wf->wBuf, " %s", pp->templates[i].tname);
			 wf->DisplayAndFile(wf->wBuf, 2);
			}
    pp->clustersS[j].empty_ctxtS_list = 0;  // All context links on empty list
    for (k=0; k < MAX_CONTEXT_LINKS_S; k++)
	    {clptr = &pp->clustersS[j].ctxtS[k];
		   clptr->event.event = NULLEVENT;
		   clptr->event.type = NULLTYPE;
		   clptr->next_list = NULLLONG;
			 clptr->linkbk = NULLLONG;
			 clptr->next = k+1;
			 if (k == (MAX_CONTEXT_LINKS_S - 1)) clptr->next = NULLLONG;
			}
		for (k=0; k < MAX_NODES_S; k++)
			{pp->clustersS[j].assS[k].cntxt_no = k;
			 pp->clustersS[j].assS[k].pei      = NULLLONG;
       pp->clustersS[j].assS[k].step_last_used = NULLSTEP; // Shows it's on empty list
 			 pp->clustersS[j].assS[k].next     = k+1;  // Last one overwritten below
			}
		pp->clustersS[j].assS[pp->maxnodeS[j] - 1].next = NULLNODE; // End empty list
		for (k=0; k < MAX_PREDICTIONS_S; k++)
			{pp->clustersS[j].prdS[k].event.event = NULLEVENT;
			 pp->clustersS[j].prdS[k].next     = k+1;    // Last one overwritten
			}
		pp->clustersS[j].prdS[pp->maxpredS[j] - 1].next = NULLLONG; // End empty list
	  }
  pp->clustersA[CLBE].leakback_cluster_no = 0;  // cluster 0 is lkbk cluster 0
  pp->leakback_clusters[0].clusterA = CLBE;		// "ClBE"
  pp->clustersA[CLSA].leakback_cluster_no = 1;  // cluster 1 is lkbk cluster 0
  pp->leakback_clusters[1].clusterA = CLSA;		// "ClSA"
  pp->nlkbckclstrs = 2;
  wf->DisplayAndFile("\nLeakback clusters are ", 2);
  for (i=0; i < pp->nlkbckclstrs; i++)
	  {for (k=0; k<LKBK_LISTS_LENGTH; k++)
		  pp->leakback_clusters[i].lkbk_list[k] = NULLNODE; //No clustersS equivt
		sprintf(wf->wBuf," %s",cluster_namesA[pp->leakback_clusters[i].clusterA]);
		wf->DisplayAndFile(wf->wBuf, 2);
		pp->leakback_clusters[i].emptyel = 0;  // set empty element pointer to 0.

	  }
// set is_in_leakback_cluster flag in each template.    21apr99
  pp->leak_back_clusters[0] = CLBE;
  pp->leak_back_clusters[1] = CLSA;
  for (j=0; j < pp->ntemplates; j++)
	 pp->templates[j].is_in_leakback_cluster = 0;   // no for all
  for (j=0; j < pp->nlkbckclstrs; j++)
	  {i = pp->leak_back_clusters[j];
		for (k=0; k < pp->clustersA[i].ntemps; k++)      // yes for some
		  pp->templates[pp->clustersA[i].tem[k]].is_in_leakback_cluster = 1;
	  }
// hold_info has not been initialized. <<<<
}

void swap_robot()
{ if ( w.robot == 'A')
	 {w.robot = 'B'; sa = s; s = sb;
	  wf->DisplayAndFile("\n=== Robot B", 0);
	 }
  else
	 {w.robot = 'A'; sb = s; s = sa;
	  wf->DisplayAndFile("\n=== Robot A", 0);
	 }
}

void new_step_HN()
{ char datebuf[10], timebuf[10];
  short i, rewds;
  s->step++;
  if ( (w.robot == 'A') && !(s->step%w.change_file_step) )
	{wf->mainFileCount++;
	 if (!(s->step%w.step_cycle_before_counters_zeroed))
		w.number_step_cycles++;
	 if ((!(w.jumping)) || (!(w.min_file_record_while_jumping))
							  || ((!(s->step%w.step_cycle_before_counters_zeroed))
					  && (w.number_step_cycles == w.m_step_cycles[w.m_file_line])))
		{wf->CopyBigBufToFile(); // clears out buffer before changing file
		 wf->ChangeMainFile();   // <<<<<< CHANGE TO NEW FILE
		 sprintf(wf->wBuf, "\nNew file %s\n    on %s at %s",
						  wf->File->Main, _strdate(datebuf), _strtime(timebuf));
		 wf->DisplayAndFile(wf->wBuf, 0);
		}
	 }
  if ((s->drive & w.food) && (w.current_goal == ULONG_O))
	  s->steps_with_f_drive_and_O++;
  if ((s->drive & w.drink) && (w.current_goal == ULONG_Q))
	  s->steps_with_d_drive_and_Q++;
  if ((s->resource_f < w.sublevel) || (s->resource_d < w.sublevel))
	  s->steps_below_sublevel++;
  s->reward = 0;
  s->disapproval = 0;
  if ( s->boredom_inc == ON )  s->boredom++;
  s->boredom_inc = OFF;
//	  if (!w.jumping) display_board(); //c _and_canvas(); //If jumping, before leakback.
  if (w.robot == 'A')
	{if ((w.jumping) && (w.min_file_record_while_jumping) && (!(w.diag))
					  && ((s->step%w.step_cycle_before_counters_zeroed)
					  || (w.number_step_cycles != w.m_step_cycles[w.m_file_line])))
	  {cout << s->step << endl;
	   w.no_display_or_file = TRUE;  // inhibits all writing to display and file
	  }
	 else
	  {w.no_display_or_file = FALSE;
	   sprintf(wf->wBuf,
	    "\n=>> h+n step %d  Robot A b=%d,f=%d rwd_f/tot=%d/%d rwd_d/tot=%d/%d"
        "\n rwd_gd=%d sub=%d rsc-f/d=%.2f/%.2f npths>5=%d,>2=%d folld%d,jumpStep=%d ",
					s->step, s->boredom, s->frustration,
					s->reward_counter_f, s->steps_with_f_drive_and_O,
					s->reward_counter_d, s->steps_with_d_drive_and_Q,
					s->reward_counter_gd,
                    s->steps_below_sublevel,
                    s->resource_f,  s->resource_d,
					pp->tt_paths_longer_than_5,
					pp->tt_paths_longer_than_2,
					pp->paths_longer_than_2_followed,w.jumpStep);
	   wf->DisplayAndFile(wf->wBuf, 0);
	   sprintf(wf->wBuf,
           "\nRwds A+B=%d,Curr goal=%X,A/Bdrives=%d/%d", // LM-BE-tAge=%d
		           w.reward_count,w.current_goal,s->drive,sb->drive);
	   wf->DisplayAndFile(wf->wBuf, 0);
	  }
	}
  else     // Robot B
	{if (!(w.no_display_or_file))
	  {sprintf(wf->wBuf,
		"\n=>> step %d  Robot B rwd_f/tot=%d/%d rwd_d/tot=%d/%d sub=%d"
        "\n rsc-f/d=%.2f/%.2f noBtells=%d",
		s->step, s->reward_counter_f, s->steps_with_f_drive_and_O,
		s->reward_counter_d,s->steps_with_d_drive_and_Q,s->steps_below_sublevel,
        s->resource_f, s->resource_d, s->number_of_B_tells);
	   wf->DisplayAndFile(wf->wBuf, 0);
	  }
	}
  if ((w.robot == 'A') && (!(s->step%w.step_cycle_before_counters_zeroed))
				 && (w.number_step_cycles == w.m_step_cycles[w.m_file_line]))
	{display_ltm_tree();  // regardless of w.min_file_record_while_jumping
	 display_nodes();     // following items need counts carried out in this
     fill_file_lineA();
	 if (pp->not_learning)wf->DisplayAndFile("\nPP not learning or planning ", 0);
	 wf->DisplayAndFile("\n", 0);
	 wf->CopyBigBufToFile();
	}
  if ((w.robot == 'B') && (!(s->step%w.step_cycle_before_counters_zeroed))
				 && (w.number_step_cycles == w.m_step_cycles[w.m_file_line]))
	{fill_file_lineB();
	 display_graph(w.m_file_line);
	 wf->CopyBigBufToFile();
	 w.m_file_line++;
	}
// This is done in robot B half-step so that extra graph lines can be displayed
//  just before robot B's half step without robot A's parameters zeroed.
  if ((w.robot == 'B') && (!(s->step%w.step_cycle_before_counters_zeroed)))
	{sa->subsumption_counter = 0;
	 sa->reward_counter_f = 0;
	 sa->reward_counter_d = 0;
	 sa->reward_counter_gd = 0;
	 sa->steps_with_f_drive_and_O = 0;
	 sa->steps_with_d_drive_and_Q = 0;
     sa->number_of_B_tells = 0;
	 sa->steps_below_sublevel = 0;
	 sa->rewards_without_drivefd = 0;
	 s->subsumption_counter = 0;
	 s->reward_counter_f = 0;
	 s->reward_counter_d = 0;
	 s->reward_counter_gd = 0;
	 s->steps_with_f_drive_and_O = 0;
	 s->steps_with_d_drive_and_Q = 0;
     s->number_of_B_tells = 0;
	 s->steps_below_sublevel = 0;
	 s->rewards_without_drivefd = 0;
//	 if (w.robot == 'A')    This will now be done in robot B's half-step.
	 pp->tt_paths_longer_than_5 = 0;
	 pp->tt_paths_longer_than_2 = 0;
	 pp->paths_longer_than_2_followed = 0;
	 if (!w.no_display_or_file) display_plan_steps();
	 for (i=0; i<MAX_REWARDED_PLANS; i++) pp->rewarded_plans[i] = 0;
	 pp->last_rewarded_plan_number = 0;
	 if (!w.no_display_or_file) display_reward_getting_associations();
	 for (i=0; i<pp->highest_reward_getting_association; i++)
		 pp->rgass[i].node = NULLNODE;
	 pp->highest_reward_getting_association = -1;
	}
}

void new_step_TT()
{ s->step++;
  if ((!w.jumping) || (!w.min_file_record_while_jumping))
	{sprintf(wf->wBuf,"\n-->--> t+t step %d",s->step);
	 wf->DisplayAndFile(wf->wBuf, 0);
	}
}

//  *****  Reward
void reward(unsigned long object)
{ switch(object)
	{case ULONG_O :  if (s->drive & w.food)
						{s->reward = w.food;
						 s->reward_counter_f++;
						 wf->DisplayAndFile("\nRewarded for Food ", 0);
						}
					 else
						{if (!(s->drive & w.drink)) s->rewards_without_drivefd++;
							wf->DisplayAndFile("\nFood but not hungry", 0);
						}
					 break;
	 case ULONG_Q :  if (s->drive & w.drink)
						{s->reward = w.drink;
						 s->reward_counter_d++;
						 wf->DisplayAndFile("\nRewarded for Drink ", 0);
						}
					 else
						{if (!(s->drive & w.food)) s->rewards_without_drivefd++;
						    wf->DisplayAndFile("\nDrink but not thirsty", 0);
						}
					 break;
     case ULONG_GD : if (!(s->drive & w.plus))
						{s->reward = w.good;
						 s->reward_counter_gd++;
						 wf->DisplayAndFile("\nRewarded for Good ", 0);
						}
					 else wf->DisplayAndFile("\nNo Good Reward as hungry or thirsty", 0);
					 return; // So as not to add to w.reward_count
	 default : error("\nNot admissible object ", object);
	}
  w.reward_count++;
  if (w.reward_count > w.rewards_between_goal_change)
	 {w.reward_count = 0;
	  if (w.current_goal == ULONG_O) w.current_goal = ULONG_Q;
	  else w.current_goal = ULONG_O;
	 }
}


//  *****  Disapproval
void disapproval()
{ s->disapproval = 1;
  wf->DisplayAndFile("\nDisapproved ", 0);
}

void warning(char *msg)
{wf->DisplayAndFile("\nWARNING!!:", 0); wf->DisplayAndFile(msg, 0);   }

void error(char *msg)
{w.jumping = FALSE;
 wf->CopyBigBufToFile();
 sprintf(wf->wBuf,"\nError!! %s", msg);
 wf->DisplayAndFile(wf->wBuf, 0);
 getch();
 exit(EXIT_FAILURE);
}

void error(char *msg, unsigned long ul)
{w.jumping = FALSE;     // To free display
 wf->CopyBigBufToFile();
 sprintf(wf->wBuf,"\nError!! %s %X", msg, ul);
 wf->DisplayAndFile(wf->wBuf, 0);
 getch();
 exit(EXIT_FAILURE);
}

void error(char *msg, unsigned long ul1, unsigned long ul2)
{w.jumping = FALSE;     // To free display
 wf->CopyBigBufToFile();
 sprintf(wf->wBuf,"\nError!! %s %X %X", msg, ul1, ul2);
 wf->DisplayAndFile(wf->wBuf, 0);
 getch();
 exit(EXIT_FAILURE);
}

void error_dec(char *msg, long lng)
{w.jumping = FALSE;     // To free display
 wf->CopyBigBufToFile();
 sprintf(wf->wBuf,"\nError!! %s %d", msg, lng);
 wf->DisplayAndFile(wf->wBuf, 0);
 getch();
 exit(EXIT_FAILURE);
}

void error_2dec(char *msg, long lng1, long lng2)
{w.jumping = FALSE;     // To free display
 wf->CopyBigBufToFile();
 sprintf(wf->wBuf,"\nError!! %s %d %d ", msg, lng1, lng2);
 wf->DisplayAndFile(wf->wBuf, 0);
 getch();
 exit(EXIT_FAILURE);
}

