// ppfuncs.hpp  PURRPUSS  Dev.from C.B.Gunn 22/4/93   jha:12aug98-26jly01

//           FUNCTION DEFINITIONS FOR THE PURRPUSS PROGRAM.

#ifndef	_PPFUNCS_H
	#define	_PPFUNCS_H
#include "c:\Program Files\Borland\CBuilder3\examples\foodrink\ppheader.hpp"

const short 	FILELEN = 75;  //  length of buffer needed for file name
const short	OVERBUFFERLENGTH = 5000;    // 1200;
const short	MAXCHOICES = 20;

// **********   ppaction.cpp   **********
void              get_stimuli_HN();
void              get_stimuli_TT();
unsigned long get_stimulus_from_world(short type);
void              get_actions_HN();
void              get_actions_TT();

//  **********	 ppcycle.cpp    **********
void world_data();
void FileOnly_world_data();
void robot_data();
void pp_data();
void swap_robot();
void new_step_HN();
void new_step_TT();
void disapproval();
void reward(unsigned long object);
void warning (char *msg);
void error(char *msg);
void error(char *msg, unsigned long ul);
void error(char *msg, unsigned long ul1, unsigned long ul2);
void error_dec(char *msg, long lng);
void error_2dec(char *msg, long lng1, long lng2);

//  **********	 pplkback.cpp    **********
void  leakback();
short wipe_expectations_of_active_list();
short wipe_expectations_and_make_active_list(); //30apr00
short leakback_cluster();
short leakback_node (short node, short cluster);
void  add_to_lkbck_list(short cluster, short node );

//  **********   ppltmA.cpp    **********
short  tree_searchA_plus(short ntemp);
short  tree_searchA(short ntemp);
short  make_context_without_removing_nodesA(short cluster, short ntemp,
											  			short noTypes);
void   update_ltmA();     //      (short acst);
void   update_nodeA(short cluster, short temp, short node,
										short type, unsigned long event);
//void   update_landmark(short cluster, short node, unsigned long l_event,
//                                          struct predictionA *lpredptr);
void   add_to_list_of_reward_getting_associations(long step, short node,
						   short temp, short type, unsigned long event);
short update_bkptr_without_removing_node(short cluster, long bkp, short cnode,
											  			  short lnode);
short update_prbptr_without_removing_node(short cluster, short temp, long lprob,
						 					short cnode, short lnode);
void   store_heard_sound_as_action();

//  **********   ppltmS.cpp    **********
short  tree_searchS_plus(short ntemp);
short  tree_searchS     (short ntemp);
short  make_context_without_removing_nodesS(short cluster, short ntemp,
												 	short noTypes);
void   update_ltmS();     //      (short acst);
void   update_nodeS(short cluster, short temp, short nodeS,
																short c_type, long c_event);
// void   remove_LMpreds_without_landmark(short nodeS);

// **********	  ppmemory.cpp    **********
//struct context_link        *newlink();
struct pointer_probs       *newpointer_probs();
short  newnodeA(short ntemp, short cnode);
short  newnodeS(short ntemp, short cnode);
long   newpredictionA(short cluster, short cnode);
long   newpredictionS(short cluster, short cnode);
long   newpointer_prob(short cluster, short cnode);
long   newbackpointer(short cluster, short cnode);
// void   return_back_pointer(short cluster, long bkp);
long   newcontext_linkA(short cluster);
long   newcontext_linkS(short cluster);
struct temp_priority_entry *new_priority();
//void        remove_back_pointer_if_needed(short cluster,short to_node,
//                                                              short from_node);
void   remove_nodeA(short cluster, short node);
void   remove_nodeS(short cluster, short node);
void   remove_predictionsA(short cluster, struct cluster_struct_A *clustptr,
                                                            short node);
void   remove_predictionsS(short cluster, struct cluster_struct_S *clustptr,
                                                            short node);
void   remove_far_back_pointer(struct cluster_struct_A *clustptr, short node,
                                                            long pprob);
void   remove_back_pointers(short cluster, struct cluster_struct_A *clustptr,
                                                            short node);
void   remove_pointer_probs(struct cluster_struct_A *clustptr, short node,
																						long pei);
void   remove_forward_pointers(short cluster, struct cluster_struct_A *clustptr,
																 short node, short backnode);
short  find_least_used_nodeA(short cluster, short cnode);
short  find_least_used_nodeS(short cluster, short cnode);
short  no_conflict_with_current_and_last_nodesA(short cluster,
								short least_used_node, short cnode, short lnode);
void   remove_free_context_links_from_nodeA(short temp,short node,long ctxtel);
void   remove_free_context_links_from_nodeS(short temp,short node,long ctxtel);
void   remove_context_linkA_if_free(short temp, long ctxtel);
void   remove_context_linkS_if_free(short temp, long ctxtel);

//  **********   ppplans.cpp    ***********
void  stay_in_or_restore_h_n();
void  start_or_not_tandt();
void  end_or_not_tandt();
short test_for_tt_terminationA (short stream);
short test_for_tt_terminationS (short stream);
void  copy_list_pred_to_current();
short streams_have_pred_stim   ();
void  install_t_t              ();

//  **********    pppreda.cpp    ***********
struct choice_A *choose_best_from_listA_HN(short stream, short worthFlag);
struct choice_A *choose_best_from_listA_TT(short stream, short worthFlag);
void check_choice_for_plan_mark(struct choice_A *adrchA);
short make_choice_listA(short stream, short worthFlag);
short add_preds_for_tempA(short tstream, short node,
										 short ttemp, short worthFlag);
short add_pred_to_choice_listA(short tstream, long pei,
		  short cluster, short node, short worthFlag );
void  wipe_choice_listsA();
void  mark_nodesA(struct choice_A *adrchA);
void  wipe_all_marks();
void  add_to_best_listA (short tstream, struct choice_A *adrchA);
void  wipe_best_predsA(short stream);

//  **********    pppreds.cpp    ***********
struct choice_S *choose_best_from_listS(short stream);
short there_are_alternative_stimuli();
void make_choice_listS(short stream);
short add_preds_for_tempS(short tstream, short nodeS,	short ttemp);
short add_pred_to_choice_listS(short tstream, long pei,
		  short cluster, short nodeS);
void  wipe_choice_listsS();
void  add_to_best_listS(short tstream, struct choice_S *adrchS);
void  wipe_best_predsS(short stream);

//  **********    ppstm.cpp    **********
void  wipe_events(short acst);
short reg_type_delay(short type, short delay);
unsigned long get_tim_regul(short temp, short context_event_number);
void  shift_stm();
void  display_event_structure(short acst);
void  event_to_string(short ev_type, unsigned long ev_number);
void  display_type_and_shift(short typdelay);
void  display_ltm_tree();
void  disp_ltm(long ctxel, short acst, short mcl, short temp, char* str);
void  display_nodes();
void  disp_nodeA(short clust);
void  disp_nodeS(short clust);
void  display_node(short cntxt_no, short temp, short window);
void  display_node_to_file(short cntxt_no, short temp);
void  display_backpointers(short cluster, long backpr);
void  display_peiA(short cluster, long  peip);
void  display_peiS(short cluster, long  peip);
void  display_ptrprob(short cluster, long ptrprob);
void  display_best_predictionsA();
void  display_best_predictionsS();
void  display_choice_listsS();
void  display_rest_choice_listsS();
void  display_board(); //c _and_canvas();  // canvas only if robot A.
void  board_str(short board_posn);
char  charof(unsigned long ulbyte);
void display_priority(struct temp_priority_entry *priptr,short level,char *str);
void  display_plan_steps();
void  display_graph_line(short line);
void  display_extra_graph_line();
void  display_graph(short line);
void  fill_file_lineA();
void  fill_file_lineB();
void  display_reward_getting_associations();
void  display_array_assA();
void  display_array_prdA();
void  display_array_pprb();
void  display_array_bptr();
void  display_array_assS();
void  display_array_prdS();
void  display_array_ctxtA();
void  display_array_ctxtS();
void  display_arrays_A();
void  display_arrays_S();

//  **********    ppworld.cpp    ************
void  init_actions_stim();
void draw_board();
//c void one_decay_step();
//c void update_canvas_by_action(unsigned long event);
short row_col_to_cell_no(short row, short col);
struct board_posn cell_no_to_row_col(short cell_no );
unsigned long subsumption_body_eye_move();
unsigned long subsumption_body_move();
unsigned long help_A_move_strategy();      // like mother helping baby
unsigned long B_tells_A();   // B telling A what nmoves to make
unsigned long subsumption_eye_move(unsigned long body_move);
unsigned long help_A_eye_strategy(unsigned long body_move); // like mother helping baby
unsigned long subsumption_speechB();
unsigned long abs_to_rel_dirn(unsigned long abs_action);
unsigned long get_feeling_event();
unsigned long get_proprioception_event();
unsigned long get_fovea_event();
unsigned long get_wide_event();
unsigned long get_dirn_event();
unsigned long get_hearing_event();
unsigned long get_desire_event();
// unsigned long get_landmark_event();
//c void canvas_from_wide(unsigned long ulwid);
unsigned long get_left_byte_board_cell(short row, short col);
unsigned long get_mid_byte_board_cell(short row, short col);
unsigned long get_right_byte_board_cell(short row, short col);
void set_left_byte_board_cell(short row, short col, unsigned long ulchar);
void set_mid_byte_board_cell(short row, short col, unsigned long ulchar);
void set_right_byte_board_cell(short row, short col, unsigned long ulchar);
void move_eye(short erow, short ecol, short nrow, short ncol);
BOOL can_move_forward(short brow, short bcol, unsigned long dirn);
void object_squashed( short orow, short ocol, unsigned long object );
void new_object_in_random_empty_posn();
BOOL can_move_or_squash_object(short row, short col, unsigned long dirn);
void move_object(short row, short col, short far_row, short far_col);
BOOL can_pop_object_sideways(short row, short col, unsigned long dirn);
void do_action_in_world(struct event_type evtyp);
unsigned long rotate(unsigned long action, unsigned long dirn);
void change_body_posn(short row, short col, short nrow, short ncol,
													unsigned long dirn);
//c void extra_events_from_wide_and_canvas( unsigned long surround, short delay);
void extra_events_from_wide( unsigned long surround, short delay);
void extra_action_events(short stream, unsigned long action);
void update_drives();



//  *********     ppwind.cpp

class TWindFile
{public:
	TWindFile();
	int		mainFileCount;
	int		bigBufCount;
	int		maxStepsInFile;
	char*	mainFileName;
	char*	wBuf;
	char*	bigBuf;
	void	ChangeMainFile();
	void	CopyBufToBigBuf(char* buf);
	void    CopyBigBufToFile();
	void	CopyBufToFile(char*, char* );
	BOOL	MyFGets(char*, short );
	char	*StrFGets(char*, short );
	void	DisplayAndFile(char*, short);
	void	DisplayOnly(char*, short);
	void	FileOnly(char* buf);
	void    LoopControl();
	void    ppCycleStages(short stge);
	void    Terminate();
	void    SetDiagnostics();
	void    SetJump();
    void    Graph_Line();
	void    ToggleFile();
	void    Initialize();
 struct fileNames
  { char Main[FILELEN];
  }  *File;
};

#endif
