//  pplkback    PURRPUSS     Dev.from C.B.Gunn 22/4/93    jha:12aug98-9jun01

// DESCRIPTION: leakback adjusts the expectations of the LTM nodes,
//  by starting with recently modified associations, and backtracking through
// connected nodes until either the change in expectation is negligible, or a
// fixed` limit is reached. Leakback travels through back-pointers.
// pei.EXPN zeroed before leakback from all goals. Only pou.expn before. 21aug00

#include "c:\Program Files\Borland\CBuilder3\examples\foodrink\ppheader.hpp"

extern robot_info *s;
extern pp_info *pp;
extern world w;
extern TWindFile	*wf;
extern char *event_type_names[];     // in ppworld.cpp
extern char *template_names[];       // in ppworld.cpp
extern char *cluster_namesA[];        // in ppworld.cpp
extern char *stream_names[];         // in ppworld.cpp

#define MYABS(x)  ((x>0)?x:-x)	// need it for floats, abs() only for int.

// *****  FUNCTION: leakback() *****
// Returns to Windows and reenters after leakback to NODES_BETWEEN_WINDOWS nodes.
// Does a complete leakback every n steps, and an incremental leakback on the
// intermediate steps.  4may00
// Uses a cyclic list for processing nodes. emptyel points to first empty
//   element on list. actvel points to next node to process. endactel points
//   to position after last of nodes to process at the current level.

void leakback()
{ struct leakback_cluster *lcstclptr;
  short k, flag = TRUE;
 // Short-cut to leakback_cluster() if just new node.
  if (pp->lkbk_flag == NEW_NODE)
	 {if (!(leakback_cluster())) return ; // If FALSE, don't finish this time
	 }
  else   // New leakback, new cluster or new level
	 {if (pp->lkbk_flag == OFF)  // New processing begins.
		 {if (w.diag & 4)  wf->DisplayAndFile("\nLkbk nodes=", 2);
		  pp->lkbck_counter = 0;
		  pp->lkbkst.lkbkcl=0;          // leakback cluster number
		  pp->lkbkst.level = 0;   // Haven't started processing a cluster
		  pp->lkbk_flag = NEW_CLUSTER;      // Leakback processing is starting.
		 	  pp->nodes_displayed = 0;      // inserts CRLF after every 20. 3sep99
	}
	  if (pp->lkbkst.lkbkcl>=pp->nlkbckclstrs) // All leakback clusters done
		 {pp->lkbk_flag = OFF;          // Leakback finished for this step
		  pp->lkbkst.lkbkcl = 0;
		  pp->lkbkst.level = pp->lkbkst.actvel = 0;
		  pp->lkbkst.endactel = pp->lkbkst.emptyel = 0;
//      if ( w.diag & 4 )
//	       {sprintf(wf->wBuf," nodes/allCls=%d ",pp->lkbck_counter);   // total leakbacks for step
//	        wf->DisplayAndFile(wf->wBuf, 2);
//	       }
		  return;
		 }
	  if (pp->lkbk_flag == NEW_CLUSTER) // First or later cluster
		 {pp->lkbkst.clust = pp->leakback_clusters[pp->lkbkst.lkbkcl].clusterA;
		  pp->lkbkst.actvel = 0; // actvel ptr set to beginning of leakback list.
		  pp->lkbkst.level = 0;
// Leakback from reward/novelty nodes if step is multiple of leakback-frequency,
// or if drive has changed (generating a new set of reward nodes)
		  if ((!(s->step % w.leakback_frequency)) || (s->drive_has_changed))
//  Wipe expectations and make new active list of nov>0 nodes.
			 {pp->lkbkst.endactel = wipe_expectations_and_make_active_list();
			  pp->lkbkst.emptyel = pp->lkbkst.endactel;
			  if (!pp->lkbkst.endactel) flag = FALSE;  // next leakback_cluster
			 }
		  else
//  Set emptyel ptr to first empty element in leakback-list.
			 {pp->lkbkst.emptyel = pp->leakback_clusters[pp->lkbkst.lkbkcl].emptyel;
			  pp->lkbkst.endactel = 0;   // Used to scan through leakback list.
//  Wipe expectations from nodes of active list from leakback list.
			  if (pp->lkbkst.emptyel > 0) // There are nodes to process.
				 flag = wipe_expectations_of_active_list();
			  else flag = FALSE;  // No nodes to process, so next leakback_cluster
			 }
		 }
	  if ( flag == TRUE )  // Non-empty active list to do leakback on.
//  Apply leakback to cluster
		{if (pp->lkbk_flag == NEW_CLUSTER) // New register for processed nodes
			 for (k=0; k<LKBK_LISTS_LENGTH; k++) pp->node_register[k] = FALSE;
		 if (!(leakback_cluster())) return ; // If FALSE, don't finish this time
		}
	 }
	  if ( w.diag & 4 )   // Diagnostic display of no of nodes processed.
		 {sprintf(wf->wBuf," nodes/Cl=%d ",pp->lkbck_counter); // leakbacks for
		  wf->DisplayAndFile(wf->wBuf, 2);      // this cluster this time
		 }
      lcstclptr = &pp->leakback_clusters[pp->lkbkst.lkbkcl];
	  for (k=0; k < LKBK_LISTS_LENGTH; k++)  // wipe leakback list
		  lcstclptr->lkbk_list[k] = NULLNODE;
	  lcstclptr->emptyel = 0;
	  pp->lkbkst.lkbkcl++;                   // next leakback cluster
	  if (pp->lkbkst.lkbkcl<pp->nlkbckclstrs)  // If there is another,
		 {pp->lkbk_flag = NEW_CLUSTER;          // set new cluster flag
		  return; // To Windows before processing next cluster
		 }
	  pp->lkbk_flag = OFF;  // No more clusters
	  return;

}
// ***** FUNCTION: wipe_expectations and make new active list
// For every associated event of every association in leakback cluster:
//    Put node (i.e. association) on leakback list if hungry & hunger reward,
//                                                 or thirsty & drink reward,
//                                                 or novel.
//    If all associated events have disapproval, put node on leakback list.
// If there is still room on leakback list, look at next association in cluster.
// No more associations, so wipe remainder of leakback list before exiting
//    with first empty position on leakback list.
short wipe_expectations_and_make_active_list()
{struct predictionA   *predptr;
 struct cluster_struct_A *lbkclustptr;
 struct leakback_cluster *lcstclptr;
 short i,j, node;
 short all_disapproved = TRUE;
 long pei;
 lbkclustptr = &pp->clustersA[pp->lkbkst.clust];
 lcstclptr = &pp->leakback_clusters[pp->lkbkst.lkbkcl];
 i = node = 0;
 if ( w.diag & 4 ) wf->DisplayAndFile("\nWhole active list(", 2);
// For every associated event of every association in leakback cluster:
 for (node=0; node < pp->maxnodeA[pp->lkbkst.clust]; node++)
    { if (lbkclustptr->assA[node].step_last_used == NULLSTEP) continue;
	 lbkclustptr->assA[node].expn = 0;  // Sets expns to zero.
	 pei = lbkclustptr->assA[node].pei;
	 while ( pei != NULLNODE )  // Search associated events for nov>0
		 {predptr = &lbkclustptr->prdA[pei];
		  predptr->expn = 0;
		  if (!predptr->disapproval)
			 {all_disapproved = FALSE; // At least one assoc.event not disapproved
// Put node on leakback list if hungry & hunger reward,
//                           or thirsty & drink reward,
//                           or novel
//***10apr01   if ((predptr->novelty & w.food) || (predptr->novelty & w.drink))
//***10apr01     predptr->landmark = TRUE;      // 14mar01
			  if (((predptr->novelty & w.food) && (s->drive & w.food))
				  || ((predptr->novelty & w.drink) && (s->drive & w.drink))
				  || (predptr->novelty == 1)
                  || ((!(s->drive & w.plus)) && (predptr->novelty & w.good)))
				 {lcstclptr->lkbk_list[i++] = node;
				  if ( w.diag & 4 )  // If diagnostics, display node added
					{sprintf(wf->wBuf," %d",node);
					 wf->DisplayAndFile(wf->wBuf, 2);
					}
				  break;
				 }
			 }
		  pei = predptr->next;  //
		 }
// If all associated events have disapproval, put node on leakback list.
	 if (all_disapproved == TRUE)
		{lcstclptr->lkbk_list[i++] = node;
		 if ( w.diag & 4 )         // If diagnostics, display node added
			{sprintf(wf->wBuf," %d",node);
			 wf->DisplayAndFile(wf->wBuf, 2);
			}
		}
// If there is still room on leakback list, look at next association in cluster.
	 if (i >= LKBK_LISTS_LENGTH) error_dec("Active List > LKBK_LISTS_LENGTH", i);
	}
// No more associations, so wipe remainder of leakback list before exiting
//   with first empty position on leakback list.
 for (j=i; j < LKBK_LISTS_LENGTH; j++) // Wipe remainder of leakback list
	 lcstclptr->lkbk_list[j] = NULLNODE;
 if ( w.diag & 4 ) wf->DisplayAndFile(")\n", 2);
 return(i);  // Returns first empty position on leakback list.
}


// *****  FUNCTION: 	Wipe_expectations_of_active_list on leakback list
//            but set expn if reward, novelty or all assoc.events disapproved.
// For each node (i.e. association) on leakback list from the position pointed
//    pointed to by endactel until the end of the list or a null node is found:
//    For each not disapproved associated event,
//       if hungry & food reward rate (as fraction) > expectation for novelty,
//       or thirsty & drink reward rate (as fraction) > expectation for novelty,
//          pei expectation = scaling factor * reward rate (as fraction);
//       else if novel, pei expectation = scaling factor * expn for novelty;
//       else pei expectation = 0.
//    The largest of these pei expectations is max-pei-expn, unless all the
//       associated events were disapproved, in which case max-pei-expn = -age.
//    Now set expectation for the node to be max-pei-expn * age/scaling factor,
//       unless it exceeds the age, when it is limited to the age.
// Increment the pointer endactel to the end of the leakback list, changing it
//    to zero if the maximum length of the list is reached, to keep it cyclic.
short 	wipe_expectations_of_active_list()
{ struct predictionA   *predptr;
  struct cluster_struct_A *lbkclustptr;
  struct leakback_cluster *lcstclptr;
  long pei;
  long max_pei_expn = 0, fexp, age;              //       ; g;
//  long scf = SCALE_FACTOR;
  float predRewdProb, predRPf, predRPd;
  short node, count = 0;
  short all_disapproved = TRUE;
  lbkclustptr = &pp->clustersA[pp->lkbkst.clust];
  lcstclptr = &pp->leakback_clusters[pp->lkbkst.lkbkcl];
  if ( w.diag & 4 ) wf->DisplayAndFile("\nPart active list(", 2);
// For each node (i.e. association) on leakback list from the position pointed
//    pointed to by endactel until the end of the list or a null node is found:
  while  ( pp->lkbkst.endactel != pp->lkbkst.emptyel )
	 {node = lcstclptr->lkbk_list[pp->lkbkst.endactel];
	  if (node == NULLNODE)
		 {if ( w.diag & 4 ) wf->DisplayAndFile(")\n", 2);
          if (count) return( TRUE ); else return( FALSE );
		 }
      if (lbkclustptr->assA[node].step_last_used == NULLSTEP)
        {pp->lkbkst.endactel++;     // 27feb01
	     if (pp->lkbkst.endactel == LKBK_LISTS_LENGTH) pp->lkbkst.endactel = 0; // cyclic list
         continue;
        }
	  if ( w.diag & 4 ) // If diagnostics, display node.
		 {sprintf(wf->wBuf," %d",node);
		  wf->DisplayAndFile(wf->wBuf, 2);
		 }
      count++;
	  max_pei_expn = 0;    // will be changed if novelty, or if all disapproved.
	  pei = lbkclustptr->assA[node].pei;
//    For each not disapproved associated event,
//       if hungry & food reward rate (as fraction) > expectation for novelty,
//       or thirsty & drink reward rate (as fraction) > expectation for novelty,
//          pei expectation = scaling factor * reward rate (as fraction);
//       else if novel, pei expectation = scaling factor * expn for novelty;
//       else pei expectation = 0.
//    The largest of these pei expectations is max-pei-expn, unless all the
//       associated events were disapproved, in which case max-pei-expn = -age.
//    Now set expectation for the node to be max-pei-expn * age/scaling factor,
//       unless it exceeds the age, when it is limited to the age.
// Increment the pointer endactel to the end of the leakback list, changing it
//    to zero if the maximum length of the list is reached, to keep it cyclic.
	  while ( pei != NULLNODE )
		 {predptr = &lbkclustptr->prdA[pei];
		  if (s->drive & w.food) predRPf = predptr->reward_rate_f * 0.01;
		  if (s->drive & w.drink) predRPd = predptr->reward_rate_d * 0.01;
		  if (predRPf >= predRPd) predRewdProb = predRPf;
		  else predRewdProb = predRPd;
		  if ( !predptr->disapproval )
			{all_disapproved = FALSE;
			 if (((s->drive & w.food) || (s->drive & w.drink))
								  && (predRewdProb > w.expectation_for_novelty))
					fexp = predRewdProb;
			 else if (predptr->novelty == 1)
					fexp = w.expectation_for_novelty;
             else if ((predptr->novelty & w.good) && (!(s->drive & w.plus)))
                    fexp = w.expectation_for_good;
			 else fexp = 0;
			 if ( max_pei_expn <  fexp )  max_pei_expn = fexp;
			}
		  pei = predptr->next;
		 }
	  age = lbkclustptr->assA[node].age;
	  if ( all_disapproved == TRUE ) max_pei_expn = -1 * age;
	  else lbkclustptr->assA[node].expn = (max_pei_expn * (float) age);
	  if ( lbkclustptr->assA[node].expn > age)
		  lbkclustptr->assA[node].expn = age;
	  pp->lkbkst.endactel++;
	  if (pp->lkbkst.endactel == LKBK_LISTS_LENGTH) pp->lkbkst.endactel = 0; // cyclic list
	 }
  if ( w.diag & 4 ) wf->DisplayAndFile(")=\n", 2);
  if (count) return( TRUE );
  else return( FALSE );
}

// *****  FUNCTION: leakback_cluster()  *****
// For up to NODES_BETWEEN_WINDOWS nodes or until null node reached:
//   Remove a node from active section of leakback list.
//   Do leakback to this node and, if a change has been made to node, add the
//      nodes pointed to by its backpointers to the holding section of the list,
//      omitting backpointers to same node (if not allowed) and duplicates.
//   If this is a whole leakback step & node limit reached, exit with TRUE.
//   If the active section of the list is used up, start the next level.
//     If the leakback level limit has been reached, exit with TRUE.
//     If there are no nodes in the holding section of the list, exit with TRUE.
//     Holding section becomes new active section.
//     Clear duplicate-avoiding register.

short leakback_cluster()
{struct back_pointer *bkptr;
 struct cluster_struct_A *lbkclustptr;
 struct leakback_cluster *lcstclptr;
 long bpr;
 short  i;
 lbkclustptr = &pp->clustersA[pp->lkbkst.clust];
 lcstclptr = &pp->leakback_clusters[pp->lkbkst.lkbkcl];
 pp->lkbkst.node =
			lcstclptr->lkbk_list[pp->lkbkst.actvel];
// Until null node reached:
//   Remove a node from active section of leakback list.
//   Do leakback to this node and, if a change has been made to node, add the
//      nodes pointed to by its backpointers to the holding section of the list,
//      omitting backpointers to same node (if not allowed) and duplicates.
 while (( pp->lkbkst.node != NULLNODE )
      && (lbkclustptr->assA[pp->lkbkst.node].step_last_used != NULLSTEP))
  {lcstclptr->lkbk_list[pp->lkbkst.actvel] = NULLNODE; // remove from list
	if (leakback_node(pp->lkbkst.node, pp->lkbkst.clust)) // TRUE if change made
	 {bpr = lbkclustptr->assA[pp->lkbkst.node].back;
//	  if ( w.diag & 4 )
//		 {sprintf(wf->wBuf, "\nBnodes from %d:", pp->lkbkst.node);
//		  wf->DisplayAndFile(wf->wBuf, 2);
//		 }
	  while ( bpr != NULLNODE )  // Add backpointer nodes to leakback list.
		{bkptr = &lbkclustptr->bptr[bpr];
		 if ( ((pp->lkbkst.node != bkptr->node)
					|| (!w.expn_calc_omits_ptrs_to_same_node))
					&& ( pp->node_register[bkptr->node] == FALSE ) ) // not duplicate
		  {lcstclptr->lkbk_list[pp->lkbkst.emptyel++]
										 = bkptr->node; // Add node and move up pointer
			pp->node_register[bkptr->node] = TRUE; // Register addition
			if (pp->lkbkst.emptyel == LKBK_LISTS_LENGTH)
						pp->lkbkst.emptyel = 0;       // maintain cyclic list
			if (pp->lkbkst.emptyel == pp->lkbkst.actvel)
					  error("Leakback stopped because no space on step ", s->step);
//			if ( w.diag & 4 )
//			  {sprintf(wf->wBuf, " b%d", bkptr->node);
//				wf->DisplayAndFile(wf->wBuf, 2);
//			  }
		  }
		 bpr = bkptr->next;      // Next backpointer
		}
	 }
	pp->lkbkst.actvel++;        // Move up pointer to active section of list
	if (pp->lkbkst.actvel == LKBK_LISTS_LENGTH)
		pp->lkbkst.actvel = 0; // maintain cyclic list: returns to 0 from end.
//   If this is a whole leakback step & node limit reached, exit with TRUE.
	if ((s->step % w.leakback_frequency) &&
								 (pp->lkbck_counter > w.leakback_node_limit))
	  {//if ( w.diag & 4 ) wf->DisplayAndFile(" Lkbk-node-limit ",2);
		return(TRUE);  // Node Limit reached
	  }
//   If the active section of the list is used up, start the next level.
	if (pp->lkbkst.actvel == pp->lkbkst.endactel)   // Active List used up.
	  {pp->lkbkst.level++;                          // Start next level.
		pp->nodes_displayed = 0;         // New level starts new diagnostic line
//		if ( w.diag & 4 ) {sprintf(wf->wBuf,"\nLevel=%d",pp->lkbkst.level);
//								  wf->DisplayAndFile(wf->wBuf, 2);
//								 }
//     If the leakback level limit has been reached, exit with TRUE.
		if (pp->lkbkst.level >= w.leakback_level_limit)  // Whole or Part
			{//if ( w.diag & 4 ) wf->DisplayAndFile(" Lkbk-level-limit ",2);
			 return(TRUE);  // Level Limit reached
			}
//     If there are no nodes in the holding section of the list, exit with TRUE.
		if (pp->lkbkst.endactel == pp->lkbkst.emptyel)
			{//if ( w.diag & 4 ) wf->DisplayAndFile(" No-more-Lkbk-nodes ",2);
			 return(TRUE);
			}
//     Holding section becomes new active section.
//     Clear duplicate-avoiding register.
		pp->lkbkst.endactel = pp->lkbkst.emptyel;    // Next level active list.
		for (i=0; i<LKBK_LISTS_LENGTH; i++) pp->node_register[i] = FALSE;
		pp->lkbk_flag = NEW_LEVEL; // Flag set to allow re-entry from Windows.
		return(FALSE);
	  }
	 pp->lkbkst.node =              // Next node if more to process.
			 lcstclptr->lkbk_list[pp->lkbkst.actvel];
  }
	pp->lkbk_flag = NEW_NODE;  // For re-entry from Windows to process next node.
	return(FALSE);    // FALSE signals leakback process not complete.
}

// *****  FUNCTION: leakback_node()  *****
// Calculates the expectation for a node:
// For each associated event (pei):
//   For each pointer-probability to a far node:
//       Add an expectation = prob * expn/age of far node.
//   If assoc.event is disapproved, its expectation = -age
//   Else add the fractional reward rate for food if hunger drive,
//                                        for drink if thirsty,
//                                    and larger of two if both,
//          or if neither drive is ON or reward rate < expn for novelty,
//                   if novel, add the expn for novelty,
//       in each case multiplied by the age.
//   If the sum exceeds the age, truncate to the age.
// Expectation of node is the best of the expectations of the associated events.
// Returns TRUE if expectation of node is changed and above threshold.
short leakback_node( short node, short cluster )
{//struct nodeA    *cntxtptr;
 struct predictionA  *predptr;
 struct pointer_prob *prbptr;
 struct cluster_struct_A *clusptr;
 short pnode;
 float max_pei_expn = 0;
 float fexp, best, oldexpn, pexpn, predRewdProb, predRPf, predRPd;
// float scdf, scf = SCALE_FACTOR;
 long age, p_age, pei, pprb;
 clusptr = &pp->clustersA[cluster];
 predRPf = predRPd = 0;
// scdf = scf * w.discount_factor;
 pp->lkbck_counter++;    // Counts number of nodes processed.
 if ( node == NULLNODE ) error("Empty node to do leakback to.");    // 1may99
 if (clusptr->assA[node].step_last_used != NULLSTEP)
 age  = clusptr->assA[node].age;
// if ( w.diag & 4 )
//	{display_node(node, clusptr->assA[node].temp, 2);
//	 if ( ++pp->nodes_displayed > 15 ) // Not more than 15 nodes in one line.
//		{ pp->nodes_displayed = 0;
//		  wf->DisplayAndFile("\n", 2);
//		}
//	}
// For each associated event (pei):
 pei = clusptr->assA[node].pei;
 while ( pei != NULLNODE )
	{predptr = &clusptr->prdA[pei];
	 if (predptr->event.event == NULLEVENT) break;   // No associated events
	 fexp = 0;                                       // zero before calculation
//    For each pointer-probability to a far node:
//       Add an expectation = prob * expn/age of far node.
	 pprb=predptr->ptr_prob;
	 while (pprb != NULLNODE)         // For each ptr to a node
		{prbptr = &clusptr->pprb[pprb];
		 pnode = prbptr->node;         // Node pointed to
		 pexpn = clusptr->assA[pnode].expn; // expn of pointed to node
		 p_age = clusptr->assA[pnode].age;  // age of pointed to node
		 if (((w.expn_calc_omits_ptrs_to_same_node) && (pnode == node ))
						  || ( !pexpn ))               // Nothing to add.
			{pprb = prbptr->next; continue;     // Next pointer to a node
			}
		 if ( !p_age )  error("\nZero p_age as denominator. ");
		 fexp = fexp + (w.discount_factor * (float) prbptr->prob * pexpn / p_age);
		 pprb = prbptr->next;
		}
//   If assoc.event is disapproved, its expectation = -age
//   Else add the fractional reward rate for food if hunger drive,
//                                        for drink if thirsty,
//                                    and larger of two if both,
//          or if neither drive is ON or reward rate < expn for novelty,
//                   if novel, add the expn for novelty,
//       in each case multiplied by the age.
//   If the sum exceeds the age, truncate to the age.
	 if ( predptr->disapproval ) fexp = -1 * (float) predptr->age;
	 else
		{predRewdProb = 0;
		 if (s->drive & w.food) predRPf = predptr->reward_rate_f * 0.01;
		 if (s->drive & w.drink) predRPd = predptr->reward_rate_d * 0.01;
		 if (predRPf >= predRPd) predRewdProb = predRPf;
		 else predRewdProb = predRPd;
		 if (((s->drive & w.food) || (s->drive & w.drink))
								  && (predRewdProb > w.expectation_for_novelty))
			fexp += predRewdProb * (float) predptr->age;
         else if ((predptr->novelty & w.good) && (!(s->drive & w.plus)))
            fexp += w.expectation_for_good * (float) predptr->age;
		 else if (predptr->novelty == 1)
			fexp += w.expectation_for_novelty * (float) predptr->age;
//	 if ( w.diag & 4 )
//		{sprintf(wf->wBuf, " fex%.2f", fexp);
//		 wf->DisplayAndFile(wf->wBuf, 2);
//		}
		 if ( MYABS(fexp) < ((float) predptr->age * w.leakback_threshold))
			fexp = 0;
		 else if ( predptr->age )
				  {if ( fexp > ((float) predptr->age) )
					  fexp = (float) predptr->age;
				  }
				else error("\nZero pei->age as denominator. ");
		}
	 predptr->expn = fexp;
	 fexp = fexp/predptr->age;
	 if ( MYABS(max_pei_expn) < MYABS(fexp) )
		max_pei_expn = fexp;
//	 if ( w.diag & 4 )
//		{sprintf(wf->wBuf, " max%.2f", max_pei_expn);
//		 wf->DisplayAndFile(wf->wBuf, 2);
//		}
	 pei = predptr->next;   // Next associated event.
	}
// Expectation of node is the best of the expectations of the associated events.
// Returns TRUE if expectation of node is changed and above threshold.
 best = (max_pei_expn * (float) age );
 if ( best > ((float) age) ) best = (float) age;
 if ( oldexpn == best )
	{//if ( w.diag & 4 )
	 //	{sprintf(wf->wBuf, "No change in expn=%.2f ", oldexpn);
	 //	 wf->DisplayAndFile(wf->wBuf, 2);
	 //	}
	 return FALSE;  // No change so don't process further.
	}
 if ( MYABS(best) > (float) age * w.leakback_threshold )
	{fexp = clusptr->assA[node].expn = best;
//	 if ( w.diag & 4 )
//		{sprintf(wf->wBuf, " expn=%.2f ", fexp);
//		 wf->DisplayAndFile(wf->wBuf, 2);
//		}
	 return TRUE;
	}
 else clusptr->assA[node].expn = 0;
 return FALSE;
}

// ***** FUNCTION: add_to_lkbck_list() *****
void  add_to_lkbck_list(short cluster, short node )
{ short i, lbcl, emptyel;
  lbcl = pp->clustersA[cluster].leakback_cluster_no;
  emptyel = pp->leakback_clusters[lbcl].emptyel;
  for (i=0; i < emptyel; i++)
	  if (node == pp->leakback_clusters[lbcl].lkbk_list[i]) return; //already there
  pp->leakback_clusters[lbcl].lkbk_list[emptyel] = node;
  emptyel++; if (emptyel == LKBK_LISTS_LENGTH) emptyel = 0; // cyclic list
  pp->leakback_clusters[lbcl].emptyel = emptyel;
	  }


