// ppltma.cpp     PURRPUSS   Dev.from C.B.Gunn 22/4/93    jha:11aug98-24jly01
//  Reward counter added to predictions.   18apr00.
#include "c:\Program Files\Borland\CBuilder3\examples\foodrink\ppheader.hpp"

extern robot_info *s;
extern pp_info *pp;
extern world w;
extern TWindFile	*wf;
extern char *event_type_names[];     // in ppworld.cpp
extern char *template_names[];       // in ppworld.cpp
extern char *cluster_namesA[];        // in ppworld.cpp
extern char *stream_names[];         // in ppworld.cpp

// ***** FUNCTION: update_ltmA() *****
// For each action-predicting cluster:
//    For each template in cluster until a matching association is found:
//         For each associated event type which has a current event in STM:
//            Find a matching context in STM.
//            Update association comprising context and associated event.
void update_ltmA()
{ short cl, k, n, ttemp, prtyp, cnode;
  short valid_context;
  struct event_type current_event;
// For each action-predicting cluster:
  for (cl=0; cl<pp->naclusters; cl++)                  // for each cluster
	 {//if ( w.diag & 2 )
	  //	 {sprintf(wf->wBuf,"\nUpdating cluster %d. ", cl);
	  //	  wf->DisplayAndFile(wf->wBuf, 2);
	  //	 }
	  valid_context = 0;
//    For each template in cluster until a matching association is found:
	  for (k=0; k<pp->clustersA[cl].ntemps; k++)
		 {ttemp = pp->clustersA[cl].tem[k];
		  if ( pp->templates[ttemp].acst != AC ) continue;
//		  if ( w.diag & 2 )
//			{sprintf(wf->wBuf," k/max=%d/%d ", k, pp->clustersA[cl].ntemps);
//			 wf->DisplayAndFile(wf->wBuf, 2);
//			}
		  if ( w.diag & 2 )
			{sprintf(wf->wBuf,"\nUpdating clusterA %s,temp %s,npreds:%d ",
				cluster_namesA[cl],template_names[ttemp],pp->templates[ttemp].npreds);
			 wf->DisplayAndFile(wf->wBuf, 2);
			}
//         For each associated event type which has a current event in STM:
		  for (n=0; n<pp->templates[ttemp].npreds; n++)
			 {prtyp = pp->templates[ttemp].predict_event_type[n];
			  if ( w.diag & 2 )
				{ sprintf(wf->wBuf," prtyp=%s ",event_type_names[prtyp]);
				  wf->DisplayAndFile(wf->wBuf, 2);
				}
			  if ( s->events[prtyp].tim_shift_reg[0] == NULLEVENT ) continue;
//            Find a matching context in STM.
			  cnode = tree_searchA_plus( ttemp );         // >>> TREE_SEARCH_PLUS
			  if ( cnode == NULLNODE ) continue;
			  else
				{
//           if ( w.diag & 2 )
//				  {sprintf(wf->wBuf,"\ntree searchA+ succeeds:temp=%d,cnode=%d ",
//														 ttemp,cnode);
//					wf->DisplayAndFile(wf->wBuf, 2);
//				  }
		// We now have a context in which to store the prediction
				 valid_context = 1;
				 current_event.event = s->events[prtyp].tim_shift_reg[0];  // see if OK
				 current_event.type = prtyp;
				 if ( w.diag & 2 )
				  {sprintf(wf->wBuf,"\nUpdating temp%d,clstr%d,cnode%d with typ%d,evt%X ",
						ttemp, cl, cnode, current_event.type, current_event.event);
					wf->DisplayAndFile(wf->wBuf, 2);
				  }
//            Update association comprising context and associated event.
				 update_nodeA( cl, ttemp, cnode, current_event.type,
																current_event.event );
				 pp->clustersA[cl].last_event.event =  current_event.event;
				 pp->clustersA[cl].last_event.type  =  current_event.type;
				 pp->clustersA[cl].last_node      =  cnode;
				 break;  // No need to consider more than one prediction type
				}
			 }   //4}
		  if ( valid_context ) break;     // No need to consider more than one template
		 }      //3}   end of template loop
	 }         //2}   end of cluster loop
}             //1}

// ***** FUNCTION: update_nodeA() *****
// USED BY: update_ltmA().
// DESCRIPTION: Does all updating of current context.
//  templates[].kindofpred = CHOICE means can have list of predictions.
//								 RECENCY means only most recent prediction.
// RECENCY is not implemented here.
//
// Reinforcement is either food reward, drink reward, or just novelty.
// For-each associated event of context node until null or match:
//   If null (i.e. none or no match) make a new associated event ('prediction').
//   If the first associated event is new, initialize age and expn of the node.
//   If not the first, increment the node age and, if not in a leakback cluster,
//     set the node expn equal to the age.
//   Initialize the associated event parameters.
// If there is a matching associated event and type:
//     Cancel a novelty mark.
//     Set a reward mark if there is reward and the corresponding drive is ON.
//     Update a reward rate if the corresponding drive is ON,
//        initializing reward rate to 100 if it was zero and there is reward.
//     Remove reward mark if reward rate drops below threshold.
//     If there is a path mark equal to the path step increment marks-seen.
void update_nodeA(short cluster, short ctemp, short cnode,
											short c_type, unsigned long c_event)
{ //struct nodeA    *l_cntxtptr, *hold_cntxtptr, *hh_cntxtptr;
  struct back_pointer *bkptr;
  struct predictionA *predptr, *lpredptr;
  struct pointer_prob  *lprbptr;   // *fstprbptr;
  long pei, lpei, lprob, bkp;
  unsigned long  l_event;
  short lnode, hold_node, hh_node, l_type;
  long  hold_prob, hh_prob;
  short nov_reward;  // same  ptrprob_count
  short flag = 0;
  short ptr_prob_flag = FALSE; // True if new ptr_prob has to be obtained
// Reinforcement is either food reward, drink reward, or just novelty.
  nov_reward = 1;
  if (( pp->templates[ctemp].is_in_leakback_cluster )
								 || ( !w.novelty_with_leakback_only ))
	 {if ((s->reward == w.food) && (s->drive & w.food))    nov_reward = w.food;
	  if ((s->reward == w.drink) && (s->drive & w.drink))  nov_reward = w.drink;
	  if ((s->reward == w.good) && (!(s->drive & w.plus))) nov_reward = w.good;
	 }
//  if ( w.diag & 2 ) display_arrays(cluster);
// For-each associated event of context node until null or match:
//   If null (i.e. none or no match) make a new associated event ('prediction').
  if (cnode == NULLNODE) error("\nupdate_nodeA: cnode is null");
  pei = pp->clustersA[cluster].assA[cnode].pei;
  if (pei >= pp->maxpredA[cluster] ) error_dec("\n**ucA*pei exceeds max preds ",pei);
  if ( pei == NULLLONG )   // null
	 {pei = pp->clustersA[cluster].assA[cnode].pei = newpredictionA(cluster, cnode);
      if ((pei == NULLLONG) || (pei >= pp->maxpredA[cluster]))
         error_dec("\n**ucA2*pei is null or exceeds max preds ",pei);
	  predptr = &pp->clustersA[cluster].prdA[pei];
	  flag = 1;  // new first prediction
	 }
  else if ( pp->templates[ctemp].kindofpred == CHOICE )  //look further if CHOICE
	 {flag = 2;  // will be this if a CHOICE match is found.
	  predptr = &pp->clustersA[cluster].prdA[pei];
	  while ( ( predptr->event.event != c_event  ||  predptr->event.type != c_type )
										 && (predptr->next != NULLLONG) )
		  {pei = predptr->next;
           if ((pei == NULLLONG) || (pei >= pp->maxpredA[cluster] ))
              error_dec("\n**ucA3*pei is null or exceeds max preds ",pei);
			predptr = &pp->clustersA[cluster].prdA[pei];
		  }
	  if ( predptr->event.event != c_event  ||  predptr->event.type != c_type )
		 {flag = 3;       // no match, so new associated event to be stored
		  pei = predptr->next = newpredictionA(cluster, cnode);
          if ((pei == NULLLONG) || (pei >= pp->maxpredA[cluster]))
             error_dec("\n**ucA4*pei is null or exceeds max preds ",pei);
		  predptr = &pp->clustersA[cluster].prdA[pei];
//		  wf->DisplayAndFile("\nNo match. ", 2);
		 }
	 }  // If flag == 1 or 3, we have a new prediction.
		 // If flag == 2, we have a match for CHOICE.
		 // If flag == 0 we have a match or no-match for RECENCY (not implemented)
  if ( w.diag & 2 )
	{sprintf(wf->wBuf, "  flag=%d ", flag);
	 wf->DisplayAndFile(wf->wBuf, 2);	}
  if ( (flag == 1) || (flag == 3) )		// first or later new prediction
		 { predptr->event.event = c_event;     // PEI for c_event
			predptr->event.type  = c_type;
		  if (w.diag & 2)
			 {sprintf(wf->wBuf, "\nNew predtyp=%d,evt=%X for ",
															 c_type, c_event);	// Yes
			  wf->DisplayAndFile(wf->wBuf, 2);
			  display_node(cnode, ctemp, 2);
			 }
		  s->frustration = 0;
		  s->boredom = 0;
//   If the first associated event is new, initialize age and expn of the node;
//   If not the first, increment the node age and, if not in a leakback cluster,
//     set the node expn equal to the age.
//   Initialize the associated event parameters.
		  if (flag == 1)    // new first associated event
			 {pp->clustersA[cluster].assA[cnode].age = w.quantum;
			  pp->clustersA[cluster].assA[cnode].expn =
													 w.quantum * w.expectation_for_novelty;
			 }
		  else
			  pp->clustersA[cluster].assA[cnode].age += w.quantum; // expn stays till leakback calcs
		  if ( !pp->templates[ctemp].is_in_leakback_cluster )
			  pp->clustersA[cluster].assA[cnode].expn =
								  pp->clustersA[cluster].assA[cnode].age;  // no leakback
		  predptr->age = w.quantum;
		  predptr->disapproval = 0;
		  predptr->reward_rate_f = 0;
		  predptr->reward_rate_d = 0;
		  if (nov_reward & w.plus)   // means Food or Drink reward and drive, or Good.
			  {if (s->reward & w.food) predptr->reward_rate_f = 100; // Initial reward_rate of 100%
			   else if (s->reward & w.drink) predptr->reward_rate_d = 100;
			   if (cluster == CLBE)  // Only for BE cluster. 24oct00
				 add_to_list_of_reward_getting_associations(s->step,
				 					 cnode, ctemp, c_type, c_event);
			  }
		  if ( pp->templates[ctemp].is_in_leakback_cluster )
			  predptr->novelty = nov_reward;  // because new prediction
		  else if ( w.novelty_with_leakback_only )
					 predptr->novelty = 0;
				 else  predptr->novelty = nov_reward;
		  if ( s->disapproval )
			{ predptr->disapproval = 1;
			  predptr->novelty = 0;
			  predptr->expn = - w.quantum;
			}
		  else if ((!pp->templates[ctemp].is_in_leakback_cluster)
											   	  || (nov_reward > 1))
					predptr->expn = w.quantum;
				 else predptr->expn = w.quantum * w.expectation_for_novelty;
		  predptr->mark = NULLMARK;
		 }
// If there is a matching associated event and type:
//     Cancel a novelty mark.
//     Set a reward mark if there is reward and the corresponding drive is ON.
//     Update a reward rate if the corresponding drive is ON,
//        initializing reward rate to 100 if it was zero and there is reward.
//     50% chance of removing reward mark if reward rate drops below threshold.
  if ( flag == 2 ) 		// matching event and type for CHOICE
	 {if ( predptr->novelty == 1 )
		 {s->frustration = 0;
		  s->boredom     = 0;
		  predptr->novelty = 0;      // 2nd time removes initial novelty
		 }
	  if (nov_reward & w.good) predptr->novelty |= nov_reward;
      else if (predptr->novelty & w.good) predptr->novelty &= w.plus; //"Good" is volatile
	  if (nov_reward & w.plus)
		 {predptr->novelty |= nov_reward;
		  if ((!predptr->reward_rate_f)  && (!predptr->reward_rate_d))
			 {add_to_list_of_reward_getting_associations(s->step,
															 cnode, ctemp, c_type, c_event);
			 }
		  if (s->reward & w.food)
			 {if ((predptr->reward_rate_f) && (random(100) > predptr->reward_rate_f))
				 {if (++predptr->reward_rate_f >= pp->reward_rate_threshold)
					 predptr->novelty |= nov_reward;
				 }
			  if (!predptr->reward_rate_f)
				  {predptr->reward_rate_f = 100;   // initial value
					predptr->novelty = nov_reward;
				  }
			 }
		  if (s->reward & w.drink)
			 {if ((predptr->reward_rate_d) && (random(100) > predptr->reward_rate_d))
				 {if (++predptr->reward_rate_d >= pp->reward_rate_threshold)
					 predptr->novelty |= nov_reward;
				 }
			  if (!predptr->reward_rate_d)
				  {predptr->reward_rate_d = 100;
					predptr->novelty = nov_reward;
				  }
			 }
		 }
	  else     // because if no drive there is no reward signal
		 {if (( s->drive & w.food ) && (random(100) < predptr->reward_rate_f))
			  predptr->reward_rate_f--;
		  if (( s->drive & w.drink ) && (random(100) < predptr->reward_rate_d))
			  predptr->reward_rate_d--;
		  if (predptr->reward_rate_f < pp->reward_rate_threshold)
			  predptr->novelty &= (w.drink | w.good); // keeps Drink,Good
		  if (predptr->reward_rate_d < pp->reward_rate_threshold)
			  predptr->novelty &= (w.food | w.good);  // keeps Food,Good
		 }
//     If there is a path mark equal to the path step increment marks-seen.
//      if (!w.no_display_or_file ) // && (predptr->mark != NULLMARK))
//		{sprintf(wf->wBuf," Step %d,mark %d, node:",
//                                      pp->path_step, predptr->mark);
//		 wf->DisplayAndFile(wf->wBuf, 2);
//		 display_node(cnode, ctemp, 2);
//		}
//	  if ((predptr->mark) && (predptr->mark == pp->path_step))
//		{pp->marks_seen++;
//		 predptr->mark = NULLMARK;
//         if (!w.no_display_or_file) wf->DisplayAndFile(" match", 2);
//		}
	  pp->clustersA[cluster].assA[cnode].age += w.quantum; // Add a quantum to age
	  predptr->age += w.quantum; // Add quantum to pred age
	  if ( s->disapproval )
		{predptr->disapproval = 1;
		 predptr->novelty = 0;
		 if ( pp->templates[ctemp].is_in_leakback_cluster )
		   predptr->expn = - w.quantum;
		 else predptr->expn = - predptr->age;
		}
	  else predptr->disapproval = 0; // Cancel any disapproval mark
	  if ( pp->templates[ctemp].is_in_leakback_cluster )
		 predptr->expn = w.quantum * w.expectation_for_novelty; // until leakback
	 }
// Match or no match for RECENCY - This will need checking if recency is used.
  if (flag == 0)   // At this point   peiptr = pp->assA[cnode].pei;
	{error("Program not correct for recency yet e.g. removable ptr-probs.");
//	 if ( predptr->event.event != c_event  ||  predptr->event.type != c_type )
//	  {predptr->event.event = c_event;		// no match
//		predptr->event.type  = c_type;
//		pp->clustersA[cluster].assA[cnode].expn =
//									pp->clustersA[cluster].assA[cnode].age = w.quantum;
//		predptr->age = w.quantum;
//		predptr->expn = w.quantum * w.expectation_for_novelty;
//		if  (s->drive == w.food)
//			if (s->reward == w.food) predptr->reward_rate_f = 100;
//			else predptr->reward_rate_f = 0;
//		if  (s->drive == w.drink)
//			if (s->reward == w.drink) predptr->reward_rate_d = 100;
//			else predptr->reward_rate_d = 0;
//		predptr->novelty = nov_reward;
//		if ( s->disapproval )
//		  {predptr->disapproval = 1;
//			predptr->novelty = 0;
//		  }
//		else  predptr->disapproval = 0;
//	  }
//	 else		// match for RECENCY
//	  {predptr->novelty = 0;
//		if ( s->reward > 1 )
//		  {predptr->novelty = nov_reward;
//			if ((s->drive == w.food) && (random(100) > predptr->reward_rate_f))
//				predptr->reward_rate_f++;
//			if ((s->drive == w.drink) && (random(100) > predptr->reward_rate_d))
//				predptr->reward_rate_d++;
//		  }
//		else
//		  {if ((s->drive == w.food) && (random(100) < predptr->reward_rate_f))
//			  predptr->reward_rate_f--;
//			if ((s->drive == w.drink) && (random(100) < predptr->reward_rate_d))
//			  predptr->reward_rate_d--;
//		  }
//		pp->clustersA[cluster].assA[cnode].age += w.quantum;
//		predptr->age += w.quantum;
//	  }
	}
// Add node to leakback list
  if (pp->templates[ctemp].is_in_leakback_cluster )
	 {if ( w.diag & 4 )
		{wf->DisplayAndFile("  Adding node:", 2);
		 display_node(cnode, ctemp, 2);
		}
	  add_to_lkbck_list( cluster, cnode );
	 }
  lnode = pp->clustersA[cluster].last_node;
  if ( lnode == NULLNODE ) return;			// No last node yet
  if ( !pp->templates[ctemp].is_in_leakback_cluster ) return; // 16sep99
  if ( w.diag & 2 )
	 {wf->DisplayAndFile("\nLast node=", 2);
	  display_node(lnode, pp->clustersA[cluster].assA[lnode].temp, 2);
	  lpei = pp->clustersA[cluster].assA[lnode].pei;
	  if ((lpei == NULLLONG) || (lpei >= pp->maxpredA[cluster]))
		  error_dec("\n**ucA*lpei is null or exceeds max preds ",lpei);
	  lpredptr = &pp->clustersA[cluster].prdA[lpei];
	  sprintf(wf->wBuf, "\nLast predtype=%d, last event=%X for added cntxt ",
							  lpredptr->event.type,lpredptr->event.event);
	  wf->DisplayAndFile(wf->wBuf, 2);
	  display_node(cnode, ctemp, 2);
	 }
  if ( pp->clustersA[cluster].assA[lnode].pei == NULLLONG )
						error_dec("Last node has no prediction. A", lnode);
// Add last node to (Not! beginning of) backpointers list.
  bkp = pp->clustersA[cluster].assA[cnode].back;
  if ( bkp == NULLLONG )
	 {bkp = pp->clustersA[cluster].assA[cnode].back = newbackpointer(cluster, cnode);
		if (bkp == NULLLONG) error_dec("\nNo new back pointer for cnode ",cnode);
	  bkptr = &pp->clustersA[cluster].bptr[bkp];
	  bkptr->node = lnode;
	  bkptr->next =  NULLLONG;
//	  sprintf(wf->wBuf,"\n*****ltma: first back node=%d, bkp=%d ",lnode,bkp);
//	  wf->DisplayAndFile(wf->wBuf, 2);
	 }
  else   //
	 while (update_bkptr_without_removing_node(cluster, bkp, cnode, lnode))
			{bkp = pp->clustersA[cluster].assA[cnode].back;
			}
// Update last cntxt preds
//  if ( w.diag & 2 )
//    {display_array_assA(cluster);
//     display_array_prdA(cluster);
//    }
  lpei = pp->clustersA[cluster].assA[lnode].pei;
  if (lpei >= pp->maxpredA[cluster] ) error_dec("\n**ucA2*lpei exceeds max preds ",lpei);
  if ( lpei == NULLLONG ) error_dec("\nLast node has no prediction. B", lnode);
  l_type = pp->clustersA[cluster].last_event.type;
  l_event = pp->clustersA[cluster].last_event.event;
  if ( w.diag & 2 )
	 {sprintf(wf->wBuf, "\nl_type=%d,l_event=%X,lnode=%d,cnode=%d ",
										  l_type,l_event,lnode,cnode);
	  wf->DisplayAndFile(wf->wBuf, 2);
	 }
  lpredptr = &pp->clustersA[cluster].prdA[lpei];
  while ( ((lpredptr->event.type != l_type) ||
			  (lpredptr->event.event != l_event)) && (lpredptr->next != NULLLONG) )
		  {lpei = lpredptr->next;
		   if ((lpei == NULLLONG) || (lpei >= pp->maxpredA[cluster]))
			  error_dec("\n**ucA3*lpei is null or exceeds max preds ",lpei);
		   lpredptr = &pp->clustersA[cluster].prdA[lpei];
		   if ( w.diag & 2 )
			 {sprintf(wf->wBuf, "\n***lpredptr->event.type=%d, .event=%X ",
					   		  lpredptr->event.type,lpredptr->event.event);
			  wf->DisplayAndFile(wf->wBuf, 2);
			 }
		  }
  if ( w.diag & 2 )
	{sprintf(wf->wBuf, "\n***2*lpredptr->event.type=%d, .event=%X ",
									  lpredptr->event.type,lpredptr->event.event);
	 wf->DisplayAndFile(wf->wBuf, 2);
	}
  if ((lpredptr->event.type != l_type) || (lpredptr->event.event != l_event) )
	 error("Last node hasn't correct pair event and type.");
  lprob = lpredptr->ptr_prob;  // We now know this is the last predn
//  ptrprob_count = w.max_ptrprobs_per_pred;
  if ( lprob == NULLLONG )
	 {lprob = lpredptr->ptr_prob = newpointer_prob(cluster, cnode);
		if (lprob == NULLLONG) error_dec("\nNo new pointer prob for lnode ", lnode);
	  lprbptr = &pp->clustersA[cluster].pprb[lprob];
	  lprbptr->node = cnode;
	  lprbptr->prob = w.quantum;
	 }
  else
	 while (update_prbptr_without_removing_node(cluster, ctemp, lprob,
                                                             cnode, lnode))
			{lprob = lpredptr->ptr_prob;
			}
}

// Function:  add_to_list_of_reward_getting_associations
void	 add_to_list_of_reward_getting_associations(long step, short node,
									 short temp, short type, unsigned long event)
{short i;
 if (!w.holding_reward_getting_associations) return;
 for (i=0; i<=pp->highest_reward_getting_association; i++)
	 {if ((pp->rgass[i].node == node) &&  (pp->rgass[i].temp == temp) &&
						(pp->rgass[i].evtyp.type == type) &&
						(pp->rgass[i].evtyp.event == event))
		return; // Already there
	 }
 i = ++pp->highest_reward_getting_association;
 if (i >= MAX_REWARD_GETTING_ASSOCIATIONS)
	error("MAX_REWARD_GETTING_ASSOCIATIONS exceeded", i);
 pp->rgass[i].step = step;
 pp->rgass[i].node = node;
 pp->rgass[i].temp = temp;
 pp->rgass[i].evtyp.type = type;
 pp->rgass[i].evtyp.event = event;
}


// ***** FUNCTION: tree_search() *****
// USED BY: make_choice_s_list().
// DESCRIPTION: Searches given template LTM for a context matching STM. (?)

short tree_searchA(short ntemp)  // Differs from tree_searchS
{ short j, noTypes, node, cluster;                                   // right at end!
  unsigned long tevent;
  struct context_link *clptr, *testptr;
  long ctxel, testel;
  if (w.diag & 8) wf->DisplayAndFile("\ntree_searchA", 2);
  cluster = pp->templates[ntemp].clust;
  ctxel = pp->templates[ntemp].base;
  if ( ctxel == NULLLONG ) return( NULLNODE );               // very first entry
  clptr = &pp->clustersA[cluster].ctxtA[ctxel];
  noTypes = pp->templates[ntemp].noEvTypesInContext;
  for (j=0; j < noTypes; j++)  // for all levels
	 {tevent = (unsigned long) get_tim_regul(ntemp, j);
	  if (w.diag & 8)
		{sprintf(wf->wBuf, " tevent=%X", tevent);
		 wf->DisplayAndFile(wf->wBuf, 2);
	    }
	  if (tevent == NULLEVENT) return(NULLNODE);
	  while ((clptr->event.event != tevent) && (clptr->next != NULLLONG))
		 {ctxel = clptr->next;
		  clptr = &pp->clustersA[cluster].ctxtA[ctxel];
          testel = clptr->linkbk;
		  if (testel == NULLLONG) error_dec("\nNo link back for ctxel ",ctxel);
			testptr = &pp->clustersA[cluster].ctxtA[testel];
          if ((testptr->next != ctxel) && (testptr->next_list != ctxel))
            error_dec("\n**tsA*linkbk doesn't point to ctxel ", ctxel);
		 }
	  if ( clptr->event.event != tevent ) return( NULLNODE ); // no match
	  if (j < (noTypes-1))
		if (clptr->next_list != NULLLONG)
		  {ctxel = clptr->next_list;
		   clptr = &pp->clustersA[cluster].ctxtA[ctxel];
           testel = clptr->linkbk;
           if (testel == NULLLONG) error_dec("\nNo link back for ctxel ",ctxel);
             testptr = &pp->clustersA[cluster].ctxtA[testel];
           if ((testptr->next != ctxel) && (testptr->next_list != ctxel))
             error_dec("\n**tsA2*linkbk doesn't point to ctxel ", ctxel);
		  }
		else return( NULLNODE ); // incomplete match
	  if (j == (noTypes-1)) node = (short)clptr->next_list;
	 }
  if ((w.diag & 8) && (node != NULLNODE))
					wf->DisplayAndFile(" tree_searchA succeeds\n", 2);
  return ( node );
}

// ***** FUNCTION: tree_search_plus() *****
// USED BY: update_ltmA().
// DESCRIPTION: Searches given template LTM for a context matching STM.
//      Creates tree path, and context if they do not exist.
//  If a node has to be removed to get a new context-link while making
// a context, the context-making has to be started again from the start.
short tree_searchA_plus(short ntemp)
{ short j, noTypes, cluster, cycle_counter;
  short flag = 0;
  short node = NULLNODE;
  noTypes = pp->templates[ntemp].noEvTypesInContext;
  cycle_counter = noTypes * 2;
  cluster = pp->templates[ntemp].clust;
  if ( w.diag & 2 )
	{sprintf(wf->wBuf,"\nTree search+ temp=%s,%d types in ctxt ",
					template_names[ntemp],noTypes);
	 wf->DisplayAndFile(wf->wBuf, 2);
	}
  for (j=0; j<noTypes; j++)             // Check that context is in the STM.
	  if (get_tim_regul(ntemp, j) == NULLEVENT) {flag = 1; break; }
  if ( flag == 1 ) return( NULLNODE );  // Context not in STM
  if (w.diag & 2) wf->DisplayAndFile("\nContext is in STM.", 2);
  while ((node == NULLNODE) && (cycle_counter--))
	 {node = make_context_without_removing_nodesA(cluster,ntemp,noTypes);
	 }
  if (node == NULLNODE) error("Failed to create context without removing nodeA.");
  else return( node );
}
// If a node has been removed, ADD ONE and then multiply by -1,
// because -0 = 0.
// ***** FUNCTION: make_context_without_removing_nodesA *****
short make_context_without_removing_nodesA(short cluster, short ntemp,
													short noTypes)
{ short j, prtyp, cycle_counter, flag;
  short node = NULLNODE;
  unsigned long tevent;
  struct context_link *clptr, *testptr;
  long ctxel, backel, emptyel;
  ctxel = pp->templates[ntemp].base;
  backel = NULLLINK;  // Indicates pointing back to base
// If base is NULLLONG, then point root at new link.
  if ( ctxel == NULLLONG )
	 {flag = FALSE;
		if (pp->clustersA[cluster].empty_ctxtA_list == NULLLONG)
		  flag = TRUE;
		ctxel = newcontext_linkA(cluster);
		if (ctxel == NULLLONG) error("\nmcwrnA:No new ctxt link");
	  if (flag)
			{emptyel = pp->clustersA[cluster].empty_ctxtA_list;
			 pp->clustersA[cluster].empty_ctxtA_list = ctxel;
			 pp->clustersA[cluster].ctxtA[ctxel].next = emptyel;
			 return( NULLNODE ); // minus if node removed
			}
	  pp->templates[ntemp].base = ctxel;
	 }
  clptr = &pp->clustersA[cluster].ctxtA[ctxel];
  clptr->linkbk = backel;  // This is NULLLONG here.
  for (j=0; j<noTypes; j++)                 // for all types in context
	 {tevent = get_tim_regul(ntemp, j);   // event of j'th
	  prtyp = pp->templates[ntemp].eventdeftype[j]; // type  of j'th
	  if ( w.diag & 2 )
		{sprintf(wf->wBuf," Atype %d,event=%X ", prtyp, tevent);
		 wf->DisplayAndFile(wf->wBuf, 2);
		}
	  if ( clptr->event.event == NULLEVENT )  // Event not on list. Empty
		{clptr->event.event = tevent;
		 clptr->event.type = prtyp;
		 if ( w.diag & 2 )
			 wf->DisplayAndFile("\n**Atyp/ev inserted as first.", 2);
		}
	  else
		{while ( (clptr->next != NULLLONG) &&    // While no match & is another.
				  ((clptr->event.event != tevent) || (clptr->event.type != prtyp)))
			 {backel = ctxel;
			  ctxel = clptr->next;       // Look at the next
			  clptr = &pp->clustersA[cluster].ctxtA[ctxel];
			  clptr->linkbk = backel;
				  testptr = &pp->clustersA[cluster].ctxtA[backel];
				  if (testptr->next != ctxel)
					  error_dec("\n**mcwrnA*linkbk doesn't point to ctxel ", ctxel);
			 }
		 if ((clptr->event.event != tevent) || (clptr->event.type != prtyp))
			 {backel = ctxel;
			  flag = FALSE;
				  if (pp->clustersA[cluster].empty_ctxtA_list == NULLLONG)
					 flag = TRUE;
				  ctxel = newcontext_linkA(cluster);
				  if (ctxel == NULLLONG) error("\nmcwrnA2:No new ctxt link ");
				 if (flag)
					 {emptyel = pp->clustersA[cluster].empty_ctxtA_list;
					  pp->clustersA[cluster].empty_ctxtA_list = ctxel;
					  pp->clustersA[cluster].ctxtA[ctxel].next = emptyel;
					  return( NULLNODE ); // minus if node removed
					 }
			  clptr->next = ctxel;
			  clptr = &pp->clustersA[cluster].ctxtA[ctxel];
			  clptr->event.event = tevent;     // and put the event,type in it
			  clptr->event.type = prtyp;
			  clptr->next =  NULLLONG;
			  clptr->next_list =  NULLLONG;
			  clptr->linkbk = backel;
				  testptr = &pp->clustersA[cluster].ctxtA[backel];
				  if (testptr->next != ctxel)
					  error_dec("\n**mcwrnA2*linkbk doesn't point to ctxel ", ctxel);
			  if ( w.diag & 2 )
				{sprintf(wf->wBuf, "\nNew linkA with typ=%d,event=%X ",
															prtyp, tevent);
				 wf->DisplayAndFile(wf->wBuf, 2);
				}
			 }
		}    // At this point the event,type must have matched or been added.
	  if ((clptr->next_list == NULLLONG) && (j < (noTypes - 1))) //not last evt
		 {backel = ctxel;
		  flag = FALSE;
			 if (pp->clustersA[cluster].empty_ctxtA_list == NULLLONG)
				 flag = TRUE;
			 ctxel = newcontext_linkA(cluster);
			 if (ctxel == NULLLONG) error("\nmcwrnA3:No new ctxt link ");
			if (flag)
				{emptyel = pp->clustersA[cluster].empty_ctxtA_list;
				 pp->clustersA[cluster].empty_ctxtA_list = ctxel;
				 pp->clustersA[cluster].ctxtA[ctxel].next = emptyel;
				 return( NULLNODE ); // minus if node removed
				}
		  clptr->next_list = ctxel;
		  clptr = &pp->clustersA[cluster].ctxtA[ctxel];
		  clptr->linkbk = backel;
			 testptr = &pp->clustersA[cluster].ctxtA[backel];
			 if (testptr->next_list != ctxel)
				 error_dec("\n**mcwrnA3*linkbk doesn't point to ctxel ", ctxel);
		  if ( w.diag & 2 )
					 {sprintf(wf->wBuf, "\nNew list link to ctxel=%d ", ctxel);
					  wf->DisplayAndFile(wf->wBuf, 2);
					 }
		 }
	  else if ((clptr->next_list != NULLLONG) && (j < (noTypes - 1))) // not last
			 {backel = ctxel;
			  ctxel = clptr->next_list;     // 18aug99        // and link exists
			  clptr = &pp->clustersA[cluster].ctxtA[ctxel];
			  clptr->linkbk = backel;
				  testptr = &pp->clustersA[cluster].ctxtA[backel];
				  if (testptr->next_list != ctxel)
					  error_dec("\n**mcwrnA4*linkbk doesn't point to ctxel ", ctxel);
			  if ( w.diag & 2 )
				{sprintf(wf->wBuf, "\nList link exists to ctxel=%d ",ctxel);
				 wf->DisplayAndFile(wf->wBuf, 2);
				}
			 }
	  else if ((clptr->next_list == NULLLONG) && (j == (noTypes - 1))) //last evt
			 {flag = FALSE;
				  if (pp->clustersA[cluster].empty_assA_list == NULLNODE)
					  flag = TRUE;  // Node will have to be removed to get new one.
				  node = newnodeA(ntemp, NULLNODE); // No cnode yet
				  if (node == NULLNODE) error("\nmcwrnA:No new node link ");
				 if (flag)
					 {emptyel = pp->clustersA[cluster].empty_assA_list;
					  pp->clustersA[cluster].empty_assA_list = node;
					  pp->clustersA[cluster].assA[node].next = emptyel;
					  return( NULLNODE ); // minus if node removed
					 }
			  clptr->next_list = (long) node;
			  clptr->linkbk = backel;
				  testptr = &pp->clustersA[cluster].ctxtA[backel];
				  if ((testptr->next != ctxel) && (testptr->next_list != ctxel))
					  error_dec("\n**mcwrnA5*linkbk doesn't point to ctxel ", ctxel);
			  pp->clustersA[cluster].assA[node].ctxtel = ctxel;  // 4jan01
			  pp->clustersA[cluster].assA[node].step_last_used = s->step;
			  if ( w.diag & 2 )
				 {sprintf(wf->wBuf, "\nNew cntxt link to node=%d ",node);
				  wf->DisplayAndFile(wf->wBuf, 2);
				 }
			 }
	  else if ((clptr->next_list != NULLLONG) && (j == (noTypes - 1))) //last evt
			 {node = (short)clptr->next_list;     // 18aug99 // and context exists
				  pp->clustersA[cluster].assA[node].step_last_used = s->step;
				if ( w.diag & 2 )
					 {sprintf(wf->wBuf, "\nCntxt link exists to node=%d ",node);
					  wf->DisplayAndFile(wf->wBuf, 2);
					 }
			 }
	 }   // repeat the above until the context processed.
  if (!w.no_display_or_file)
	{wf->DisplayAndFile("TreeS+:", 2);
	 display_node(node, ntemp, 2);
	}
  return ( node );
}

// Returns TRUE if node has had to be removed.
short update_bkptr_without_removing_node(short cluster, long bkpt, short cnode, short lnode)
{ struct back_pointer *bkptr;
  long   empty_bkp;
  short  node_removed = FALSE;
  long   bkp = bkpt; // To isolate from calling program.
  bkptr = &pp->clustersA[cluster].bptr[bkp];
  while ((bkptr->node != lnode) && (bkptr->next != NULLLONG))
		{bkp = bkptr->next;
		 bkptr = &pp->clustersA[cluster].bptr[bkp];
		}
  if (bkptr->node != lnode) // Nothing to do if it is already on the list.
	 {if (pp->clustersA[cluster].empty_bkptr_list == NULLNODE)
			node_removed = TRUE; // Nothing on empty list so node has to be removed.
	  bkp = newbackpointer(cluster, cnode);
	  if (bkp == NULLLONG) error_dec("\nNo new back ptr for cnode ",cnode);
	  if (node_removed) // Put back on empty list
		 {empty_bkp = pp->clustersA[cluster].empty_bkptr_list;
		  pp->clustersA[cluster].empty_bkptr_list = bkp;
		  bkptr = &pp->clustersA[cluster].bptr[bkp];
		  bkptr->next = empty_bkp;
		 }
	  else
		 {bkptr->next = bkp;
		  bkptr = &pp->clustersA[cluster].bptr[bkp];
		  bkptr->node = lnode;
		  bkptr->next =  NULLLONG;
		  if ( w.diag & 2 )
			{sprintf(wf->wBuf,"\nNew bk-ptr from node %d to %d", cnode, lnode);
		     wf->DisplayAndFile(wf->wBuf, 2);
            }
		 }
	 }
  return( node_removed );
}



short update_prbptr_without_removing_node(short cluster, short ctemp,
                                    long lprb, short cnode, short lnode)
{ struct pointer_prob  *lprbptr;   // *fstprbptr;
  long lprob, empty_pprb;
  short  node_removed = FALSE;
  struct cluster_struct_A *clustptr;
  lprob = lprb; // Isolate from calling program.
  clustptr = &pp->clustersA[cluster];
  lprbptr = &clustptr->pprb[lprob];
  while ((lprbptr->node != cnode) && (lprbptr->next != NULLLONG))
			{lprob = lprbptr->next;
			lprbptr = &clustptr->pprb[lprob];
			}
	  if (lprbptr->node == cnode) lprbptr->prob += w.quantum;
	  else
		 {if (lprbptr->next != NULLLONG)
			  error_dec("\nlprbptr->next not null ", lprbptr->next);
		  if (clustptr->empty_pprb_list == NULLLONG)
			  node_removed = TRUE; // Nothing on empty list so node has to be removed.
		  lprob = newpointer_prob(cluster, cnode);
		  if (lprob == NULLLONG) error_dec("\nNo new pntr prob for lnode ",lnode);
		  if (node_removed) // Put new pt_prob back on empty list.
			 {empty_pprb = clustptr->empty_pprb_list;
			  clustptr->empty_pprb_list = lprob;
			  lprbptr = &clustptr->pprb[lprob];
			  lprbptr->next = empty_pprb;
			 }
		  else
			 {lprbptr->next = lprob;
			  lprbptr = &clustptr->pprb[lprob];
			  lprbptr->node = cnode;
			  lprbptr->prob = w.quantum;
			  lprbptr->next =  NULLLONG;
			 }
		 }
  if ( w.diag & 2 )
	{
     wf->DisplayAndFile("\nPtr-prob from node:", 2);
	 display_node(lnode, clustptr->assA[lnode].temp, 2);
	 wf->DisplayAndFile(" to node:", 2);
	 display_node(cnode, ctemp, 2);
	}
  return( node_removed);
}

void   store_heard_sound_as_action()
{ short cl, k, n, ttemp, prtyp, cnode;
  short valid_context;
  struct event_type current_event;
// For each action-predicting cluster:
  cl = CLSA;
////  for (cl=0; cl<pp->naclusters; cl++)                  // for each cluster
  if ( w.diag & 2 )
	 {sprintf(wf->wBuf,"\nUpdating Sound cluster %d. ", cl);
	  wf->DisplayAndFile(wf->wBuf, 2);
	 }
  valid_context = 0;
//    For each template in cluster until a matching association is found:
  for (k=0; k<pp->clustersA[cl].ntemps; k++)
	  {ttemp = pp->clustersA[cl].tem[k];
		if ( pp->templates[ttemp].acst != AC ) continue;
//		if ( w.diag & 2 )
//		  {sprintf(wf->wBuf," k/max=%d/%d ", k, pp->clustersA[cl].ntemps);
//			wf->DisplayAndFile(wf->wBuf, 2);
//		  }
		if ( w.diag & 2 )
		  {sprintf(wf->wBuf,"\nUpdating Sound clusterA %s,temp %s,npreds:%d ",
				cluster_namesA[cl],template_names[ttemp],pp->templates[ttemp].npreds);
			 wf->DisplayAndFile(wf->wBuf, 2);
		  }
//         For each associated event type which has a current event in STM:
		for (n=0; n<pp->templates[ttemp].npreds; n++)
			{prtyp = pp->templates[ttemp].predict_event_type[n];
			 if ( w.diag & 2 )
				{ sprintf(wf->wBuf," prtyp=%s ",event_type_names[prtyp]);
				  wf->DisplayAndFile(wf->wBuf, 2);
				}
			 if ( s->events[prtyp].tim_shift_reg[0] == NULLEVENT ) continue;
//            Find a matching context in STM.
			 cnode = tree_searchA_plus( ttemp );         // >>> TREE_SEARCH_PLUS
			 if ( cnode == NULLNODE ) continue;
			 else
				{
//           if ( w.diag & 2 )
//				  {sprintf(wf->wBuf,"\ntree searchA+ succeeds:temp=%d,cnode=%d ",
//														 ttemp,cnode);
//					wf->DisplayAndFile(wf->wBuf, 2);
//				  }
		// We now have a context in which to store the prediction
				 valid_context = 1;
				 current_event.event = s->events[prtyp].tim_shift_reg[0];  // see if OK
				 current_event.type = prtyp;
				 if ( w.diag & 2 )
					{sprintf(wf->wBuf,"\nUpdating temp%d,clstr%d,cnode%d with typ%d,evt%X ",
						ttemp, cl, cnode, current_event.type, current_event.event);
					 wf->DisplayAndFile(wf->wBuf, 2);
					}
//       Update association comprising context and associated event.
				 update_nodeA( cl, ttemp, cnode, current_event.type,
																current_event.event );
				 pp->clustersA[cl].last_event.event =  current_event.event;
				 pp->clustersA[cl].last_event.type  =  current_event.type;
				 pp->clustersA[cl].last_node      =  cnode;
				 break;  // No need to consider more than one prediction type
				}
			}     // end of template preds loop
		if ( valid_context ) break;     // No need to consider more than one template
	  }         // end of template loop
}


