// ppmemory.cpp        PURRPUSS.                        jha: 10aug98-25jly01

#include "c:\Program Files\Borland\CBuilder3\examples\foodrink\ppheader.hpp"

extern robot_info *s;     //  Global variables
extern pp_info *pp;
extern world w;
extern TWindFile  *wf;
extern char *event_type_names[];     // in ppworld.cpp
extern char *template_names[];       // in ppworld.cpp
extern char *cluster_namesA[];        // in ppworld.cpp
extern char *cluster_namesS[];        // in ppworld.cpp
extern char *stream_names[];         // in ppworld.cpp

// ***** FUNCTION: newnodeA() *****
// DESCRIPTION: Returns the number of a node.

short  newnodeA(short ntemp, short cnode) // returns ptr to context
{ short cluster, node;
  struct nodeA *nodeptr;
  cluster =  pp->templates[ntemp].clust;
  node = pp->clustersA[cluster].empty_assA_list;
  if (node >= pp->maxnodeA[cluster]) error_dec("\n**ncA*node exceeds max ",node);
  if (pp->clustersA[cluster].highest_node < node) //Needed for graph lines
	 pp->clustersA[cluster].highest_node = node;
  if ( node == NULLNODE ) // End of empty list, so delete a node
    {node = find_least_used_nodeA(cluster, cnode);
     if (w.diag & 2)
        {sprintf(wf->wBuf,"\nnewnodeA:Wiping nodeA %d in cluster %s",
                       node, cluster_namesA[cluster]);
         wf->DisplayAndFile(wf->wBuf, 0);
        }
     remove_nodeA(cluster, node); // Put on empty list
     nodeptr = &pp->clustersA[cluster].assA[node];
     pp->clustersA[cluster].empty_assA_list = nodeptr->next;
//   pp->clustersA[cluster].ctxtA[nodeptr->ctxtel].next_list = NULLLONG; //Not here
    }
  else
    {nodeptr = &pp->clustersA[cluster].assA[node];
     pp->clustersA[cluster].empty_assA_list = nodeptr->next;
    }
  nodeptr->expn  = 0;         /***INITIALISE DATA***/
  nodeptr->age   = 0;
  nodeptr->cntxt_no = node;
  nodeptr->temp = ntemp;
  nodeptr->pei   =  NULLLONG;
  nodeptr->back  =  NULLLONG;
  nodeptr->ctxtel  =  NULLLONG;
  nodeptr->next  =  NULLNODE;  //  Contexts linked only in empty-list.
  return( node );
}

short  newnodeS(short ntemp, short cnode) // returns ptr to context
{ short cluster, node;
  struct nodeS *nodeptr;
  cluster =  pp->templates[ntemp].clust;
  node = pp->clustersS[cluster].empty_assS_list;
  if (node >= pp->maxnodeS[cluster]) error_dec("\n**ncS*node exceeds max ",node);
  if (pp->clustersS[cluster].highest_node < node) // Needed for graph lines
    pp->clustersS[cluster].highest_node = node;
  if ( node == NULLNODE ) // New context is a deleted context.
    {node = find_least_used_nodeS(cluster, cnode);
     if (w.diag & 2)
       {sprintf(wf->wBuf,"\nnewnodeS:Wiping nodeS %d in cluster %s",
                                node, cluster_namesS[cluster]);
        wf->DisplayAndFile(wf->wBuf, 0);
       } 
     remove_nodeS(cluster, node); // Empty list isn't altered.
     nodeptr = &pp->clustersS[cluster].assS[node];
     pp->clustersS[cluster].empty_assS_list = nodeptr->next;
//   pp->clustersS[cluster].ctxtS[nodeptr->ctxtel].next_list = NULLLONG; // Not here.
    }
  else
    {nodeptr = &pp->clustersS[cluster].assS[node];
     pp->clustersS[cluster].empty_assS_list = nodeptr->next;
    }
  nodeptr->age   = 0;
  nodeptr->cntxt_no = node;
  nodeptr->temp = ntemp;
  nodeptr->pei   =  NULLLONG;
  nodeptr->next  =  NULLNODE;  // Contexts linked only in empty-list.
  return( node );
}

// ***** FUNCTION: newprediction() *****
// USED BY: update_cntxt()
// DESCRIPTION: SAME AS newlink()
// SIZE = 16 BYTES.

long  newpredictionA(short cluster, short cnode)
{ struct predictionA *peiptr;
  long pei;
  short node;
  pei = pp->clustersA[cluster].empty_prdA_list;
  if (pei >= pp->maxpredA[cluster] ) error_dec("\n**npA*pei exceeds max preds ",pei);
  while ( pei == NULLLONG )
	  {node = find_least_used_nodeA(cluster, cnode);
        if (w.diag & 2)
		  {sprintf(wf->wBuf,"\nnewpredictionA:Wiping nodeA %d in cluster %s",
                                          node, cluster_namesA[cluster]);
		   wf->DisplayAndFile(wf->wBuf, 0);
          } 
		remove_nodeA(cluster, node); // Put on empty list
		pei = pp->clustersA[cluster].empty_prdA_list;
        if (pei >= pp->maxpredA[cluster] ) error_dec("\n**npA*pei exceeds max preds ",pei);
	  }
  peiptr = &pp->clustersA[cluster].prdA[pei];
  pp->clustersA[cluster].empty_prdA_list = peiptr->next; // pt to rest of empty-list
  if (peiptr->next >= pp->maxpredA[cluster] )
    error_dec("\n***peiptr->next exceeds max predsA ",peiptr->next);
//  sprintf(wf->wBuf, "\n***NP empty_prdA_list = %d ",peiptr->next);
//  wf->DisplayAndFile(wf->wBuf, 0);
  if (w.diag & 2)
	 {sprintf(wf->wBuf, "\nNewpredictionA: empty_prdA_list =%d ",
									  pp->clustersA[cluster].empty_prdA_list);
	  wf->DisplayAndFile(wf->wBuf, 0);
	 }
  peiptr->expn  = 0;
  peiptr->age   = w.quantum;	// 26apr99  safer than letting an age ever = 0
  peiptr->reward_rate_f = 0;
  peiptr->reward_rate_d = 0;
  peiptr->novelty = 1;
  peiptr->disapproval = 0;
  peiptr->mark = NULLMARK;
  peiptr->event.type  = NULLTYPE;
  peiptr->event.event = NULLEVENT;
  peiptr->ptr_prob =  NULLLONG;
  peiptr->next     =  NULLLONG;
  return( pei );
}

long  newpredictionS(short cluster, short cnode)
{ struct predictionS *peiptr;
  long pei;
  short node;
  pei = pp->clustersS[cluster].empty_prdS_list;
  if (pei >= pp->maxpredS[cluster] ) error_dec("\n**npS*pei exceeds max preds ",pei);
  while ( pei == NULLLONG )
     {node = find_least_used_nodeS(cluster, cnode);
      if (w.diag & 2)
        {sprintf(wf->wBuf,"\nnewpredictionS:Wiping nodeS %d in cluster %s",
                                    node, cluster_namesS[cluster]);
         wf->DisplayAndFile(wf->wBuf, 0);
        } 
      remove_nodeS(cluster, node); // Put on empty list
      pei = pp->clustersS[cluster].empty_prdS_list;
      if (pei >= pp->maxpredS[cluster] ) error_dec("\n**npS2*pei exceeds max preds ",pei);
     }
  peiptr = &pp->clustersS[cluster].prdS[pei];
  pp->clustersS[cluster].empty_prdS_list = peiptr->next; // pt to rest of empty-list
  peiptr->age   = w.quantum;	// 26apr99  safer than letting an age ever = 0
  peiptr->event.type  = NULLTYPE;
  peiptr->event.event = NULLEVENT;
  peiptr->next      =  NULLLONG;
  return( pei );
}

// ***** FUNCTION: newpointer_probs() *****
long newpointer_prob(short cluster, short cnode)
{ struct pointer_prob *pbptr;
  long pprob;
  short node;
  pprob = pp->clustersA[cluster].empty_pprb_list;
  if (pprob >= pp->maxprobA[cluster]) error_dec("\n**npp*pprob exceeds max ",pprob);
  while ( pprob == NULLLONG )
     {node = find_least_used_nodeA(cluster, cnode);
      if (w.diag & 2)
        {sprintf(wf->wBuf,"\nnewpointer_prob:Wiping nodeA %d in cluster %s",
                                        node, cluster_namesA[cluster]);
          wf->DisplayAndFile(wf->wBuf, 0);
        }
      remove_nodeA(cluster, node); // Put on empty list
      pprob = pp->clustersA[cluster].empty_pprb_list;
     }
  pbptr = &pp->clustersA[cluster].pprb[pprob];
  pp->clustersA[cluster].empty_pprb_list = pbptr->next; // pt to rest of empty-list
  if (w.diag & 2)
	{sprintf(wf->wBuf, "\nNewpointer_prob: pprob=%d, ->node nulled,empty_pprb_list = %d ",
                         pprob, pp->clustersA[cluster].empty_pprb_list);
     wf->DisplayAndFile(wf->wBuf, 0);
//  display_array_pprb(cluster);
    }
  pbptr->prob     = 0;
  pbptr->node     =  NULLNODE;
  pbptr->next     =  NULLLONG;
  return( pprob );
}

// ***** FUNCTION: newbackpointer() *****
long newbackpointer(short cluster, short cnode)
{ struct back_pointer *bptr;
  long bp;
  short node;
  bp = pp->clustersA[cluster].empty_bkptr_list;
  if (bp >= pp->maxbkptA[cluster]) error_dec("\n**nbp*bpointer exceeds max ",bp);
  while ( bp == NULLLONG )
     {node = find_least_used_nodeA(cluster, cnode);
      if (w.diag & 2)
        {sprintf(wf->wBuf,"\nnewbackpointer:Wiping nodeA %d in cluster %s",
                                            node, cluster_namesA[cluster]);
	     wf->DisplayAndFile(wf->wBuf, 0);
        }
      remove_nodeA(cluster, node); // Put on empty list
      bp = pp->clustersA[cluster].empty_bkptr_list;
     }
  bptr = &pp->clustersA[cluster].bptr[bp];
  pp->clustersA[cluster].empty_bkptr_list = bptr->next;
  bptr->node =  NULLNODE;
  bptr->next =  NULLLONG;
  return( bp );
}

//void return_back_pointer(short cluster, long bkp)
//{ struct back_pointer *bptr;
//  long bp;
//  bp = pp->clustersA[cluster].empty_bkptr_list;
//  if (bp >= pp->maxbkptA[cluster]) error_dec("\n**rbp*bpointer exceeds max ",bp);
//  pp->clustersA[cluster].empty_bkptr_list = bkp;
//  bptr = &pp->clustersA[cluster].bptr[bkp];
//  bptr->next = bp;
//  bptr->node = (short) NULLNODE;
//  if ( w.diag & 2 )
//    {sprintf(wf->wBuf, "\nReturned bkp %d, empty list was to %d ",bkp,bp);
//     wf->DisplayAndFile(wf->wBuf, 0);
//    }
//  return;
//}


// ***** FUNCTION: newcontext_linkA *****
long newcontext_linkA(short cluster)
{ struct context_link *cptr;
  long ctx;
  short node;
  ctx = pp->clustersA[cluster].empty_ctxtA_list;
  if (ctx >= MAX_CONTEXT_LINKS_A) error_dec("\n**ncl*link exceeds max ", ctx);
  while ( ctx == NULLLONG )
	  {node = find_least_used_nodeA(cluster, NULLNODE); // No cnode yet
		if (w.diag & 2)
		  { //display_array_ctxtA();
			sprintf(wf->wBuf,"\nnewcontext_linkA:Removing least used nodeA %d ", node);
			wf->DisplayAndFile(wf->wBuf, 0);
		  }
		remove_nodeA(cluster, node); // Put on empty list
		if (w.diag & 2)
		  {sprintf(wf->wBuf,"\nnewcontext_linkA:Removed least used nodeA %d ", node);
			wf->DisplayAndFile(wf->wBuf, 0);
			//display_array_ctxtA();
		  }
		ctx = pp->clustersA[cluster].empty_ctxtA_list;
	  }
  if ( w.diag & 2 )
	 {sprintf(wf->wBuf, "\nNew context link %d ", ctx);
	  wf->DisplayAndFile(wf->wBuf, 0);
	 }
  cptr = &pp->clustersA[cluster].ctxtA[ctx];
  pp->clustersA[cluster].empty_ctxtA_list = cptr->next;
  cptr->event.event     = NULLEVENT;
  cptr->next            =  NULLLONG;
  cptr->next_list       =  NULLLONG;
  return( ctx );
}
// ***** FUNCTION: newcontext_linkS *****
long newcontext_linkS(short cluster)
{ struct context_link *cptr;
  long ctx;
  short node;
  ctx = pp->clustersS[cluster].empty_ctxtS_list;
//  if (pp->highest_ctxtS < ctx) pp->highest_ctxtS = ctx;
  while ( ctx == NULLLONG )
	  {node = find_least_used_nodeS(cluster, NULLNODE); // No cnode yet
		if (w.diag & 2)
		  { //display_array_ctxtS();
			sprintf(wf->wBuf,"\nnewcontext_linkS:Removing least used nodeS %d ", node);
			wf->DisplayAndFile(wf->wBuf, 0);
		  }
		remove_nodeS(cluster, node); // Put on empty list
	  if (w.diag & 2)
		  {sprintf(wf->wBuf,"\nnewcontext_linkS:Removed nodeS %d ", node);
			wf->DisplayAndFile(wf->wBuf, 0);
			//display_array_ctxtS();
		  }
		ctx = pp->clustersS[cluster].empty_ctxtS_list;
	  }
  cptr = &pp->clustersS[cluster].ctxtS[ctx];
  pp->clustersS[cluster].empty_ctxtS_list = cptr->next;
  cptr->event.event     = NULLEVENT;
  cptr->next            =  NULLLONG;
  cptr->next_list       =  NULLLONG;
  return( ctx );
}

short find_least_used_nodeA(short cluster, short cnode)
{ short k, lnode, least_used_node, next_least_used_node, random_node;
  short count = MAX_RANDOM_NODES;
  long oldest, next_oldest, last_used_step;
  struct cluster_struct_A *clustptr;
  oldest = next_oldest = s->step;
  least_used_node = NULLNODE;
  clustptr = &pp->clustersA[cluster];
  lnode =   lnode = clustptr->last_node;
  for (k=0; k < pp->clustersA[cluster].highest_node ; k++)
	 {last_used_step = clustptr->assA[k].step_last_used;
		if (last_used_step == NULLSTEP) continue;   // on empty list
		if (last_used_step < oldest)
		  {next_oldest = oldest;
			next_least_used_node = least_used_node;
			oldest = last_used_step;
			least_used_node = k;
		  }
        else if (last_used_step < next_oldest)
               {next_oldest = last_used_step;
                next_least_used_node = k;
               }
	  }
  if (no_conflict_with_current_and_last_nodesA(cluster, least_used_node,
										 cnode, lnode)) return( least_used_node );
  else if (no_conflict_with_current_and_last_nodesA(cluster,
			next_least_used_node, cnode, lnode)) return( next_least_used_node );
  else
    while (count)
      {random_node = random(pp->maxnodeA[cluster]);
       while (clustptr->assA[random_node].step_last_used == NULLSTEP)
         {random_node = random(pp->maxnodeA[cluster]);
          wf->DisplayAndFile("\nRandom node has null step.", 0);
         }
       if (no_conflict_with_current_and_last_nodesA(cluster,
		                                  random_node, cnode, lnode))
         {sprintf(wf->wBuf,"\nDeleting random_node=%d", random_node);
          wf->FileOnly(wf->wBuf);
          return( random_node );
         }
      }
  sprintf(wf->wBuf,"\ncnode=%d,lnode=%d,least_used_node=%d,next_least_used_node=%d",
								  cnode, lnode, least_used_node, next_least_used_node);
  wf->DisplayAndFile(wf->wBuf, 0);
  error_2dec("nodes conflict with current and last nodesA: ",
												  least_used_node, next_least_used_node);
  return( NULLNODE );  // Never gets here.
}

// Returns TRUE if no conflict current or last node
short  no_conflict_with_current_and_last_nodesA(short cluster,
								short test_node, short cnode, short lnode)
{ long pei, pprob, bp;
  struct predictionA *peiptr;
  struct cluster_struct_A *clustptr;
  struct pointer_prob *pbptr;
  struct back_pointer *bptr;
  if ((test_node == cnode) || (test_node == lnode)) return( FALSE );
  clustptr = &pp->clustersA[cluster];
  pei = clustptr->assA[test_node].pei;
  if (pei >= pp->maxpredA[cluster] ) error_dec("\n**nc*pei exceeds max preds ",pei);
  while (pei != NULLLONG)  // Check nodes pointed to by ptr-probs.
	{peiptr = &clustptr->prdA[pei];
	 pprob = clustptr->prdA[pei].ptr_prob;
     if (pprob >= pp->maxprobA[cluster])
        error_2dec("\nncwclnA:pprob exceeds max for pei",pprob,pei);
	 while (pprob != NULLLONG)
	   {pbptr = &clustptr->pprb[pprob];
		if (pbptr->node == NULLNODE)
           error_2dec("\npbptr->node is null:pprob,pei",pprob,pei);
		if ((pbptr->node == cnode) || (pbptr->node == lnode))
          {sprintf(wf->wBuf,"\nClash:test_node=%d,cnode=%d,lnode=%d,pbptr->node=%d ",
								 test_node, cnode, lnode, pbptr->node);
           wf->DisplayAndFile(wf->wBuf, 0);
		   return( FALSE );
          }
		pprob = pbptr->next;
	   }
	 pei = peiptr->next;
     if (pei >= pp->maxpredA[cluster] ) error_dec("\n**nc**pei exceeds max preds ",pei);
	}
  bp = clustptr->assA[test_node].back;
  while (bp != NULLLONG)
	{bptr = &clustptr->bptr[bp];
	 if (bptr->node == NULLNODE) error("\nBack-pointer to null node.");
	 if ((bptr->node == cnode) || (bptr->node == lnode))
       {sprintf(wf->wBuf,"\nClash:test_node=%d,cnode=%d,lnode=%d,bptr->node=%d ",
							  test_node, cnode, lnode, bptr->node);
        wf->DisplayAndFile(wf->wBuf, 0);
		return( FALSE );
       }
	 bp = bptr->next;
	}
  return( TRUE );   // No conflict
}

// Conflict doesn't arise with these because there are no ptr-probs, bpointers.
short find_least_used_nodeS(short cluster, short cnode)
{ short k, least_used_node, next_least_used_node;
  long oldest, next_oldest, last_used_step;
  oldest = s->step;
  for (k=0; k < pp->clustersS[cluster].highest_node ; k++)
	 {last_used_step = pp->clustersS[cluster].assS[k].step_last_used;
		if (last_used_step == NULLSTEP) continue;   // on empty list
		if (last_used_step < oldest)
		  {next_oldest = oldest;
		   next_least_used_node = least_used_node;
		   oldest = last_used_step;
		   least_used_node = k;
		  }
        else if (last_used_step < next_oldest)
               {next_oldest = last_used_step;
                next_least_used_node = k;
               }
	  }
  return( least_used_node );
}

// (node = node to be deleted)
// Put node on empty list
void remove_nodeA(short cluster, short node)
{ struct cluster_struct_A *clustptr;
	struct nodeA *nodeptr;
	long empty_node;
	short temp;
	if (w.diag & 2)
	 {sprintf(wf->wBuf, "\nRemoving nodeA %d ", node);
	  wf->DisplayAndFile(wf->wBuf, 0);
	 }
	clustptr = &pp->clustersA[cluster];
	nodeptr = &clustptr->assA[node];
	remove_predictionsA(cluster, clustptr, node);
	remove_back_pointers(cluster, clustptr, node);
	empty_node = clustptr->empty_assA_list;
	clustptr->empty_assA_list = node;
	nodeptr->next = empty_node;
	nodeptr->expn = 0;
	nodeptr->age = 0;
	nodeptr->step_last_used = NULLSTEP;
	nodeptr->pei   =  NULLLONG;
	nodeptr->back  =  NULLLONG;
//	if (w.diag & 2) display_array_ctxtA();
	remove_free_context_links_from_nodeA(nodeptr->temp, node, nodeptr->ctxtel);
	nodeptr->ctxtel =  NULLLONG;
    if (clustptr->empty_prdA_list >= pp->maxpredA[cluster] )
     error_dec("\n**rnA2*empty_prdA_list exceeds max preds ",clustptr->empty_prdA_list);
  if (w.diag & 2)
	 {sprintf(wf->wBuf,"\nremoved nodeA %d cluster %d ", node, cluster);
	  wf->DisplayAndFile(wf->wBuf, 0);
	  //display_array_assA();
	 }
	return;
}

void remove_nodeS(short cluster, short node)
{ struct cluster_struct_S *clustptr;
  struct nodeS *nodeptr;
  long empty_node;
  if (w.diag & 2)
	 {//display_array_assS();
	  sprintf(wf->wBuf,"\nremoving nodeS %d cluster %d ", node, cluster);
	  wf->DisplayAndFile(wf->wBuf, 0);
	 }
  clustptr = &pp->clustersS[cluster];
  nodeptr = &clustptr->assS[node];
  remove_predictionsS(cluster, clustptr, node);
  empty_node = clustptr->empty_assS_list;
  clustptr->empty_assS_list = node;
  if (clustptr->empty_prdS_list >= pp->maxpredS[cluster] )
     error_dec("\n**rnS*empty_prdS_list exceeds max preds ",clustptr->empty_prdS_list);
  nodeptr->next = empty_node;
  nodeptr->age = 0;
  nodeptr->step_last_used = NULLSTEP;
  nodeptr->pei   =  NULLLONG;
//  if (w.diag & 2) display_array_ctxtS();
  remove_free_context_links_from_nodeS(nodeptr->temp, node, nodeptr->ctxtel);
  nodeptr->ctxtel  =  NULLLONG;
  if (clustptr->empty_prdS_list >= pp->maxpredS[cluster] )
     error_dec("\n**rnS2*empty_prdS_list exceeds max preds ",clustptr->empty_prdS_list);
  if (w.diag & 2)
	 {sprintf(wf->wBuf,"\nremoved nodeS %d cluster %d ", node, cluster);
	  wf->DisplayAndFile(wf->wBuf, 0);
	  //display_array_assS();
	 }
  return;
}

// Put predictions on empty list
void remove_predictionsA(short cluster, struct cluster_struct_A *clustptr,
                                                            short node)
{ struct predictionA *peiptr;
  long pei, empty_pei;
  if (w.diag & 2)
	 {sprintf(wf->wBuf, "\nRemoving predictions from action node %d ", node);
	  wf->DisplayAndFile(wf->wBuf, 0);
	 }
  pei = clustptr->assA[node].pei;
  if (pei >= pp->maxpredA[cluster] ) error_dec("\n**rp*pei exceeds max preds ",pei);
  while (pei != NULLLONG)
		 {peiptr = &clustptr->prdA[pei];
		  if (peiptr->event.event != NULLEVENT)
			  remove_pointer_probs(clustptr, node, pei);
		  empty_pei = clustptr->empty_prdA_list;
		  clustptr->empty_prdA_list = pei;
          if (pei >= pp->maxpredA[cluster] ) error_dec("\n**rp1*pei exceed max preds ",pei);
		  clustptr->assA[node].pei = peiptr->next;
		  pei = peiptr->next;
          if (pei >= pp->maxpredA[cluster] ) error_dec("\n**rp2*pei exceeds max preds ",pei);
		  peiptr->next = empty_pei;
		  peiptr->age  = 0;
		  peiptr->expn = 0;
		  peiptr->event.type  = NULLTYPE;
		  peiptr->event.event = NULLEVENT;
		  peiptr->ptr_prob =  NULLLONG;
		  peiptr->reward_rate_f = 0;
		  peiptr->reward_rate_d = 0;
		  peiptr->novelty =  0;
		  peiptr->disapproval =  0;
		  peiptr->mark =  NULLMARK;
		  if (w.diag & 2)
			{sprintf(wf->wBuf, "\nRemoving predAs empty_prdA_list =%d ",
												 clustptr->empty_prdA_list);
			 wf->DisplayAndFile(wf->wBuf, 0);
			}
		 }
  return;
}

// Put predictions on empty list
void remove_predictionsS(short cluster, struct cluster_struct_S *clustptr,
                                                          short node)
{ struct predictionS *peiptr;
  long pei, empty_pei;
  if (w.diag & 2)
	 {sprintf(wf->wBuf, "\nRemoving predictions from stimulus node %d ", node);
	  wf->DisplayAndFile(wf->wBuf, 0);
	 }
  pei = clustptr->assS[node].pei;
  if (pei >= pp->maxpredS[cluster] ) error_dec("\n**rps*pei exceeds max preds ",pei);
  while (pei != NULLLONG)
		 {peiptr = &clustptr->prdS[pei];
		  empty_pei = clustptr->empty_prdS_list;
		  clustptr->empty_prdS_list = pei;
          if (pei >= pp->maxpredS[cluster] ) error_dec("\n**rps1*pei exceeds max preds ",pei);
		  clustptr->assS[node].pei = peiptr->next;
		  pei = peiptr->next;
          if (pei >= pp->maxpredS[cluster] ) error_dec("\n**rps2*pei exceeds max preds ",pei);
		  peiptr->next = empty_pei;
		  peiptr->age  = 0;
		  peiptr->event.type  = NULLTYPE;
		  peiptr->event.event = NULLEVENT;
		 }
  return;
}

// Remove pointer-probs from prediction
void remove_pointer_probs(struct cluster_struct_A *clustptr,
						  						 short node, long ppei)
{ struct pointer_prob *pbptr;
  long pprob, pei, empty_pprob;
  if (w.diag & 2)
	 {sprintf(wf->wBuf, "\nRemoving ptr-probs from pei=%d of node %d ",pei, node);
	  wf->DisplayAndFile(wf->wBuf, 0);
	 }
  pei = ppei;  // To isolate routine from calling program
  pprob = clustptr->prdA[pei].ptr_prob;
  while (pprob != NULLLONG)
	   {pbptr = &clustptr->pprb[pprob];
		if (pbptr->node == NULLNODE)
           error_2dec("\npbptr->node is null, pprob=,pei= ",pprob,pei);
		if (pbptr->node != node)  // self-pointing node
           remove_far_back_pointer(clustptr, node, pprob);
		empty_pprob = clustptr->empty_pprb_list;
		clustptr->empty_pprb_list = pprob;
		clustptr->prdA[pei].ptr_prob = pbptr->next;
		pprob = pbptr->next;
		pbptr->next = empty_pprob;
		pbptr->node = NULLNODE;
        pbptr->prob = 0;
        sprintf(wf->wBuf, "\n**Removeptr_prb: pprob=%d has node nulled + put on empty",
                                         clustptr->empty_pprb_list );
        wf->DisplayAndFile(wf->wBuf, 0);
	   }
  return;
}

// Should only be used in remove_node procedure, where all
// forward pointers to the node are being removed.
void remove_far_back_pointer(struct cluster_struct_A *clustptr,
                                               short node, long pprb)
{ struct back_pointer *bkptr;
	short farnode;
	long bp, pprob, lastbp, empty_bp;
    pprob = pprb;  // isolation
    if (pprob == NULLLONG) error("\nremovefbp:pprob is null ");
	farnode = clustptr->pprb[pprob].node;
	if (farnode == node) return;   // self-pointer   ***redundant***
	if (w.diag & 2)
	  {sprintf(wf->wBuf, "\nRemoving far bptr from %d to %d", farnode, node);
		wf->DisplayAndFile(wf->wBuf, 0);
	  }
	bp = clustptr->assA[farnode].back;
	if (bp == NULLLONG) return;    // no backpointers
	bkptr = &clustptr->bptr[bp];
	if (bkptr->node == node)
	  {clustptr->assA[farnode].back = bkptr->next;
		 empty_bp = clustptr->empty_bkptr_list;
		 clustptr->empty_bkptr_list = bp;  // Insert bp in empty list
		 bkptr->next = empty_bp;
		 bkptr->node = NULLNODE;
		 if (w.diag & 2)
			{sprintf(wf->wBuf, "\nRemoving fst bptr to %d", node);
			 wf->DisplayAndFile(wf->wBuf, 0);
			}
		 return;
	  }
	while ((bp != NULLLONG) && (bkptr->node != node)) // Skip over non-matches
			 {lastbp = bp;
			  bp = bkptr->next;
			  if (w.diag & 2)
				 {sprintf(wf->wBuf, "\nNot matching bptr %d", bkptr->node);
				  wf->DisplayAndFile(wf->wBuf, 0);
				 }
              if (bp != NULLLONG) bkptr = &clustptr->bptr[bp];
			 }
	if (bkptr->node == node)  // Can't be first so lastbp will be set
	  {clustptr->bptr[lastbp].next = bkptr->next; // branching over
		if (w.diag & 2)
			{sprintf(wf->wBuf, "\nRemoving matching bptr to %d", bkptr->node);
			 wf->DisplayAndFile(wf->wBuf, 0);
			}
		empty_bp = clustptr->empty_bkptr_list;
		clustptr->empty_bkptr_list = bp;
		bkptr->next = empty_bp;
		bkptr->node = NULLNODE;
	  }
	return;
}

void   remove_back_pointers(short cluster, struct cluster_struct_A *clustptr,
                                                           short node)
{ struct back_pointer *bptr;
  long bp, empty_bp;
  wf->DisplayAndFile("\nremove-back-pointers ", 0);
  bp = clustptr->assA[node].back;
  while (bp != NULLLONG)
		 {bptr = &clustptr->bptr[bp];
		  if (bptr->node == NULLNODE) error("\nBack-pointer to null node.");
		  if (w.diag & 2)
			 {sprintf(wf->wBuf,"\nRemoving bptr from %d to %d", node, bptr->node);
			  wf->DisplayAndFile(wf->wBuf, 0);
			 }
		  if (node != bptr->node)    // If not pointing to itself
			 remove_forward_pointers(cluster, clustptr, node, bptr->node);
		  empty_bp = clustptr->empty_bkptr_list;
		  clustptr->empty_bkptr_list = bp;
		  clustptr->assA[node].back = bptr->next;
		  bp = bptr->next;
		  bptr->next = empty_bp;
		  bptr->node = NULLNODE;
		 }
  return;
}

void  remove_forward_pointers(short cluster, struct cluster_struct_A *clustptr,
                                           short node, short backnode)
{ struct predictionA *peiptr;
  struct pointer_prob *pbptr;
  long pei, pprob, empty_pprob, last_pprob;
  if (w.diag & 2)
	 {sprintf(wf->wBuf, "\nRemoving forward ptrs from %d to %d", backnode, node);
	  wf->DisplayAndFile(wf->wBuf, 0);
	 }
  pei = clustptr->assA[backnode].pei;
  if (pei >= pp->maxpredA[cluster] ) error_dec("\n**rfp*pei exceeds max preds ",pei);
  while (pei != NULLLONG)
	{peiptr = &clustptr->prdA[pei];
	 pprob = peiptr->ptr_prob;                  //     pprob-1
	 if (pprob == NULLLONG)    // No more for this pei.
        {pei = peiptr->next;
         continue;
        }
	 pbptr = &clustptr->pprb[pprob];         //     pbptr-1
	 if (pbptr->node == node)       // First matches    node-1
		{if (w.diag & 2)
			{sprintf(wf->wBuf, "\nFst ptr to node %d matches so branch over ", node);
				 wf->DisplayAndFile(wf->wBuf, 0);
			}
		 clustptr->prdA[pei].ptr_prob = pbptr->next; // pei pts to pprob-2
		 empty_pprob = clustptr->empty_pprb_list;
		 clustptr->empty_pprb_list = pprob;     // empty points to pprob-1
		 pbptr->next = empty_pprob;          // empty -> pprob-1 -> old empty
		 pbptr->node = NULLNODE;             // pprob-1's node-1 is nulled.
		 sprintf(wf->wBuf, "\n**Removefptrs: pprob=%d has node nulled + put on empty",
													  clustptr->empty_pprb_list );
		 wf->DisplayAndFile(wf->wBuf, 0);
		}
	 else  // First doesn't match  node-1 doesn't match node
		{last_pprob = pprob;  // Set last-pprob to node-1, which hasn't matched
		 pprob = pbptr->next; // pprob is now pprob-2
		 if (pprob == NULLLONG)   // No more for this pei.
            {pei = peiptr->next;
             continue;   // (OK for while)
            }
		 pbptr = &clustptr->pprb[pprob];  // pbptr-2
		 while ((pbptr->node != node) && (pprob != NULLLONG)) // node-2 doesn't match
			 {last_pprob = pprob;   // Set last-pprob to node-2.
			  pprob = pbptr->next;  // pprob is now pprob-3.
			  if (pprob != NULLLONG) pbptr = &clustptr->pprb[pprob]; // pbptr-3
			 }
		 if (pprob == NULLLONG)  // No more for this pei.
            {pei = peiptr->next;
             continue;   // For the first "while"
            }
		 if (pbptr->node == node) // As it must: node_3, say, does match
		   {clustptr->pprb[last_pprob].next = pbptr->next; //2 pts to 4 or null.
		   	empty_pprob = clustptr->empty_pprb_list; // current head of empty
		   	clustptr->empty_pprb_list = pprob;  // empty now pts to pprob-3
		   	pbptr->next = empty_pprob; // pprob-3 pts to rest of empty list
		   	pbptr->node = NULLNODE;    // node-3 is nulled as it is on empty list
            pbptr->prob = 0;
		   	sprintf(wf->wBuf, "\n**Removefptrs2: pprob=%d has node nulled + put on empty",
										  clustptr->empty_pprb_list );
			wf->DisplayAndFile(wf->wBuf, 0);
		   }
		}
	  pei = peiptr->next;
	  if (pei >= pp->maxpredA[cluster] ) error_dec("\n**rfp2*pei exceeds max preds ",pei);
	}
  return;
}

void remove_free_context_links_from_nodeA(short temp, short node,
                                                         long ctxtel)
{ struct context_link *clptr, *blptr;
  long backel, nextel, emptyel, bknextel;
  short cluster;
  if (w.diag & 2)
	 {sprintf(wf->wBuf,"\nRemoving ctxt link to nodeA:temp=%d,node=%d,ctxtel=%d",
																		 temp,node,ctxtel);
	  wf->DisplayAndFile(wf->wBuf, 2);
	 }
  cluster = pp->templates[temp].clust;
  clptr = &pp->clustersA[cluster].ctxtA[ctxtel];
  nextel = clptr->next;
  if (clptr->next_list != (long) node)
	 error_2dec("clptr->next_list is not nodeA", clptr->next_list, node);
  backel = clptr->linkbk;
  if (w.diag & 2)
	 {sprintf(wf->wBuf,"\n**rfclnA*cluster=%d,node=%d,ctxtel=%d,nextel=%d,backel=%d",
									   cluster, node, ctxtel, nextel, backel);
	  wf->DisplayAndFile(wf->wBuf, 2);
	 }
 if (backel == NULLLONG)   // Pointing at base
	  {if (pp->templates[temp].base != ctxtel)
		  error_dec("Context linkA shouldn't belong to empty list ", ctxtel);
		emptyel = pp->clustersA[cluster].empty_ctxtA_list;
		pp->clustersA[cluster].empty_ctxtA_list = ctxtel;
		clptr->next = emptyel;
		pp->templates[temp].base = nextel;
		clptr->linkbk =  NULLLONG;
		clptr->event.event = NULLEVENT;
		if (nextel != NULLLONG)
          pp->clustersA[cluster].ctxtA[nextel].linkbk =  NULLLONG; // to point to base
		return;              // Root link removed
	  }
  blptr = &pp->clustersA[cluster].ctxtA[backel];
  emptyel = pp->clustersA[cluster].empty_ctxtA_list;
  pp->clustersA[cluster].empty_ctxtA_list = ctxtel;
  clptr->next = emptyel;
  if (w.diag & 2)
	 {sprintf(wf->wBuf,"\n**rfclnA*emptyel=%d,blptr->next=%d,blptr->next_list=%d",
                                emptyel, blptr->next, blptr->next_list);
	  wf->DisplayAndFile(wf->wBuf, 2);
	 }
  if (blptr->next == ctxtel)
	 {blptr->next = nextel; // nextel may be NULLLONG
	  if (nextel != NULLLONG) pp->clustersA[cluster].ctxtA[nextel].linkbk = backel;
	 }
  else if (blptr->next_list == ctxtel)
		 {blptr->next_list = nextel;
		  if (nextel != NULLLONG) pp->clustersA[cluster].ctxtA[nextel].linkbk = backel;
         }
  else error_dec("Back linkA or base not pointing to ctxtel", backel);
  clptr->next_list =  NULLLONG;
  clptr->linkbk =  NULLLONG;
  clptr->event.event = NULLEVENT;
  if (blptr->next_list == NULLLONG) remove_context_linkA_if_free(temp, backel);
}

void remove_free_context_links_from_nodeS(short temp, short node,
                                                          long ctxtel)
{ struct context_link *clptr, *blptr;
  long backel, nextel, emptyel, bknextel;
  short cluster;
  if (w.diag & 2)
    {sprintf(wf->wBuf,"\nRemoving ctxt link to nodeS:temp=%d,node=%d,ctxtel=%d",
                                                       temp,node,ctxtel);
     wf->DisplayAndFile(wf->wBuf, 2);
    }
  if (ctxtel >= MAX_CONTEXT_LINKS_S) error_dec("\n***ctxtel exceeds max links", ctxtel);
  cluster = pp->templates[temp].clust;
  clptr = &pp->clustersS[cluster].ctxtS[ctxtel];
  nextel = clptr->next;
  if (nextel >= MAX_CONTEXT_LINKS_S) error_dec("\n***nextel exceeds max links", ctxtel);
  if (clptr->next_list != (long) node)
    error_2dec("clptr->next_list is not nodeS", clptr->next_list, node);
  backel = clptr->linkbk;
  if (backel == NULLLONG)   // Pointing at base
     {if (pp->templates[temp].base != ctxtel)
        error_dec("Context linkS shouldn't belong to empty list ", ctxtel);
      emptyel = pp->clustersS[cluster].empty_ctxtS_list;
      pp->clustersS[cluster].empty_ctxtS_list = ctxtel;
      clptr->next = emptyel;
      pp->templates[temp].base = nextel;
      clptr->linkbk =  NULLLONG;
      clptr->event.event = NULLEVENT;
      if (nextel != NULLLONG)
        pp->clustersS[cluster].ctxtS[nextel].linkbk =  NULLLONG; // to point to base
      if (pp->clustersS[cluster].empty_prdS_list >= pp->maxpredS[cluster])
        error_dec("\n**rfcls1*empty_prdS_list > max preds ",
                           pp->clustersS[cluster].empty_prdS_list);
      return;              // Root link removed
     }
  if (backel >= MAX_CONTEXT_LINKS_S) error_dec("\n***backel exceeds max links", backel);
  blptr = &pp->clustersS[cluster].ctxtS[backel];
  emptyel = pp->clustersS[cluster].empty_ctxtS_list;
  if (emptyel >= MAX_CONTEXT_LINKS_S) error_dec("\n***emptyel exceeds max links", emptyel);
  pp->clustersS[cluster].empty_ctxtS_list = ctxtel;
  clptr->next = emptyel;
  if (blptr->next == ctxtel)
    {blptr->next = nextel; // nextel may be NULLLONG
     if (nextel != NULLLONG) pp->clustersS[cluster].ctxtS[nextel].linkbk = backel;
    }
  else if (blptr->next_list == ctxtel)
          {blptr->next_list = nextel;
           if (nextel != NULLLONG) pp->clustersS[cluster].ctxtS[nextel].linkbk = backel;
          }
  else error_dec("Back linkS or base not pointing to ctxtel", backel);
  if (pp->clustersS[cluster].empty_prdS_list >= pp->maxpredS[cluster])
     error_dec("\n**rfcls3*empty_prdS_list > max preds ",
                           pp->clustersS[cluster].empty_prdS_list);
  clptr->next_list =  NULLLONG;
  clptr->linkbk =  NULLLONG;
  clptr->event.event = NULLEVENT;
  if (blptr->next_list == NULLLONG) remove_context_linkS_if_free(temp, backel);
  if (pp->clustersS[cluster].empty_prdS_list >= pp->maxpredS[cluster])
     error_dec("\n**rfcls4*empty_prdS_list > max preds ",
                           pp->clustersS[cluster].empty_prdS_list);
}

void remove_context_linkA_if_free(short temp, long ctxtel)
{ struct context_link *clptr, *blptr;
  long backel, nextel, nextlistel, emptyel;
  short cluster;
  if (w.diag & 2)
    {sprintf(wf->wBuf,"\nRemoving ctxt linkA:temp=%d,ctxtel=%d",temp,ctxtel);
     wf->DisplayAndFile(wf->wBuf, 2);
    }
  if (ctxtel >= MAX_CONTEXT_LINKS_A) error_dec("\n**rclfA*ctxtel exceeds max links", ctxtel);
  cluster = pp->templates[temp].clust;
  clptr = &pp->clustersA[cluster].ctxtA[ctxtel];
  nextel = clptr->next;
  if (clptr->next_list != NULLLONG)
    error_dec("Shouldn't have reached here.", ctxtel);
  backel = clptr->linkbk;
  if (backel == NULLLONG)   // Pointing at base
     {if (pp->templates[temp].base != ctxtel)
        error_dec("Context linkA shouldn't belong to empty list ", ctxtel);
      emptyel = pp->clustersA[cluster].empty_ctxtA_list;
      pp->clustersA[cluster].empty_ctxtA_list = ctxtel;
      clptr->next = emptyel;
      pp->templates[temp].base = nextel;
      clptr->linkbk =  NULLLONG;
      clptr->event.event = NULLEVENT;
      if (nextel != NULLLONG)
         pp->clustersA[cluster].ctxtA[nextel].linkbk =  NULLLONG; // to point to base
      return;              // Root link removed
     }
  blptr = &pp->clustersA[cluster].ctxtA[backel];
  emptyel = pp->clustersA[cluster].empty_ctxtA_list;
  pp->clustersA[cluster].empty_ctxtA_list = ctxtel;
  clptr->next = emptyel;
  if (blptr->next == ctxtel)
    {blptr->next = nextel; // nextel may be NULLLONG
     if (nextel != NULLLONG) pp->clustersA[cluster].ctxtA[nextel].linkbk = backel;
    }
  else if (blptr->next_list == ctxtel)
          {blptr->next_list = nextel;
           if (nextel != NULLLONG) pp->clustersA[cluster].ctxtA[nextel].linkbk = backel;
          }
//  else if (pp->templates[temp].base == ctxtel)  Not possible unless
//          {pp->templates[temp].base = nextel;   backel == NULLLONG
//           if (nextel == NULLLONG)
//              error_dec("\nDestroying root of Atree for temp ", temp);
//          }
  else error_dec("Back linkA or base not pointing at ctxtel", backel);
  clptr->linkbk =  NULLLONG;
  clptr->event.event = NULLEVENT;
  if (blptr->next_list == NULLLONG)
     remove_context_linkA_if_free(temp, backel);
}

void remove_context_linkS_if_free(short temp, long ctxtel)
{ struct context_link *clptr, *blptr;
  long backel, nextel, nextlistel, emptyel;
  short cluster;
  if (w.diag & 2)
    {sprintf(wf->wBuf,"\nRemoving ctxt linkS:temp=%d,ctxtel=%d",temp,ctxtel);
     wf->DisplayAndFile(wf->wBuf, 2);
    }
  if (ctxtel >= MAX_CONTEXT_LINKS_S) error_dec("\n**rclfS*ctxtel exceeds max links", ctxtel);
  cluster = pp->templates[temp].clust;
  clptr = &pp->clustersS[cluster].ctxtS[ctxtel];
  nextel = clptr->next;
  if (clptr->next_list != NULLLONG)
    error_dec("Shouldn't have reached here.", ctxtel);
  backel = clptr->linkbk;
  if (backel == NULLLONG)
     {if (pp->templates[temp].base != ctxtel)
        error_dec("Context linkS shouldn't belong to empty list ", ctxtel);
      emptyel = pp->clustersS[cluster].empty_ctxtS_list;
      pp->clustersS[cluster].empty_ctxtS_list = ctxtel;
      clptr->next = emptyel;
      pp->templates[temp].base = nextel;
      clptr->linkbk =  NULLLONG;
      clptr->event.event = NULLEVENT;
      if (nextel != NULLLONG)
         pp->clustersS[cluster].ctxtS[nextel].linkbk =  NULLLONG; // to point to base
      return;        // Root link removed
     }
  blptr = &pp->clustersS[cluster].ctxtS[backel];
  emptyel = pp->clustersS[cluster].empty_ctxtS_list;
  pp->clustersS[cluster].empty_ctxtS_list = ctxtel;
  clptr->next = emptyel;
  if (blptr->next == ctxtel)
    {blptr->next = nextel; // nextel may be NULLLONG
     if (nextel != NULLLONG) pp->clustersS[cluster].ctxtS[nextel].linkbk = backel;
    }
  else if (blptr->next_list == ctxtel)
          {blptr->next_list = nextel;
           if (nextel != NULLLONG) pp->clustersS[cluster].ctxtS[nextel].linkbk = backel;
          }
//  else if (pp->templates[temp].base == ctxtel)
//         {pp->templates[temp].base = NULLLONG;
//           if (nextel == NULLLONG)
//              error_dec("\nDestroying root of Stree for temp ", temp);
//         }
  else error_dec("Back linkS or base not pointing at ctxtel", backel);
  clptr->linkbk =  NULLLONG;
  clptr->event.event = NULLEVENT;
  if (blptr->next_list == NULLLONG)
     remove_context_linkS_if_free(temp, backel);
}


