// pppreda.cpp   PURRPUSS  Dev.from C.B.Gunn 22/4/93  jha:15aug98-26jly01

#include "c:\Program Files\Borland\CBuilder3\examples\foodrink\ppheader.hpp"

extern robot_info *s;
extern pp_info *pp;
extern world w;
extern TWindFile	*wf;
extern char *event_type_names[];     // in ppworld.cpp
extern char *template_names[];       // in ppworld.cpp
extern char *cluster_namesA[];        // in ppworld.cpp
extern char *stream_names[];         // in ppworld.cpp

// Make choice list of actions for a stream with worth or age-worth specified.
// Get template from priority hierarchy for stream.
// Find context matching STM for template and add associated events to list with
//    appropriate worths or age-worths.
// Repeat for each template found following priority hierarchy.

// *****  FUNCTION: make_choice_listA()  *****
//   Returns match_flag = 1, if there has been a match with a template.
short make_choice_listA(short stream, short worthFlag)
{ short  ttemp, node, match_flag = 0;
  struct temp_priority_entry *tpriptr;
//  struct nodeA  *cntxt_ptr = NULL;
  tpriptr =  s->streams[stream].template_priority;
  s->streams[stream].current_expectation = 0;
  if ( !tpriptr ) return(match_flag);
  while ( tpriptr )
		{ttemp = tpriptr->temp;
//		 tclust = pp->templates[ttemp].clust;
		 if (w.diag & 8) {sprintf(wf->wBuf," ttemp=%s", template_names[ttemp]);
								wf->DisplayAndFile(wf->wBuf, 2);
							  }
		 if (ttemp >= 0)
		  {node = tree_searchA(ttemp); // Find context matching cntxt
			if ((w.diag & 8) && ( node != NULLNODE ))
			  display_node( node, ttemp, 2 );
		  }
		 if (( node == NULLNODE ) ||
					( !add_preds_for_tempA(stream, node, ttemp, worthFlag) ))
			tpriptr = tpriptr->nomatch;
		 else {tpriptr = tpriptr->match;
				 match_flag = 1;
				}
		}
  return( match_flag );
}

// *****  FUNCTION: add_preds_for_temp()  *****
// Add to choice_list for stream the predictions from that context
// of the template whose context matches STM and whose prediction types
// belong to the stream.
short add_preds_for_tempA(short stream,short node,short ttemp,short worthFlag)
{ struct predictionA *predptr;
  long pei;
  short j, cluster, acstim, match_for_pred;
  short matches = 0;
//  if (w.diag & 8) wf->DisplayAndFile("\nadd_preds_for_temp", 2);
  cluster = pp->templates[ttemp].clust;
  acstim = pp->templates[ttemp].acst;
  if (w.diag & 8)
	 {sprintf(wf->wBuf, "\nclusterA=%s,acstim=%d,str=%d,",
											cluster_namesA[cluster], acstim, stream);
	  wf->DisplayAndFile(wf->wBuf, 2);
	 }
  if ( cluster < 0 ) error("add_preds_for_temp(), temp not on cluster list.");
// for each prediction of the context:
  pei = pp->clustersA[cluster].assA[node].pei;
  while (pei != NULLNODE)
	  {predptr = &pp->clustersA[cluster].prdA[pei];
//   if it has an event type of the stream
		j=0; match_for_pred = 0;
		while ( (!match_for_pred) && (j<s->streams[stream].nevtypes) )
		 {if (w.diag & 8)
			  {sprintf(wf->wBuf,
				 "predtyp=%d,predev=%X,predexp=%f,predage=%d,preddis=%d",
				 predptr->event.type, predptr->event.event, predptr->expn,
				 predptr->age, predptr->disapproval);
				wf->DisplayAndFile(wf->wBuf, 2);
			  }
//     if the prediction type is a stream type, add prediction to choices
		  if ( predptr->event.type == s->streams[stream].event_type[j] )
			 if (add_pred_to_choice_listA(stream,pei,cluster,node,worthFlag))
				 {matches++; match_for_pred = 1;
				 }
		  j++;
		 }
		pei = predptr->next;
	  }
  if (w.diag & 8)
	 {sprintf(wf->wBuf, " matches=%d", matches);
	  wf->DisplayAndFile(wf->wBuf, 2);
	 }
  return( matches );
}

// *****  FUNCTION: add_pred_to_choice_listA()  *****
// DESCRIPTION: If mark is set, worth is marked-up.
//   If context is zero, return FALSE.
//   If prediction is not on choice-list, add it and add nodes to node-list.
//    Else add worths and add any new nodes to node-list. Return TRUE.
//   Each stream has a linked list of choices type struct choice_listA.
//**  Runs exactly the same as BodyEye to step 20000 if **SAME AS IF** line is
//**  commented out.
short add_pred_to_choice_listA( short stream, long pei,
		 short cluster, short node, short worthFlag )
{ struct predictionA *predptr;
  struct choice_A  *adrchA;      // chA
  struct event_type et;
  short predRPf, predRPd;
  float dscf = DIVSF;     // Division scale factor
  float predRewdProb, worth = 0;
  float age_worth = 0;
  long age;
  short i, j, temp;
  predRPf = predRPd = 0;
  if (w.diag & 8) wf->DisplayAndFile("\nadd_pred_to_choice_listA-1", 2);
  predptr = &pp->clustersA[cluster].prdA[pei];
  if ( !predptr->age ) return FALSE;   // No prediction
  age = pp->clustersA[cluster].assA[node].age;
  temp = pp->clustersA[cluster].assA[node].temp;
  if  (!predptr->disapproval)         // If prediction has no disapproval mark &&
	 {predRewdProb = 0;
	  if (s->drive & w.food) predRPf = predptr->reward_rate_f;
	  if (s->drive & w.drink) predRPd = predptr->reward_rate_d;
	  if (predRPf >= predRPd) 	  predRewdProb = predRPf * 0.01;
	  else predRewdProb = predRPd * 0.01;
	  if (( worthFlag == WORTHANDAGEWORTH ) || ( worthFlag == EXPNWORTHONLY	 ))
		 {if ((s->drive > 1) && ((predRewdProb > w.expectation_for_novelty)
																 || (predptr->novelty != 1)))
			 worth += dscf * predRewdProb;
		  else if (predptr->novelty == 1)
			 worth = dscf * w.expectation_for_novelty;
		  worth += (dscf * predptr->expn)/ predptr->age; // Added anyway
		 }
	  age_worth = ( (dscf * predptr->age)/ age );
	 }
  et.event = predptr->event.event;
  et.type  = predptr->event.type;
// If following a path, treat marked predictions as worth more.
  if ((predptr->mark != NULLMARK) && (s->mode == H_N)
                && (pp->path_steps_to_go > 0)
                && (pp->templates[temp].is_in_leakback_cluster))
		worth *= w.mark_up_factor ;                  //  Mark up
  for (i=0; i<MAX_CHOICES; i++)
	 {adrchA = &pp->choice_listsA[stream].charray[i];    // choice
	  if (adrchA->event.event == NULLEVENT)
		 {adrchA->worth = worth;
		  adrchA->age_worth   = age_worth;
		  adrchA->event.event = et.event;
		  adrchA->event.type  = et.type;
		  adrchA->chnodesA[0].node  = node;
		  adrchA->chnodesA[0].cluster  = cluster;
		  adrchA->chnodesA[1].node  = NULLNODE; // Trouble here if  MAX_NODES_PER_CHOICE < 2
		  if ((i+1) < MAX_CHOICES)
			 pp->choice_listsA[stream].charray[i+1].event.event = NULLEVENT; //new i!
		  break;
		 }
	  if ((adrchA->event.event == et.event) && (adrchA->event.type == et.type))
		 {adrchA->worth += worth;
		  adrchA->age_worth += age_worth;
		  j = 0;
		  while ( (j < MAX_NODES_PER_CHOICE) && (adrchA->chnodesA[j].node != NULLNODE)
					&& ((adrchA->chnodesA[j].node != node)
									  || (adrchA->chnodesA[j].cluster != cluster))) j++;
		  if (j >= MAX_NODES_PER_CHOICE) error("Not enough nodes/choice ", j);
		  if (adrchA->chnodesA[j].node == node) break; // node already on list.
		  if (adrchA->chnodesA[j].node == NULLNODE)
			 {adrchA->chnodesA[j].node = node;
			  adrchA->chnodesA[j].cluster = cluster;
			  if (j+1 < MAX_NODES_PER_CHOICE)
				  adrchA->chnodesA[j+1].node = NULLNODE;
			  break;
			 }
		 }
	 }
  if (w.diag & 8)
	 {sprintf(wf->wBuf,"\nAdded to choices, strm=%d,cls=%s,wrth=%.2f,node=",
									 stream, cluster_namesA[cluster], worth );
	  wf->DisplayAndFile(wf->wBuf, 2);
	  display_node(node, pp->clustersA[cluster].assA[node].temp, 2);
	 }
  return TRUE;
}


// MUST SEPARATE STREAMS SOME TIME.

// *****  Comprehensively frees all choice-lists.
void wipe_choice_listsA()
{ short strm, i;
  for (strm=0; strm<s->nastreams; strm++)
	  {for (i=0; i<MAX_CHOICES; i++)
		  {pp->choice_listsA[strm].charray[i].event.event = NULLEVENT;
			pp->choice_listsA[strm].charray[i].event.type  = NULLTYPE;
			pp->choice_listsA[strm].charray[i].chnodesA[0].node = NULLNODE;
		  }
	  }
}

// *****  FUNCTION: choose_best_from_listA_HN()  *****
// DESCRIPTION: If action and boredom < deterministic, choose randomly
//              If boredom < probabilistic, choose with prob prop to worth
//                Else ask teacher to choose from the list. Why less than???
struct choice_A *choose_best_from_listA_HN(short stream, short worthFlag)
{ float max=-32000;                                                      //{1
  long bigrnd, k, sum = 0;
  int count = 0;
  struct choice_A  *adrchA;   // chA
  short i;
  if (stream >= s->nastreams) error("Not an action stream.", stream);
  if (pp->choice_listsA[stream].charray[0].event.event == NULLEVENT)
	 return( &pp->null_choiceA );                        // i.e. return no choice
	 // Find largest or choose random of equal largest.
	 // Deterministic for actions only.
  if ((s->boredom < w.deterministic)
		  && ((worthFlag == WORTHANDAGEWORTH) || (worthFlag == EXPNWORTHONLY)))
	{if (w.diag & 8) wf->DisplayAndFile("\nDeterministicHN ", 2);           //{2
	 for (i=0; i<MAX_CHOICES; i++)
		{adrchA = &pp->choice_listsA[stream].charray[i];    // choice
		 if ( adrchA->event.event == NULLEVENT ) break;  // no more choices
		 if (w.diag & 8)
			{sprintf(wf->wBuf,"adrchA->worth=%.2f ",adrchA->worth);
			 wf->DisplayAndFile(wf->wBuf, 2);
			}
		 if ( adrchA->worth > max )	{max = adrchA->worth; count = 1; }
		 else if ( adrchA->worth == max) count++;          // and count maxes
		}
	 if (max > 0)   // Non-empty choice list based on expectations
		{k = random( count );
		 count = 0;
		 for (i=0; i<MAX_CHOICES; i++)                      // Choose a max
			{adrchA = &pp->choice_listsA[stream].charray[i];    // choice
			 if (adrchA->event.event == NULLEVENT) break;
			 if (w.diag & 8)
				{sprintf(wf->wBuf," :strm/max/count/k=%d/%f/%d/%d ",
												 stream,max,count,k);
				 wf->DisplayAndFile(wf->wBuf, 2);
				}
			 if ( adrchA->worth != max )  continue;			  // not a max
			 if ( count++ < k )     continue;           // not right max
//           Should check choice for plan mark here
//           - OK if any of contributing nodes has event as marked pred.
       check_choice_for_plan_mark(adrchA);
			 return( adrchA );   // pp->choice_listsA[stream].charray[i] );
			}
			 error("Choosing deterministically failed with worths!", max);
		}
	 else if (worthFlag == WORTHANDAGEWORTH) // max <= 0 AND not EXPNWORTHONLY
		{max = 0;                                                             //{3
		 count = 0;
		 for (i=0; i<MAX_CHOICES; i++)                      // Choose a max
			{adrchA = &pp->choice_listsA[stream].charray[i];    // choice
			 if (adrchA->event.event == NULLEVENT) break;
			 if (w.diag & 8)
				{sprintf(wf->wBuf," adrchA->age_worth=%d ",adrchA->age_worth);
				 wf->DisplayAndFile(wf->wBuf, 2);
				}
			 if ( adrchA->age_worth > max )
				{max = adrchA->age_worth; count = 1;
				}
			 else if ( adrchA->age_worth == max) count++;   // and count maxes
			}
		 if (max > 0)  // Non-empty choice list based on age-worths
			{k = random( count );
			 count = 0;
			 for (i=0; i<MAX_CHOICES; i++)                      // Choose a max
				{adrchA = &pp->choice_listsA[stream].charray[i];    // choice
				 if (adrchA->event.event == NULLEVENT) break;
				 if (w.diag & 8)
				  {sprintf(wf->wBuf," ::strm/max/count/k=%d/%f/%d/%d ",
																	 stream,max,count,k);
					wf->DisplayAndFile(wf->wBuf, 2);
				  }
				 if ( adrchA->age_worth != max )  continue;			  // not a max
				 if ( count++ < k )     continue;                 // not right max
				 adrchA->worth = 0;     // Indicator that age-worths used in selection
                 check_choice_for_plan_mark(adrchA);
				 return( adrchA ); //pp->choice_listsA[stream].charray[i] );     // Should return from here.
				}
			 error("Choosing deterministically failed with age-worths!");
			}
		}                                                                  //3}
	}                                                                     //2}
  else if ( s->boredom < w.probabilistic ) // Choice proportional to worth
	{if ((worthFlag == WORTHANDAGEWORTH) || (worthFlag == EXPNWORTHONLY))   //{2
		{sum = 0;                                                            //{3
		 for (i=0; i<MAX_CHOICES; i++)                      // Choose a max
			{adrchA = &pp->choice_listsA[stream].charray[i];    // choice
			 if (adrchA->event.event == NULLEVENT) break;
			 sum += adrchA->worth;
			}
		 if ( sum > 0 )
			{bigrnd = random( sum );
			 if (w.diag & 8)
				{sprintf(wf->wBuf,"-RND used=%ld-",bigrnd);
				 wf->DisplayAndFile(wf->wBuf, 2);
				}
			 sum = 0;  // Go through again to select random biggest
			 for (i=0; i<MAX_CHOICES; i++)                      // Choose a max
				 {adrchA = &pp->choice_listsA[stream].charray[i];    // choice
				  if (adrchA->event.event == NULLEVENT) break;
				  sum += adrchA->worth;
				  if ( sum <= bigrnd )   continue;
				  else
					{check_choice_for_plan_mark(adrchA);
					 return(adrchA); // pp->choice_listsA[stream].charray[i]); //Should exit here
					}
				 }
			 error("Choosing probabilistically failed with worths!");
			}
		  }                                                                  //3}
		 else if ((worthFlag == WORTHANDAGEWORTH) || (worthFlag == AGEWORTHONLY))
		 {sum = 0;
		  for (i=0; i<MAX_CHOICES; i++)                      // Choose a max
			 {adrchA = &pp->choice_listsA[stream].charray[i];    // choice
			  if (adrchA->event.event == NULLEVENT) break;
			  sum += adrchA->age_worth;
			 }
		  if ( sum > 0 )
			 {bigrnd = random( sum );
			  if (w.diag & 8)
				 {sprintf(wf->wBuf,"-RND used=%ld-",bigrnd);
				  wf->DisplayAndFile(wf->wBuf, 2);
				 }
			  sum = 0;  // Go through again to pick biggest
			  for (i=0; i<MAX_CHOICES; i++)                      // Choose a max
				 {adrchA = &pp->choice_listsA[stream].charray[i];    // choice
				  if (adrchA->event.event == NULLEVENT) break;
				  sum += adrchA->age_worth;
				  if ( sum <= bigrnd )   continue;
				  else
					 {adrchA->worth = 0; // Indicator that age-worths used
            check_choice_for_plan_mark(adrchA);
					  return( adrchA ); //pp->choice_listsA[stream].charray[i] );
					 }
				 }
			  error("Choosing probabilistically failed with age-worths!");
			 }
		 }
	}
  return( &pp->null_choiceA );   // Choosing failed altogether
}

// *****  FUNCTION: choose_best_from_listA_TT()  *****
// DESCRIPTION: If action and boredom < deterministic, choose randomly
//              If boredom < probabilistic, choose with prob prop to worth
//                Else ask teacher to choose from the list. Why less than???
struct choice_A *choose_best_from_listA_TT(short stream, short worthFlag)
{ float max=-32000;                                                      //{1
  long bigrnd, k, sum = 0;
  int count = 0;
  struct choice_A  *adrchA;   // chA
  short i;
  if (stream >= s->nastreams) error("Not an action stream.", stream);
  if (pp->choice_listsA[stream].charray[0].event.event == NULLEVENT)
	 return( &pp->null_choiceA );                        // i.e. return no choice
	 // Find largest or choose random of equal largest.
	 // Deterministic for actions only.
  if ((s->boredom < w.deterministic)
		  && ((worthFlag == WORTHANDAGEWORTH) || (worthFlag == EXPNWORTHONLY)))
	{if (w.diag & 8) wf->DisplayAndFile("\nDeterministicTT ", 2);           //{2
	 for (i=0; i<MAX_CHOICES; i++)
		{adrchA = &pp->choice_listsA[stream].charray[i];    // choice
		 if ( adrchA->event.event == NULLEVENT ) break;  // no more choices
		 if (w.diag & 8)
			{sprintf(wf->wBuf,"adrchA->worth=%.2f ",adrchA->worth);
			 wf->DisplayAndFile(wf->wBuf, 2);
			}
		 if ( adrchA->worth > max )	{max = adrchA->worth; count = 1; }
		 else if ( adrchA->worth == max) count++;          // and count maxes
		}
	 if (max > 0)   // Non-empty choice list based on expectations
		{k = random( count );
		 count = 0;
		 for (i=0; i<MAX_CHOICES; i++)                      // Choose a max
			{adrchA = &pp->choice_listsA[stream].charray[i];    // choice
			 if (adrchA->event.event == NULLEVENT) break;
			 if (w.diag & 8)
				{sprintf(wf->wBuf," ;strm/max/count/k=%d/%f/%d/%d ",
												 stream,max,count,k);
				 wf->DisplayAndFile(wf->wBuf, 2);
				}
			 if ( adrchA->worth != max )  continue;			  // not a max
			 if ( count++ < k )     continue;           // not right max
       mark_nodesA(adrchA);
			 return( adrchA );   // pp->choice_listsA[stream].charray[i] );
			}
			 error("Choosing deterministically failed with worths!", max);
		}
	 else if (worthFlag == WORTHANDAGEWORTH) // max <= 0 AND not EXPNWORTHONLY
		{max = 0;                                                             //{3
		 count = 0;
		 for (i=0; i<MAX_CHOICES; i++)                      // Choose a max
			{adrchA = &pp->choice_listsA[stream].charray[i];    // choice
			 if (adrchA->event.event == NULLEVENT) break;
			 if (w.diag & 8)
				{sprintf(wf->wBuf," adrchA->age_worth=%d ",adrchA->age_worth);
				 wf->DisplayAndFile(wf->wBuf, 2);
				}
			 if ( adrchA->age_worth > max )
				{max = adrchA->age_worth; count = 1;
				}
			 else if ( adrchA->age_worth == max) count++;   // and count maxes
			}
		 if (max > 0)  // Non-empty choice list based on age-worths
			{k = random( count );
			 count = 0;
			 for (i=0; i<MAX_CHOICES; i++)                      // Choose a max
				{adrchA = &pp->choice_listsA[stream].charray[i];    // choice
				 if (adrchA->event.event == NULLEVENT) break;
				 if (w.diag & 8)
				  {sprintf(wf->wBuf," ;;strm/max/count/k=%d/%f/%d/%d ",
																	 stream,max,count,k);
					wf->DisplayAndFile(wf->wBuf, 2);
				  }
				 if ( adrchA->age_worth != max )  continue;			  // not a max
				 if ( count++ < k )     continue;                 // not right max
				 adrchA->worth = 0;     // Indicator that age-worths used in selection
				 return( adrchA ); //pp->choice_listsA[stream].charray[i] );     // Should return from here.
				}
			 error("Choosing deterministically failed with age-worths!");
			}
		}                                                                  //3}
	}                                                                     //2}
  else if ( s->boredom < w.probabilistic ) // Choice proportional to worth
	{if ((worthFlag == WORTHANDAGEWORTH) || (worthFlag == EXPNWORTHONLY))   //{2
		{sum = 0;                                                            //{3
		 for (i=0; i<MAX_CHOICES; i++)                      // Choose a max
			{adrchA = &pp->choice_listsA[stream].charray[i];    // choice
			 if (adrchA->event.event == NULLEVENT) break;
			 sum += adrchA->worth;
			}
		 if ( sum > 0 )
			{bigrnd = random( sum );
			 if (w.diag & 8)
				{sprintf(wf->wBuf,"-RND used=%ld-",bigrnd);
				 wf->DisplayAndFile(wf->wBuf, 2);
				}
			 sum = 0;  // Go through again to select random biggest
			 for (i=0; i<MAX_CHOICES; i++)                      // Choose a max
				 {adrchA = &pp->choice_listsA[stream].charray[i];    // choice
				  if (adrchA->event.event == NULLEVENT) break;
				  sum += adrchA->worth;
				  if ( sum <= bigrnd )   continue;
				  else
					{mark_nodesA(adrchA);
					 return(adrchA); // pp->choice_listsA[stream].charray[i]); //Should exit here
					}
				 }
			 error("Choosing probabilistically failed with worths!");
			}
		  }                                                                  //3}
		 else if ((worthFlag == WORTHANDAGEWORTH) || (worthFlag == AGEWORTHONLY))
		 {sum = 0;
		  for (i=0; i<MAX_CHOICES; i++)                      // Choose a max
			 {adrchA = &pp->choice_listsA[stream].charray[i];    // choice
			  if (adrchA->event.event == NULLEVENT) break;
			  sum += adrchA->age_worth;
			 }
		  if ( sum > 0 )
			 {bigrnd = random( sum );
			  if (w.diag & 8)
				 {sprintf(wf->wBuf,"-RND used=%ld-",bigrnd);
				  wf->DisplayAndFile(wf->wBuf, 2);
				 }
			  sum = 0;  // Go through again to pick biggest
			  for (i=0; i<MAX_CHOICES; i++)                      // Choose a max
				 {adrchA = &pp->choice_listsA[stream].charray[i];    // choice
				  if (adrchA->event.event == NULLEVENT) break;
				  sum += adrchA->age_worth;
				  if ( sum <= bigrnd )   continue;
				  else
					 {mark_nodesA(adrchA);
					  adrchA->worth = 0; // Indicator that age-worths used
					  return( adrchA ); //pp->choice_listsA[stream].charray[i] );
					 }
				 }
			  error("Choosing probabilistically failed with age-worths!");
			 }
		 }
	}
  return( &pp->null_choiceA );   // Choosing failed altogether
}


void check_choice_for_plan_mark(struct choice_A *adrchA)
{struct predictionA *predptr;
 struct event_type evtyp;
 long pei;
 short i,j, node, cluster, mknode;
// Goes through a succession of nodes to find mark of plan
 evtyp = adrchA->event;
 for (i=0; i<MAX_NODES_PER_CHOICE; i++)
  {node = adrchA->chnodesA[i].node;
   cluster = adrchA->chnodesA[i].cluster;
   if (node == NULLNODE) return;
   pei = pp->clustersA[cluster].assA[node].pei;
   while (pei != NULLNODE)
	{predptr = &pp->clustersA[cluster].prdA[pei];
	 if ((predptr->event.type == evtyp.type) &&
					       (predptr->event.event == evtyp.event))
	  {if (predptr->mark != NULLMARK)
     {if (!w.no_display_or_file)
		   {sprintf(wf->wBuf,"\nSeen mark:%d typ/ev %d/%d, step %d on node:",
		   		   predptr->mark,evtyp.type,evtyp.event,pp->path_step);
		    wf->DisplayAndFile(wf->wBuf, 2);
		    display_node(node,pp->clustersA[cluster].assA[node].temp,2);
		   }
      if (predptr->mark == pp->path_step)
		  {pp->marks_seen++;
		   predptr->mark = NULLMARK;
           return;
      }
     }
	  }
	 pei = predptr->next;
	}
  }
 return;
}


// ***** Finds the end of mark-list and then adds and marks the
//   given list.   Note. Can have multiple entries.  Only in T&T.
void mark_nodesA(struct choice_A *adrchA)
{ struct predictionA *predptr;
  struct event_type evtyp;
  long pei;
  short i,j, node, cluster, mknode;
// Adds a succession of nodes to mark_list,
  evtyp = adrchA->event;
  for (i=0; i<MAX_NODES_PER_CHOICE; i++)
	{node = adrchA->chnodesA[i].node;
	 cluster = adrchA->chnodesA[i].cluster;
	 if (node == NULLNODE) return;
     for (j=0; j < MAX_MARKS_A; j++)
        {mknode = pp->clustersA[cluster].marksA[j];
         if (mknode == node) break; // already there but may be diff. predn
         if (mknode == NULLNODE) // spare slot
           {pp->clustersA[cluster].marksA[j] = node;
//**            sprintf(wf->wBuf,"\nmarksA[%d] given node %d for clust %d ",
//**                          j, node, cluster);   // ***********
//**		        wf->DisplayAndFile(wf->wBuf, 2);      // ***********
            break;
           }
         if (j == MAX_MARKS_A - 1) error("Not enough marksA slots ", j);
        }
	 if (!w.no_display_or_file)
       {sprintf(wf->wBuf," node-to-mark:%d ",node);   // ***********
		    wf->DisplayAndFile(wf->wBuf, 2);      // ***********
       }
	 pei = pp->clustersA[cluster].assA[node].pei;
	 while (pei != NULLNODE)
		{predptr = &pp->clustersA[cluster].prdA[pei];
		 if ( (predptr->event.type == evtyp.type) &&
					(predptr->event.event == evtyp.event) )
		  {if (predptr->mark == NULLMARK)
              predptr->mark = s->step;   //
       else predptr->mark = LOOPMARK;
       if (!w.no_display_or_file )
			  {sprintf(wf->wBuf,"\nMark:%d typ/ev %d/%d on node:",
							predptr->mark,	evtyp.type, evtyp.event);
			   wf->DisplayAndFile(wf->wBuf, 2);
			   display_node(node,pp->clustersA[cluster].assA[node].temp,2);
			  }
		  }
		 pei = predptr->next;
		}
	}
  return;
}

// ***** Zero all marks (only  A ), on mark-list nodes, and wipe mark-list
void wipe_all_marks()
{ short j,k, node;
  struct predictionA *predptr;
  long pei;
  for (j=0; j < pp->naclusters; j++)
   {for (k=0; k<MAX_MARKS_A; k++)
	  {node = pp->clustersA[j].marksA[k];
//**		 wf->DisplayAndFile("\nWiping marks on node ", 2);      //************
//**		 display_node(node,pp->clustersA[j].assA[node].temp,2); //***********
     if (node == NULLNODE) continue;
	   pei = pp->clustersA[j].assA[node].pei;
	   while (pei != NULLNODE)
		  {predptr = &pp->clustersA[j].prdA[pei];
		   predptr->mark = NULLMARK;		// zeroing pred marks whether marked or not
		   pei = predptr->next;
		  }
	   pp->clustersA[j].marksA[k] = NULLNODE;
	  }
   }
  if (!w.no_display_or_file )
     wf->DisplayAndFile("\nWiped all marks", 2);
//**  disp_nodeA(0);     //************************remoe when OK
 }


// *****  FUNCTION: add_to_best_listA()  *****
// COPIES ONE struct choice_listA ONTO pp->best_predictions[STREAM].
// -ONLY ONE EVENT PREDICTION PER STREAM ALLOWED.
//NOTE: best_predictions[] IS ONLY USED TO DISPLAY, AND FOR THE NODE LIST.
// THE NODE LIST BY ITSELF COULD JUST BE GENERATED INSTEAD.
// THE PRINTOUT IS TURNED OFF HERE.
void add_to_best_listA(short tstream, struct choice_A *adrchA)
{ short i, node, cluster;
  short flag = 0;
  long age;
  float expn;
  if ( adrchA->event.event == NULLEVENT ) return;
  pp->best_predictionsA[tstream].event.type  = adrchA->event.type ;
  pp->best_predictionsA[tstream].event.event = adrchA->event.event ;
  pp->best_predictionsA[tstream].worth = adrchA->worth ;
//  if (!adrchA->worth)  // No, as safer and efficient to copy age_worth as well.
	 pp->best_predictionsA[tstream].age_worth = adrchA->age_worth ;
  if (w.diag & 8)
	 {sprintf(wf->wBuf,"\nstream %d:",tstream);
	  wf->DisplayAndFile(wf->wBuf, 2);
	  if (adrchA->worth) sprintf(wf->wBuf,"(%d %X),WORTH=%.2f",
								 adrchA->event.type,adrchA->event.event,adrchA->worth);
	  else sprintf(wf->wBuf,"(%d %X),AGE_WORTH=%.2f",
								 adrchA->event.type,adrchA->event.event,adrchA->age_worth);
	  wf->DisplayAndFile(wf->wBuf, 2);
	 }
  for (i=0; i<MAX_NODES_PER_CHOICE; i++)
	 {node = adrchA->chnodesA[i].node;
	  cluster = adrchA->chnodesA[i].cluster;
	  if (node == NULLNODE) flag = 1;
	  if (!flag)
		 {pp->best_predictionsA[tstream].chnodesA[i].node = node;
		  pp->best_predictionsA[tstream].chnodesA[i].cluster = cluster;
		  if (w.diag & 8)
			  display_node(adrchA->chnodesA[i].node,
										pp->clustersA[cluster].assA[node].temp, 2);
		  age = pp->clustersA[cluster].assA[node].age;
		  expn = pp->clustersA[cluster].assA[node].expn;
		  if ((age) && (expn > (age * s->streams[tstream].current_expectation)))
			  s->streams[tstream].current_expectation = expn/age;
		 }
	  else {pp->best_predictionsA[tstream].chnodesA[i].node = NULLNODE;
			  break;      // Writes one NULL after nonNULL nodes.
			 }
	 }
}

// *****  Frees the memory dynamically allocated for best-preds.
void wipe_best_predsA(short stream)
{ pp->best_predictionsA[stream].worth = 0;
  pp->best_predictionsA[stream].age_worth = 0;
  pp->best_predictionsA[stream].event.event = NULLEVENT;
  pp->best_predictionsA[stream].event.type = NULLTYPE;
  pp->best_predictionsA[stream].chnodesA[0].node = NULLNODE;
}





