// pppreds.cpp     PURRPUSS  Dev.from C.B.Gunn 22/4/93    jha: 15aug98-9jun01

#include "c:\Program Files\Borland\CBuilder3\examples\foodrink\ppheader.hpp"

extern robot_info *s;
extern pp_info *pp;
extern world w;
extern TWindFile	*wf;
extern char *event_type_names[];     // in ppworld.cpp
extern char *template_names[];       // in ppworld.cpp
extern char *cluster_namesS[];        // in ppworld.cpp
extern char *stream_names[];         // in ppworld.cpp


// *****  FUNCTION: make_choice_listS()  *****
// DESCRIPTION: Makes a list of the event choices for stream.
//   For each template according to the preference hierarchy list:
//   find context to match STM and add predictions to the choice list.
void make_choice_listS(short stream)
{ short  ttemp, node;
  struct temp_priority_entry *tpriptr;
//  struct nodeS  *cntxt_ptr = NULL;
  tpriptr =  s->streams[stream].template_priority;
  if ( !tpriptr ) return;
  while ( tpriptr )
		{ttemp = tpriptr->temp;
		 if (w.diag & 8) { sprintf(wf->wBuf," ttemp=%d", ttemp);
									wf->DisplayAndFile(wf->wBuf, 2);  }
		 if (ttemp >= 0)
		  {node = tree_searchS(ttemp); // Find context matching cntxt
			if ((w.diag & 8) && (node != NULLNODE)) display_node(node, ttemp, 2);
		  }
		 if (( node == NULLNODE ) || ( !add_preds_for_tempS(stream,node,ttemp) ))
			tpriptr = tpriptr->nomatch;
		 else tpriptr = tpriptr->match;
		}
}

// *****  FUNCTION: add_preds_for_temp()  *****
// Add to choice_list for stream the predictions from that context
// of the template whose context matches STM and whose prediction types
// belong to the stream.
short add_preds_for_tempS(short stream, short node, short ttemp)
{ struct predictionS *predptr;
  long pei;
  short j, cluster, acstim, match_for_pred;
  short matches = 0;
//  if (w.diag & 8) wf->DisplayAndFile("\nadd_preds_for_temp", 2);
  cluster = pp->templates[ttemp].clust;
  acstim = pp->templates[ttemp].acst;
  if (w.diag & 8)
	 {sprintf(wf->wBuf, " clusterS=%s,acstim=%d,str=%d",
								cluster_namesS[cluster], acstim, stream);
	  wf->DisplayAndFile(wf->wBuf, 2);
	 }
  if ( cluster < 0 ) error("add_preds_for_temp(), temp not on cluster list.");
// for each prediction of the context:
  pei = pp->clustersS[cluster].assS[node].pei;
  while (pei != NULLNODE)
	  {predptr = &pp->clustersS[cluster].prdS[pei];
//   if it has an event type of the stream
	   j=0; match_for_pred = 0;
	   while ( (!match_for_pred) && (j<s->streams[stream].nevtypes) )
//     if the prediction type is a stream type, add prediction to choices
		 {if (w.diag & 8)
			{sprintf(wf->wBuf,
				 " pei=%d,predtyp=%d,predev=%X,predage=%d",
				  pei,predptr->event.type, predptr->event.event, predptr->age);
			 wf->DisplayAndFile(wf->wBuf, 2);
		     sprintf(wf->wBuf, "\n***stream=%d,j=%d,nevtypes=%d ",
                                  stream, j, s->streams[stream].nevtypes);
		     wf->DisplayAndFile(wf->wBuf, 2);
			}
		  if ( predptr->event.type == s->streams[stream].event_type[j] )
			{if (add_pred_to_choice_listS(stream, pei, cluster, node))
			   {if (w.diag & 8) wf->DisplayAndFile("\n***match ", 2);
                matches++; match_for_pred = 1;
			   }
            }
		  j++;
		 }
		pei = predptr->next;
	  }
  if (w.diag & 8)
	 {sprintf(wf->wBuf, " matches=%d", matches);
	  wf->DisplayAndFile(wf->wBuf, 2);
	 }
  return( matches );
}


// *****  FUNCTION: add_pred_to_choice_listS()  *****
// DESCRIPTION:
//   If context is zero, return FALSE.
//   If prediction is not on choice-list, add it and add nodes to node-list.
//    Else add worths and add any new nodes to node-list. Return TRUE.
//   Each stream has a linked list of choices type struct choice_list.
short add_pred_to_choice_listS(short stream,long pei,short cluster, short node)
{ struct predictionS *predptr;
  struct choice_S chS;
  struct event_type et;
  float dscf = DIVSF;     // Division scale factor
  float age_worth = 0;
  short i,j;
  long age;
//  if (w.diag & 8) wf->DisplayAndFile("\nadd_pred_to_choice_listS-1", 2);
  predptr = &pp->clustersS[cluster].prdS[pei];
  if ( !predptr->age ) return( FALSE );   // No prediction
  age = pp->clustersS[cluster].assS[node].age;
  age_worth = ( (dscf * predptr->age)/ age );
  et.event = predptr->event.event;
  et.type  = predptr->event.type;
//  if (w.diag & 8) wf->DisplayAndFile("\nadd_pred_to_choice_listS-2", 2);
  for (i=0; i<MAX_CHOICES; i++)
   {chS = pp->choice_listsS[stream].charray[i];    // choice
    if (pp->choice_listsS[stream].charray[i].event.event == NULLEVENT)     // new entry
   	 {pp->choice_listsS[stream].charray[i].age_worth   = age_worth;
   	  pp->choice_listsS[stream].charray[i].event.event = et.event;
   	  pp->choice_listsS[stream].charray[i].event.type  = et.type;
   	  pp->choice_listsS[stream].charray[i].chnodesS[0].node  = node;
   	  pp->choice_listsS[stream].charray[i].chnodesS[0].cluster  = cluster;
   	  pp->choice_listsS[stream].charray[i].chnodesS[1].node  = NULLNODE;  // Trouble here if  MAX_NODES_PER_CHOICE < 2
   	  if ((i+1) < MAX_CHOICES)
   		 pp->choice_listsS[stream].charray[i+1].event.event = NULLEVENT;
   	  break;  // out of "for" loop
   	 }
//	  if (w.diag & 8) wf->DisplayAndFile("\nadd_pred_to_choice_listS-3", 2);
	if ((chS.event.event == et.event) && (chS.event.type == et.type))
	 {pp->choice_listsS[stream].charray[i].age_worth += age_worth;
	  j = 0;
// Previously checked cluster, but the context pointers cannot be the same
// for contexts in different clusters.
	  while ( (j < MAX_NODES_PER_CHOICE)
                    && (chS.chnodesS[j].node != NULLNODE)
			 	      && ((chS.chnodesS[j].node != node)
                         || (chS.chnodesS[j].cluster != cluster)) )
             j++;
	  if (j >= MAX_NODES_PER_CHOICE) error("Not enough nodes/choice ", j);
	  if ((chS.chnodesS[j].node == node)
                              && (chS.chnodesS[j].cluster == cluster))
           break; // node already on list.
	  if (chS.chnodesS[j].node == NULLNODE)
	    {pp->choice_listsS[stream].charray[i].chnodesS[j].node = node;
	     pp->choice_listsS[stream].charray[i].chnodesS[j].cluster = cluster;
	     if ((j+1) < MAX_NODES_PER_CHOICE)
	      pp->choice_listsS[stream].charray[i].chnodesS[j+1].node = NULLNODE;//after new one
		 break;   // node/cluster added
		}
	 }
   }
  if (w.diag & 8)
    {sprintf(wf->wBuf,"\nAdded to choices, strm=%d,cls=%s,ageWrth=%.2f,node=",
									  stream, cluster_namesS[cluster], age_worth );
     wf->DisplayAndFile(wf->wBuf, 2);
     display_node(node, pp->clustersS[cluster].assS[node].temp, 2);
    }
  return( TRUE );
}


// *****  Comprehensively frees all choice-lists.
void wipe_choice_listsS()
{ short strm, i;
  for (strm=0; strm<s->nstreams; strm++)
	  {for (i=0; i<MAX_CHOICES; i++)
		  {pp->choice_listsS[strm].charray[i].event.event = NULLEVENT;
			pp->choice_listsS[strm].charray[i].event.type  = NULLTYPE;
			pp->choice_listsS[strm].charray[i].chnodesS[0].node = NULLNODE;
		  }
	  }
}


//  Find stream with highest rest_worth. Rest_worth is sum of remaining worths.
//  Remove best choice from list for this stream by moving up choices beyond
//       it in array.
//  Choose best from rest and put on to best-predictions list.
//  Copy predicted list to current stimulus list.
//  Display alternative stimuli, obtaining constituent stimuli where needed.

// *****  FUNCTION: there_are_alternative_stimuli()  *****
// Returns TRUE if there are, FALSE otherwise.
short there_are_alternative_stimuli()
{ short i, j, k, strm, node, bestindex;
  short stream = NULLSTREAM;
  short preds_for_all_S_streams = TRUE;
  short test_TT_for_stream_says_terminate = FALSE;
  short no_alternative_stimuli = TRUE;
  long evnt, chevent, restwth = 0;
  struct choice_S *adrchS;
//  Find stream with highest rest_worth.
  for (i=s->nastreams; i<s->nstreams; i++)
	  if ((i != DESTR) && (pp->rest_choice_list_S[i].rest_worth > restwth))  // && (i != LMSTR)
		{restwth = pp->rest_choice_list_S[i].rest_worth;
		 stream = i;
		}
  if (stream == NULLSTREAM) return( FALSE );
// Remove best choice from list so that we can return to get next best
//   if choice doesn't lead to template match for action decision.
  bestindex = pp->rest_choice_list_S[stream].index_best;
  if (bestindex < 0) return( FALSE );
// Remove best choice by moving up choices beyond it in array.
  for (j=bestindex; j<(MAX_CHOICES-1); j++)
	  {chevent = pp->choice_listsS[stream].charray[j+1].event.event;
		pp->choice_listsS[stream].charray[j] =
											  pp->choice_listsS[stream].charray[j+1];
		if (j >0) no_alternative_stimuli = FALSE;  // Condition added 27jly00
		if (chevent == NULLEVENT) break; // No more to shift
		if (j == (MAX_CHOICES - 2))  // Set last choice in array to null
		  {pp->choice_listsS[stream].charray[j+1].event.event = NULLEVENT;
			pp->choice_listsS[stream].charray[j+1].event.type  = NULLTYPE;
			pp->choice_listsS[stream].charray[j+1].age_worth   = NULLWORTH;
			pp->choice_listsS[stream].charray[j+1].chnodesS[0].node = NULLNODE;
		  }
	  }
		if ( no_alternative_stimuli == TRUE ) return( FALSE );
  if (w.diag & 8) {sprintf(wf->wBuf, "\nBest ch from str%d ", stream);
						 wf->DisplayAndFile(wf->wBuf, 2);
						}
//  display_choice_listsS();
  adrchS = choose_best_from_listS(stream); // Chooses best from rest
  if ( adrchS->event.event == NULLEVENT )   // No Best
	 {s->predicted_stimulus[stream].event = NULLEVENT;
	  s->predicted_stimulus[stream].type  = NULLTYPE;
	  preds_for_all_S_streams = FALSE;
	 }
  else
	 {s->predicted_stimulus[stream].type  = adrchS->event.type;  // replaces
	  s->predicted_stimulus[stream].event = adrchS->event.event; // etcopy()
	  add_to_best_listS(stream, adrchS); // Copy best onto best preds list
//	  if ((s->mode == T_T)  &&  (chS.event.event != NULLEVENT))
//		 if ( test_for_tt_terminationS(strm) )  // 28aug99
//				  test_TT_for_stream_says_terminate = TRUE;
//		 else s->events[chS.event.type].tim_shift_reg[0] = chS.event.event;
	 }
  if (w.diag & 8)  display_best_predictionsS();
  copy_list_pred_to_current();	// predicted_stimulus to current_stimulus
//	  if ( !preds_for_all_S_streams || test_TT_for_stream_says_terminate )
//		 stay_in_or_restore_h_n();       		// here in ppplans.cpp
  if (!w.no_display_or_file) wf->DisplayAndFile("\nAlt T+T Stim: ", 0);
// Display alternative stimuli and obtain constituent stimuli where appropriate.
  for (strm=s->nastreams; strm<s->nstreams;  strm++)    // For each s stream
	  {// if (strm == DESTR) continue;    removed 22may01
       evnt = s->current_stimulus[strm].event;
			if ( evnt != NULLEVENT )       // Note stimuli have been shifted
			  {s->events[s->current_stimulus[strm].type].tim_shift_reg[1] = evnt;
				if (!w.no_display_or_file)
                  {event_to_string(s->current_stimulus[strm].type, evnt);
				   wf->DisplayAndFile(wf->wBuf, 0);
                  }
		}	  }
  return( TRUE );
}


// *****  FUNCTION: choose_best_from_listS()  *****
// DESCRIPTION: Choose by age_worth.
//  age_worth has been multiplied by DIVSF (=1000) so that its fractional part
//  can be neglected.
// Holds stream, second-best choice and its index.
struct choice_S *choose_best_from_listS(short stream)
{ long bigrnd, sum, sump, rest ;
//  int count = 0;
//  char *c;
  struct choice_S *adrchS, chStemp;
  short i, j;
  pp->rest_choice_list_S[stream].index_best = -1;
  pp->rest_choice_list_S[stream].rest_worth = NULLWORTH;
  if (w.diag & 8) wf->DisplayAndFile("\nchoose_best_from_listS", 2);
  if (stream < s->nastreams) error("Not a stimulus stream.", stream);
	 if (pp->choice_listsS[stream].charray[0].event.event == NULLEVENT)
	 return( &pp->null_choiceS );                        // i.e. return no choice
	 // Find largest or choose random of equal largest.
  if ( s->boredom < w.probabilistic ) // Choice proportional to worth
	 {sum = 0;
	  for (i=0; i<MAX_CHOICES; i++)                      // Choose a max
		 {adrchS = &pp->choice_listsS[stream].charray[i];    // choice
		  if (adrchS->event.event == NULLEVENT) break;
		  sum += adrchS->age_worth;
		 }
	  if ( sum > 0 )
		 {bigrnd = random( sum );
		  if (w.diag & 8)
			 {sprintf(wf->wBuf,"-RND used=%ld-",bigrnd);
			  wf->DisplayAndFile(wf->wBuf, 2);
			 }
		  sump = 0;  // Go through again to pick biggest
		  for (i=0; i<MAX_CHOICES; i++)                      // Choose a max
			  {if (pp->choice_listsS[stream].charray[i].event.event == NULLEVENT)
					break;
				sump += pp->choice_listsS[stream].charray[i].age_worth;
				if ( sump <= bigrnd )   continue;
				pp->rest_choice_list_S[stream].rest_worth =
							  sum - pp->choice_listsS[stream].charray[i].age_worth;
				pp->rest_choice_list_S[stream].index_best = i;
//				sprintf(wf->wBuf, "\nBest index=%d ", i);
//				wf->DisplayAndFile(wf->wBuf, 2);
				return( &pp->choice_listsS[stream].charray[i] );
			  }
		  error("Choosing probabilistically failed!");
		 }
	 }
  return( &pp->null_choiceS );
}

// *****  FUNCTION: add_to_best_listS()  *****
// COPIES ONE struct choice_list ONTO pp->best_predictions[STREAM].
// -ONLY ONE EVENT PREDICTION PER STREAM ALLOWED.
//NOTE: best_predictions[] IS ONLY USED TO DISPLAY, AND FOR THE NODE LIST.
// THE NODE LIST BY ITSELF COULD JUST BE GENERATED INSTEAD.
// THE PRINTOUT IS TURNED OFF HERE.
void add_to_best_listS(short tstream, struct choice_S *adrchS)
{ short i, node, cluster;
  short flag = 0;
  if ( adrchS->event.event == NULLEVENT ) return;
  pp->best_predictionsS[tstream].event.type  = adrchS->event.type ;
  pp->best_predictionsS[tstream].event.event = adrchS->event.event ;
  pp->best_predictionsS[tstream].age_worth = adrchS->age_worth ;
  if (w.diag & 8)
	 {sprintf(wf->wBuf,"\nstream %d:",tstream);
	  wf->DisplayAndFile(wf->wBuf, 2);
	  sprintf(wf->wBuf,"(%d %X),AGE_WORTH=%.2f",
                      adrchS->event.type,adrchS->event.event,adrchS->age_worth);
	  wf->DisplayAndFile(wf->wBuf, 2);
	 }
  for (i=0; i<MAX_NODES_PER_CHOICE; i++)
	  {node = adrchS->chnodesS[i].node;
		if (node == NULLNODE) flag = 1;
		cluster = adrchS->chnodesS[i].cluster;
		if (!flag)
		  {pp->best_predictionsS[tstream].chnodesS[i].node = node;
			pp->best_predictionsS[tstream].chnodesS[i].cluster = cluster;
			if (w.diag & 8)
			  display_node(node, pp->clustersS[cluster].assS[node].temp, 2);
		  }
		else {pp->best_predictionsS[tstream].chnodesS[i].node = NULLNODE;
				break;      // Writes one NULL after nonNULL nodes.
			  }
	  }
}


// *****  Frees the memory dynamically allocated for best-preds.
void wipe_best_predsS(short stream)
{ pp->best_predictionsS[stream].age_worth = 0;
  pp->best_predictionsS[stream].event.event = NULLEVENT;
  pp->best_predictionsS[stream].event.type = NULLTYPE;
  pp->best_predictionsS[stream].chnodesS[0].node = NULLNODE;
}





