//  ppstm.cpp   PURRPUSS.  Dev.from C.B.Gunn 22/4/93    jha: 15aug98-25jly01

#include "c:\Program Files\Borland\CBuilder3\examples\foodrink\ppheader.hpp"

extern robot_info *s;
extern robot_info *sa;
extern robot_info *sb;
extern pp_info *pp;
extern world w;
extern TWindFile  *wf;
extern char *event_type_names[];     // in ppworld.cpp
extern char *template_names[];       // in ppworld.cpp
extern char *cluster_namesA[];        // in ppworld.cpp
extern char *cluster_namesS[];        // in ppworld.cpp
extern char *stream_names[];         // in ppworld.cpp
extern char *kindofpred_string[];   // in ppcycle.cpp

// *****  Puts type and delay into a short integer for template definitions.
short reg_type_delay(short type, short delay)
{ return( (type << 8) | delay ); }

void display_type_and_shift(short typdelay)
{ short type, delay;
  delay = typdelay & 0X000000FF;
  type  = (typdelay >> 8) & 0X000000ff;
  sprintf(wf->wBuf," %s,sh=%d", event_type_names[type], delay);
  wf->DisplayAndFile(wf->wBuf, 2);
}

// *****  Get event from context_event_number of template
unsigned long get_tim_regul(short temp, short context_event_number)
{ short type_delay, type, delay;
  type_delay = pp->templates[temp].eventdef[context_event_number];
  type = ((type_delay >> 8) & 255);
  delay = (type_delay & 255);
  if (s->events[type].tim) return( s->events[type].tim_shift_reg[delay] );
  if (s->events[type].thr) return( s->events[type].thr_shift_reg[delay] );
  error("\nEvent is neither timing or threading.", type);
}

//  *****  FUNCTION: shift_stm()  ******
// DESCRIPTION:  For each event, shifts the shift registers
//    New events are loaded into the first elements of the shift registers.
//  	Shifted each step if tim flag, only when not nil if thr flag.
void shift_stm()
{ short j,k;
  for (j=0; j<s->nevtypes; j++)
	 {if (s->events[j].tim)
	  {for (k=MAX_EVENT_SHIFTS-1; k>0; k--)
		 s->events[j].tim_shift_reg[k] = s->events[j].tim_shift_reg[k-1];
	  }
//   Assumes that a threading event is also a timing event.
	 if (s->events[j].thr  &&  (s->events[j].thr_shift_reg[0] != NULLEVENT) )
	  {for (k=MAX_EVENT_SHIFTS-1; k>0; k--)
		 s->events[j].thr_shift_reg[k] = s->events[j].thr_shift_reg[k-1];
	  }
	}
  return;
}

//  Doesn't wipe events of threading event shift registers
void wipe_events(short acst)        // FUNCTION *****  wipe_events  *****
{ short j;
  for (j=0; j<s->nevtypes; j++)  // 17may99
	 if ( s->events[j].acst == acst )
		{if (s->events[j].tim) s->events[j].tim_shift_reg[0] = NULLEVENT;
		 else if (s->events[j].thr) s->events[j].thr_shift_reg[0] = NULLEVENT;
		 else error("\nEvent type to be wiped is neither timing nor threading.");
		}
  return;
}

//  Displays the event structure to window pclass.
void display_event_structure(short acst)
{ short j,k;
  unsigned long m;
  if (acst == AC)sprintf(wf->wBuf, "\nACTION EVENTS - Robot %c", w.robot );
  else if (acst == ST)sprintf(wf->wBuf,"\nSTIMULUS EVENTS - Robot %c",w.robot);
  else sprintf(wf->wBuf, "\nACTION & STIMULUS EVENTS - Robot %c", w.robot );
  wf->DisplayAndFile(wf->wBuf, 2);
  for ( j = 0; j < s->nevtypes; j++)
	if (( acst == BOTH ) || ( s->events[j].acst == acst ))
	 {wf->FileOnly("\n");
	  if ( s->events[j].tim == TRUE )
		for ( k = 0; k < MAX_EVENT_SHIFTS; k++)
		  { m = s->events[j].tim_shift_reg[k];
			 sprintf(wf->wBuf," sh=%d,",k);
				 wf->FileOnly(wf->wBuf);
			 event_to_string(j,m);
			 wf->FileOnly(wf->wBuf);
		  }
	  if ( s->events[j].thr == TRUE )        // Needed if any threading events
		for ( k = 0; k < MAX_EVENT_SHIFTS; k++)
		  { m = s->events[j].thr_shift_reg[k];
			 sprintf(wf->wBuf," sh=%d,",k);
			 wf->FileOnly(wf->wBuf);
			 event_to_string(j,m);
			 wf->FileOnly(wf->wBuf);
		  }
	 }
  wf->DisplayAndFile("\nEvents sent to file.", 2);
  return;
}

// ***** Produces string of event-type and event for display.     30jly99
void event_to_string(short ev_type, unsigned long ulevent)
{ if (ulevent == NULLEVENT)
	 {sprintf(wf->wBuf, " %s:--", event_type_names[ev_type]);
	  return;
	 }
  switch ( ev_type )
	{case BODYMOVE :
	 case FORWARD :       //         Note that event_type_names[]
	 case LEFT :          //         is an array, not a function
	 case RIGHT :
	 case TURN :
	 case EYEMOVE :
	 case EYESTAY :
	 case EYENORTH :
	 case EYEEAST :
	 case EYESOUTH :
	 case EYEWEST :
	 case NOTYEYEMOVE :
	 case FOVEA :
	 case WIDENONLY :       // wide - north only
	 case WIDEEONLY :       // wide - east only
	 case WIDESONLY :       // wide - south only
	 case WIDEWONLY :
 	 case DIRECTION :   sprintf(wf->wBuf, " %s:%c", event_type_names[ev_type],
									  charof(ulevent & 0X000000FF)); break;
     case DESIRE :     sprintf(wf->wBuf, " %s:%X", event_type_names[ev_type],
									  ulevent); break;
	 case BODYEYE:          // BodyMove and EyeMove
	 case SAY:
     case HEARSF:
     case HEAROR:
     case HEARFO:
	 case PROPRIOCEP : sprintf(wf->wBuf, " %s:%c%c",event_type_names[ev_type],
									  charof(( ulevent >>  8 ) & 0X000000FF),
									  charof(ulevent & 0X000000FF)); break;
	 case TOUCH : sprintf(wf->wBuf, " %s:%c%c%c", event_type_names[ev_type],
									  charof(( ulevent >> 16 ) & 0X000000FF),
									  charof(( ulevent >>  8 ) & 0X000000FF),
									  charof(ulevent & 0X000000FF));  break;
	 case WIDE : sprintf(wf->wBuf," %s:%c%c%c%c",event_type_names[ev_type],
									  charof(( ulevent >> 24 ) & 0X000000FF),
									  charof(( ulevent >> 16 ) & 0X000000FF),
									  charof(( ulevent >>  8 ) & 0X000000FF),
									  charof(ulevent & 0X000000FF));  break;
	 case HEAR : sprintf(wf->wBuf," %s:%c%c%c%c",event_type_names[ev_type],
									  charof(( ulevent >> 24 ) & 0X000000FF),
									  charof(( ulevent >> 16 ) & 0X000000FF),
									  charof(( ulevent >>  8 ) & 0X000000FF),
									  charof(ulevent & 0X000000FF));  break;
	 default : error("Event_type unacceptable.", ev_type);
	}
 }

// Displays LTM context & node per cluster to window pclass.
void display_ltm_tree()
{ short k, acst, hold_no_display_or_file;
  struct context_link *clptr;
  long ctxel;
  hold_no_display_or_file = w.no_display_or_file;
  w.no_display_or_file = FALSE;
  sprintf(wf->wBuf,"\nDISPLAY LTM TREE for Robot %c on step %d ",
					  w.robot, s->step);
  wf->DisplayAndFile(wf->wBuf, 2);
  w.jumping = TRUE;     // To force use of bigBuf
  for (k=0; k<pp->ntemplates; k++)
	  {ctxel = pp->templates[k].base;
		 if ( ctxel == NULLLONG ) continue;
		 pp->templates[k].nlinks = 0;
		acst = pp->templates[k].acst;
		sprintf(wf->wBuf,"\nTEMPLATE %s:\n\t",pp->templates[k].tname);
		wf->FileOnly(wf->wBuf);
		disp_ltm(ctxel, acst, pp->templates[k].noEvTypesInContext-1, k,  "\t");
		 sprintf(wf->wBuf,"\nNo.context links = %d ", pp->templates[k].nlinks);
		wf->FileOnly(wf->wBuf);
	  }
  w.jumping = FALSE;      // To turn off use of bigBuf
  w.no_display_or_file = hold_no_display_or_file;
  wf->DisplayAndFile("\nLTM TREE sent to file.", 2);
}

void disp_ltm(long ctxel, short acst, short mcl, short temp, char* str)
{ struct context_link *cxptr;
  long contel;
  char strt[100];
  short mclt, cluster;
  mclt = mcl;
  contel = ctxel;
  if ( contel == NULLLONG ) error_dec("tree run out before leaf. mclt=", mclt);
  cluster = pp->templates[temp].clust;
  if (acst == AC) cxptr = &pp->clustersA[cluster].ctxtA[contel];
  else cxptr = &pp->clustersS[cluster].ctxtS[contel];
  strcpy(strt, str);
  sprintf(wf->wBuf,"\t%d,", mclt); wf->FileOnly(wf->wBuf);
  event_to_string(cxptr->event.type, cxptr->event.event);
  wf->FileOnly(wf->wBuf);
  pp->templates[temp].nlinks++;
  if ( mclt )                       // more context to come
	 {if ( cxptr->next_list != NULLLONG )      // same context
		 {strcat(strt, "\t\t\t");
		  disp_ltm(cxptr->next_list, acst, mclt - 1, temp, strt); // subtree
		 }
	  if ( cxptr->next != NULLLONG )          // next context
		 { sprintf(wf->wBuf, "\n%s", str);
			wf->FileOnly(wf->wBuf);
			disp_ltm(cxptr->next, acst, mclt, temp, str); //next event same level
		 }
	 }
  else             // mclt=0
	 {if (pp->templates[temp].acst == AC)
		 {sprintf(wf->wBuf,"\t%d%s%s", cxptr->next_list,
							 pp->templates[temp].tname,
							 cluster_namesA[pp->templates[temp].clust]);
		 }
	  else
		 {sprintf(wf->wBuf,"\t%d%s%s", cxptr->next_list,
							 pp->templates[temp].tname,
							 cluster_namesS[pp->templates[temp].clust]);
		 }
	  wf->FileOnly(wf->wBuf);
	  if ( cxptr->next != NULLLONG )          // next context at bottom level
		 { sprintf(wf->wBuf, "\n%s", str);
			wf->FileOnly(wf->wBuf);
			disp_ltm(cxptr->next, acst, mclt, temp, str); //next event same level
		 }
	 }
}

// Display all nodes by cluster.
void display_nodes()
{ short i,j, max,  hold_no_display_or_file;
  hold_no_display_or_file = w.no_display_or_file;
  w.no_display_or_file = FALSE;
  sprintf(wf->wBuf,"\nDISPLAY CONTEXTS for Robot %c on step %d",
													 w.robot, s->step);
  wf->FileOnly(wf->wBuf);
  w.jumping = TRUE;    // To force use of bigBuf
  for (j=0; j<pp->naclusters; j++)
	  {sprintf(wf->wBuf,"\nCLUSTER-A %s: ", cluster_namesA[j]);	// 17may99
		wf->FileOnly(wf->wBuf);
		for (i=0; i<=pp->max_nov; i++) pp->clustersA[j].nov[i] = 0;
//        pp->clustersA[j].lm = 0;
		if (pp->clustersA[j].ntemps) disp_nodeA(j);
	  }
  for (j=0; j<pp->nsclusters; j++)
	  {sprintf(wf->wBuf,"\nCLUSTER-S %s: ", cluster_namesS[j]);	// 17may99
		wf->FileOnly(wf->wBuf);
		pp->predcountS[j] = 0;
		if (pp->clustersS[j].ntemps) disp_nodeS(j); //A and S temps in cluster.
	  }
	w.jumping = FALSE;  // To turn off use of bigBuf
  w.no_display_or_file = hold_no_display_or_file;
  wf->DisplayAndFile("\nCONTEXTS sent to file.", 2);
}

// Displays contexts for given cluster.
void disp_nodeA(short clust)
{ short i;
  struct nodeA *assptr;
  pp->nodecountA[clust] = 0;
  pp->predcountA[clust] = 0;
  pp->probcountA[clust] = 0;
  pp->bkptcountA[clust] = 0;
  for (i=0; i < pp->maxnodeA[clust]; i++)
	 {assptr = &pp->clustersA[clust].assA[i];
	  if (assptr->step_last_used == NULLSTEP) continue;
      pp->nodecountA[clust]++;
      wf->FileOnly("\nNode");
	  display_node_to_file(i, assptr->temp);
	  sprintf(wf->wBuf," XPN=%.2f AGE=%d last-used=%d BKPT=(", assptr->expn, assptr->age,assptr->step_last_used);
	  wf->FileOnly(wf->wBuf);
	  if (assptr->back != NULLLONG) display_backpointers(clust, assptr->back);
	  if (assptr->pei != NULLLONG)   display_peiA(clust, assptr->pei);
	 }
  wf->FileOnly("\n");
  for (i= pp->max_nov; i >= 0; i--)
	  if ( pp->clustersA[clust].nov[i] > 0 )
		 {sprintf(wf->wBuf,"%d:%d ",i,pp->clustersA[clust].nov[i]);
		  wf->FileOnly(wf->wBuf);
		 }
  sprintf(wf->wBuf,"\nnodes=%d, preds=%d, ptr-probs=%d, bkptrs=%d ",
	 pp->nodecountA[clust],pp->predcountA[clust],pp->probcountA[clust],pp->bkptcountA[clust]);
  wf->FileOnly(wf->wBuf);
}

void disp_nodeS(short clust)
{ short i;
  struct nodeS *assptr;
  pp->nodecountS[clust] = 0;
  pp->predcountS[clust] = 0;
 for (i=0; i < pp->maxnodeS[clust]; i++)
	 {assptr = &pp->clustersS[clust].assS[i];
	  if (assptr->step_last_used == NULLSTEP) continue;
      pp->nodecountS[clust]++;
      wf->FileOnly("\nNode");
	  display_node_to_file(i, assptr->temp);
	  sprintf(wf->wBuf," AGE=%d last-used=%d ", assptr->age,assptr->step_last_used);
	  wf->FileOnly(wf->wBuf);
	  if (assptr->pei != NULLLONG)   display_peiS(clust, assptr->pei);
	 }
  sprintf(wf->wBuf, "\nnodes=%d, preds=%d ",
                          pp->nodecountS[clust],pp->predcountS[clust]);
  wf->FileOnly(wf->wBuf);
}

// Displays number, template and cluster of a context to screen & file
void display_node(short node, short temp, short window)
{ if (w.no_display_or_file) return;
  if (pp->templates[temp].acst == AC)
	 sprintf(wf->wBuf," %d%s%s",
			  node, pp->templates[temp].tname,
			  cluster_namesA[pp->templates[temp].clust]);
  else sprintf(wf->wBuf," %d%s%s",
			  node, pp->templates[temp].tname,
			  cluster_namesS[pp->templates[temp].clust]);
  wf->DisplayAndFile(wf->wBuf, window);
}

// Displays number, template and cluster of a context to file only.
void display_node_to_file(short node, short temp)  // string from context number
{ if (pp->templates[temp].acst == AC)
	 sprintf(wf->wBuf," %d%s%s",
			  node, pp->templates[temp].tname,
			  cluster_namesA[pp->templates[temp].clust]);
  else sprintf(wf->wBuf," %d%s%s",
			  node, pp->templates[temp].tname,
			  cluster_namesS[pp->templates[temp].clust]);
  wf->FileOnly(wf->wBuf);
}

void display_backpointers(short cluster, long backpr)
{ struct back_pointer *bkptr;
  while (backpr != NULLLONG)
	  {bkptr = &pp->clustersA[cluster].bptr[backpr];
		sprintf(wf->wBuf,"%ld ",(bkptr->node));
		wf->FileOnly(wf->wBuf);
        pp->bkptcountA[cluster]++;
		backpr = bkptr->next;
	  }
  wf->FileOnly(")");
}

void display_peiA(short cluster, long peip)
{ struct predictionA *pred;
  pred = &pp->clustersA[cluster].prdA[peip];
  if ( pred->next != NULLLONG ) display_peiA(cluster,pred->next); // displays all recursively
  wf->FileOnly("\n");
  if (pred->event.event == NULLEVENT) return;
  pp->predcountA[cluster]++;
  event_to_string(pred->event.type,pred->event.event);
  wf->FileOnly(wf->wBuf);
  sprintf(wf->wBuf," tXPN=%.2f tAGE=%d RwdRate-f/d=%d/%d NOV=%d DIS=%d MRK=%d", // LM=%d,
		 pred->expn, pred->age, pred->reward_rate_f, pred->reward_rate_d,
					 pred->novelty, pred->disapproval, pred->mark); 
  wf->FileOnly(wf->wBuf);
  if (pred->novelty & w.good) pp->clustersA[cluster].nov[w.good]++;
  if ((pred->novelty & w.food)
                  && (pred->reward_rate_f > pp->reward_rate_threshold))
	  pp->clustersA[cluster].nov[w.food]++;
  if ((pred->novelty & w.drink)
                  && (pred->reward_rate_d > pp->reward_rate_threshold))
	  pp->clustersA[cluster].nov[w.drink]++;
  if ((pred->novelty == w.plus)
                  && (pred->reward_rate_f > pp->reward_rate_threshold)
                  && (pred->reward_rate_d > pp->reward_rate_threshold))
	  pp->clustersA[cluster].nov[w.plus]++;
  if (pred->novelty & 1)
	  pp->clustersA[cluster].nov[1]++;
  if ((!pred->novelty)
      || ((pred->novelty & w.food)  && (pred->reward_rate_f <= pp->reward_rate_threshold))
      || ((pred->novelty & w.drink) && (pred->reward_rate_d <= pp->reward_rate_threshold)))
	  pp->clustersA[cluster].nov[0]++;
  if (pred->ptr_prob) 	display_ptrprob(cluster, pred->ptr_prob);
}

void display_peiS(short cluster, long peip)
{ struct predictionS *pred;
  pred = &pp->clustersS[cluster].prdS[peip];
  pp->predcountS[cluster]++;
  if ( pred->next != NULLLONG ) display_peiS(cluster,pred->next); // displays all recursively
  wf->FileOnly("\n");
  if (pred->event.event == NULLEVENT) return;
  event_to_string(pred->event.type,pred->event.event);
  wf->FileOnly(wf->wBuf);
  sprintf(wf->wBuf," tAGE=%d", pred->age);   // No last_nodes    30dec99
  wf->FileOnly(wf->wBuf);
}

void display_ptrprob(short cluster, long  pprob)
{ short countprobs = 0;
  struct pointer_prob *prbptr;
  while ( pprob != NULLLONG )
		 {if ( ++countprobs > 5 )  // Move to next line if more than 5 probs
			 {countprobs = 0; wf->FileOnly("\n   ");}
		  prbptr = &pp->clustersA[cluster].pprb[pprob];
		  pp->probcountA[cluster]++;
		  sprintf(wf->wBuf,"(%ld>%d)",prbptr->node, prbptr->prob);
		  wf->FileOnly(wf->wBuf);
		  pprob = prbptr->next;
		 }
}

void display_best_predictionsA()
{ short str, node, cluster, i;
  if (w.no_display_or_file) return;
  wf->DisplayAndFile("\nBest preds:", 0);
  for (str=0; str<s->nastreams; str++)
	  {if ( pp->best_predictionsA[str].event.event == NULLEVENT ) continue;
		sprintf(wf->wBuf,"\n stream %d:",str);
		wf->DisplayAndFile(wf->wBuf, 0);
		for (i=0; i<MAX_NODES_PER_CHOICE; i++)
		  {node = pp->best_predictionsA[str].chnodesA[i].node;
			if (node == NULLNODE) break;
			cluster = pp->best_predictionsA[str].chnodesA[i].cluster;
			display_node(node, pp->clustersA[cluster].assA[node].temp, 0);
		  }
		sprintf(wf->wBuf,"(%d:%X),wrth=%f", pp->best_predictionsA[str].event.type,
					  pp->best_predictionsA[str].event.event,
					  pp->best_predictionsA[str].worth);
		wf->DisplayAndFile(wf->wBuf, 0);   }
}             // 3 pgens instead of 1 to avoid declaring another char[40]

void display_best_predictionsS()
{ short str, node, cluster, i;
  if (w.no_display_or_file) return;
  wf->DisplayAndFile("\nBest preds:", 0);
  for (str=s->nastreams; str<s->nstreams; str++)
	  {if ( pp->best_predictionsS[str].event.event == NULLEVENT ) continue;
		sprintf(wf->wBuf,"\n stream %d:",str);
		wf->DisplayAndFile(wf->wBuf, 0);
		for (i=0; i<MAX_NODES_PER_CHOICE; i++)
		  {node = pp->best_predictionsS[str].chnodesS[i].node;
			if (node == NULLNODE) break;
			cluster = pp->best_predictionsS[str].chnodesS[i].cluster;
			display_node(node, pp->clustersS[cluster].assS[node].temp, 0);
		  }
		sprintf(wf->wBuf,"(%d:%X),wrth=%f", pp->best_predictionsS[str].event.type,
					  pp->best_predictionsS[str].event.event,
					  pp->best_predictionsS[str].age_worth);
		wf->DisplayAndFile(wf->wBuf, 0);   }
}             // 3 pgens instead of 1 to avoid declaring another char[40]

void display_choice_listsS()
{ short stream, node, cluster, i;
  long chevent;
  wf->DisplayAndFile("\nChoice lists S:", 0);
  for (stream=s->nastreams; stream<s->nstreams; stream++)
	  {sprintf(wf->wBuf,"\n stream %d:",stream);
		wf->DisplayAndFile(wf->wBuf, 0);
		for (i=0; i<(MAX_CHOICES-1); i++)
			{chevent = pp->choice_listsS[stream].charray[i].event.event;
			 if (chevent == NULLEVENT) break;
			 sprintf(wf->wBuf,"(%d:%X),wrth=%f",
					  pp->choice_listsS[stream].charray[i].event.type,
					  pp->choice_listsS[stream].charray[i].event.event,
					  pp->choice_listsS[stream].charray[i].age_worth);
			 wf->DisplayAndFile(wf->wBuf, 0);
			}
	  }
}

void display_rest_choice_listsS()
{ short stream;
  if (w.no_display_or_file) return;
  wf->DisplayAndFile("\nRest_Choice lists S:", 0);
  for (stream=s->nastreams; stream<s->nstreams; stream++)
	  {sprintf(wf->wBuf,"\nstream %d: index_best=%d, rest_worth =%d",
				 stream, pp->rest_choice_list_S[stream].index_best,
				 pp->rest_choice_list_S[stream].rest_worth);
		wf->DisplayAndFile(wf->wBuf, 0);
	  }
}

//c void display_board_and_canvas()   // canvas only if robot A.
void display_board()
{ char stepBuf[24];
  short i;
  wf->wBuf[0] = '\0';
  if (!(w.no_display_or_file))
	 {wf->wBuf[0] = '\n';
	  for (i=0; i<25; i++)   board_str(i);
//c 	  if (w.jumping)
         wf->wBuf[100] = '\0';
//c 	  else
//c 		{if (w.robot == 'B')
//c 			{wf->wBuf[102] =  wf->wBuf[101] =  wf->wBuf[100] = '\n';
//c 			 wf->wBuf[104] =  wf->wBuf[103] =  '\n'; wf->wBuf[105] =  '\0';
//c 			}
//c 		 else
//c 			{wf->wBuf[101] =  wf->wBuf[100] = '\n';
//c 			 for (i=0; i<25; i++)   canvas_str(i, 102 + i + i);
//c 			 wf->wBuf[152] = '\0';
//c 			}
//c 		}
		wf->FileOnly(wf->wBuf);
	  }
  sprintf(stepBuf, "\nstep=%d", s->step);
  strcat(wf->wBuf, stepBuf);
  wf->DisplayAndFile(wf->wBuf, 1);    // Window 1 - Goes to file if not jumping
}

void board_str(short board_posn)
{ unsigned long rtbyte, mdbyte, ltbyte;
  short k;
  rtbyte = w.board[board_posn] & 0X000000FF;
  mdbyte = ( w.board[board_posn] >>  8 ) & 0X000000FF;
  ltbyte = ( w.board[board_posn] >> 16 ) & 0X000000FF;
  k = (board_posn * 4) + 1;
  wf->wBuf[k] = charof(ltbyte);
  wf->wBuf[k+1] = charof(mdbyte);
  wf->wBuf[k+2] = charof(rtbyte);
  if ( (k+3)%20 == 0 ) wf->wBuf[k+3] = '\n';
  else                 wf->wBuf[k+3] = ' ';
}

//c void canvas_str(short canvas_posn, short index)
//c { unsigned long rtbyte;
//c   rtbyte = pp->canvas[canvas_posn] & 0X000000FF;
//c   wf->wBuf[index] = charof(rtbyte);
//c   if ( (index-100)%10 == 0 ) wf->wBuf[index+1] = '\n';
//c   else                  wf->wBuf[index+1] = ' ';
//c }

//c void display_canvas()
//c { short i,j,k=0;
//c   wf->wBuf[k++] = '/';
//c   for (i=6; i<17; i+=5)
//c 	  for (j=0; j<3; j++)
//c 		wf->wBuf[k++] = charof(pp->canvas[i+j] & 0X000000FF);
//c   wf->wBuf[k++] = '/';wf->wBuf[k++] = '\0';
//c   wf->DisplayAndFile(wf->wBuf, 0);
//c }

// *****  Character from Byte, with exceptions: 0 as -, 1-9 as digit chars.
char charof(unsigned long ulbyte)
{ short shbyte;
  shbyte = (short) ulbyte;
  if ((shbyte > 0) && ( shbyte < 10 )) shbyte += 48;
  ulbyte = (unsigned long) shbyte;
  switch (ulbyte)
	{case ULONG_ZERO : return( '-' );
	 case ULONG_1 : return( '1' );
	 case ULONG_2 : return( '2' );
	 case ULONG_3 : return( '3' );
	 case ULONG_4 : return( '4' );
	 case ULONG_5 : return( '5' );
	 case ULONG_6 : return( '6' );
	 case ULONG_7 : return( '7' );
	 case ULONG_8 : return( '8' );
	 case ULONG_9 : return( '9' );
	 case ULONG_a : return( 'a' );
	 case ULONG_b : return( 'b' );
	 case ULONG_x : return( 'x' );
	 case ULONG_y : return( 'y' );
	 case ULONG_z : return( 'z' );
	 case ULONG_A : return( 'A' );
	 case ULONG_B : return( 'B' );
	 case ULONG_C : return( 'C' );
	 case ULONG_D : return( 'D' );
	 case ULONG_E : return( 'E' );
	 case ULONG_F : return( 'F' );
	 case ULONG_G : return( 'G' );
	 case ULONG_H : return( 'H' );
	 case ULONG_I : return( 'I' );
	 case ULONG_J : return( 'J' );
	 case ULONG_K : return( 'K' );
	 case ULONG_L : return( 'L' );
	 case ULONG_M : return( 'M' );
	 case ULONG_N : return( 'N' );
	 case ULONG_O : return( 'O' );
	 case ULONG_P : return( 'P' );
	 case ULONG_Q : return( 'Q' );
	 case ULONG_R : return( 'R' );
	 case ULONG_S : return( 'S' );
	 case ULONG_T : return( 'T' );
	 case ULONG_U : return( 'U' );
	 case ULONG_V : return( 'V' );
	 case ULONG_W : return( 'W' );
	 case ULONG_X : return( 'X' );
	 case ULONG_Y : return( 'Y' );
	 case ULONG_Z : return( 'Z' );
	 case ULONG_DASH : return( '-' );
	 case ULONG_WALL : return( '=' );
	 case ULONG_BLANK : return( ' ' );
	 case ULONG_QUERY : return( '?' );
	 default : error("Illegal character: ", ulbyte);
	} return( 'z' );   // to avoid compiler warning
}

void display_priority(struct temp_priority_entry *priptr, short lev, char *str)
{ struct temp_priority_entry	*prptrm, *prptrnom;
  short level;
  char strg[100] = "\t";
  strcat(strg, str);
  level = lev + 1;
  prptrm = priptr->match;
  prptrnom = priptr->nomatch;
  if ((prptrm) && (prptrm->temp == prptrnom->temp))
	 {sprintf(wf->wBuf, "  %d,no/match=%s", lev,pp->templates[prptrm->temp].tname);
	  wf->DisplayAndFile(wf->wBuf, 0);
	  if ( !(level%5) ) wf->DisplayAndFile("\n", 0);
	  display_priority(prptrm, level, strg);
	 }
  else
	 {if ( prptrm )
		 {sprintf(wf->wBuf, "  %d,match=%s", lev,pp->templates[prptrm->temp].tname);
		  wf->DisplayAndFile(wf->wBuf, 0);
		  display_priority(prptrm, level, strg);
		 }
	  if ( prptrnom )
		 {sprintf(wf->wBuf, "\n%s%dnomatch=%s",
										str,lev,pp->templates[prptrnom->temp].tname);
		  wf->DisplayAndFile(wf->wBuf, 0);
		  display_priority(prptrnom, level, strg);
		 }
	 }
}

void display_plan_steps()
{ short i;
  long count =0;
  wf->FileOnly("\nRewarded Plans longer than 3:");
  for (i=0; i<pp->last_rewarded_plan_number; i++)
	  {count++;
		if (count%8) sprintf(wf->wBuf," %d:%d", count, pp->rewarded_plans[i]);
		else          sprintf(wf->wBuf,"\n%d:%d", count, pp->rewarded_plans[i]);
		wf->FileOnly(wf->wBuf);
	  }
  wf->FileOnly("\nPlans sent to file:");
}

void display_graph_line(short line)
{sprintf(wf->wBuf,
  "\n     %d  %d %d %d %d %d %d %d  %d %d %d %d %d %d %d  %d %d %d %d %d %d  %d  %d %d %d %d" ,
						 w.m_file[line].number_step_cycles,
						 w.m_file[line].A_subacts,
						 w.m_file[line].A_steps_below_sub,
						 w.m_file[line].A_reward_fs,
						 w.m_file[line].A_reward_ds,
						 w.m_file[line].A_total_fs,
						 w.m_file[line].A_total_ds,
						 w.m_file[line].A_reward_gs,
						 w.m_file[line].B_reward_fs,
						 w.m_file[line].B_reward_ds,
						 w.m_file[line].B_total_fs,
						 w.m_file[line].B_total_ds,
						 w.m_file[line].B_rewards_nofd,
						 w.m_file[line].B_steps_below_sub,
						 w.m_file[line].number_of_B_tells,
						 w.m_file[line].number_BE_associations,
						 w.m_file[line].number_f_rewarded_BE_associations,
						 w.m_file[line].number_d_rewarded_BE_associations,
						 w.m_file[line].number_fd_rewarded_BE_associations,
						 w.m_file[line].number_novelty_BE_associations,
						 w.m_file[line].number_plans_followed,
						 w.m_file[line].number_TCH_associations,
						 w.m_file[line].number_PR_associations,
						 w.m_file[line].number_F_associations,
						 w.m_file[line].number_W_associations,
						 w.m_file[line].number_DN_associations
                         );
 wf->FileOnly(wf->wBuf);
}

// An extra graph line can be obtained on the robot B half-step of a multiple of
//  w.step_cycle_before_counters_zeroed.
void display_extra_graph_line()  // Do before robot A parameters zeroed.
{long step, stepsfOB, stepsdQB, stepsblB;
 if ((w.robot == 'A') || (step%w.step_cycle_before_counters_zeroed))
   {cout << "\nNot Robot B or not multiple of step_cycle_before_counters_zeroed."
         << endl;
    return;
   }
 stepsfOB = s->steps_with_f_drive_and_O;
 stepsdQB = s->steps_with_d_drive_and_Q;
 stepsblB = s->steps_below_sublevel;
  if ((s->drive & w.food) && (w.current_goal == ULONG_O))
	  stepsfOB++;
  if ((s->drive & w.drink) && (w.current_goal == ULONG_Q))
	  stepsdQB++;
  if ((s->resource_f < w.sublevel) || (s->resource_d < w.sublevel))
	  stepsblB++;
 wf->FileOnly(
  "\nz:Step Asbs/l ArwdsF/DtotF/D GD BrwdsF/DtotF/DnoFDsbl tells BEass/F/D/FD/nov plansf TCH/PR/F/W/DN ");
 sprintf(wf->wBuf,
  "\n     %d  %d %d %d %d %d %d %d  %d %d %d %d %d %d %d  %d %d %d %d %d %d  %d  %d %d %d %d",
  s->step,
  sa->subsumption_counter,
  sa->steps_below_sublevel,
  sa->reward_counter_f,
  sa->reward_counter_d,
  sa->steps_with_f_drive_and_O,
  sa->steps_with_d_drive_and_Q,
  sa->reward_counter_gd,
  s->reward_counter_f,
  s->reward_counter_d,
  stepsfOB,
  stepsdQB,
  s->rewards_without_drivefd,
  stepsblB,
  s->number_of_B_tells,
  pp->clustersA[CLBE].highest_node,
  pp->clustersA[CLBE].nov[w.food],
  pp->clustersA[CLBE].nov[w.drink],
  pp->clustersA[CLBE].nov[PLUS],
  pp->clustersA[CLBE].nov[1],
  pp->last_rewarded_plan_number,
  pp->clustersS[CLTCH].highest_node,
  pp->clustersS[CLPR].highest_node,
  pp->clustersS[CLF].highest_node,
  pp->clustersS[CLW].highest_node,
  pp->clustersS[CLDN].highest_node);
 wf->FileOnly(wf->wBuf);
}

void fill_file_lineA()   // Must be done when robot is A
{    w.m_file[w.m_file_line].number_step_cycles = w.number_step_cycles;
	 w.m_file[w.m_file_line].A_subacts = s->subsumption_counter;
	 w.m_file[w.m_file_line].A_steps_below_sub = s->steps_below_sublevel;
	 w.m_file[w.m_file_line].A_reward_fs = s->reward_counter_f;
	 w.m_file[w.m_file_line].A_reward_ds = s->reward_counter_d;
	 w.m_file[w.m_file_line].A_total_fs = s->steps_with_f_drive_and_O;
	 w.m_file[w.m_file_line].A_total_ds = s->steps_with_d_drive_and_Q;
	 w.m_file[w.m_file_line].A_reward_gs = s->reward_counter_gd;
	 w.m_file[w.m_file_line].number_BE_associations = pp->clustersA[CLBE].highest_node;
	 w.m_file[w.m_file_line].number_f_rewarded_BE_associations = pp->clustersA[CLBE].nov[w.food];
	 w.m_file[w.m_file_line].number_d_rewarded_BE_associations = pp->clustersA[CLBE].nov[w.drink];
	 w.m_file[w.m_file_line].number_fd_rewarded_BE_associations = pp->clustersA[CLBE].nov[PLUS];
	 w.m_file[w.m_file_line].number_novelty_BE_associations = pp->clustersA[CLBE].nov[1];
	 w.m_file[w.m_file_line].number_plans_followed = pp->last_rewarded_plan_number;
	 w.m_file[w.m_file_line].number_TCH_associations = pp->clustersS[CLTCH].highest_node;
	 w.m_file[w.m_file_line].number_PR_associations = pp->clustersS[CLPR].highest_node;
	 w.m_file[w.m_file_line].number_F_associations = pp->clustersS[CLF].highest_node;
	 w.m_file[w.m_file_line].number_W_associations = pp->clustersS[CLW].highest_node;
	 w.m_file[w.m_file_line].number_DN_associations = pp->clustersS[CLDN].highest_node;
}

void  fill_file_lineB()
{ w.m_file[w.m_file_line].B_reward_fs = s->reward_counter_f;
  w.m_file[w.m_file_line].B_reward_ds = s->reward_counter_d;
  w.m_file[w.m_file_line].B_total_fs = s->steps_with_f_drive_and_O;
  w.m_file[w.m_file_line].B_total_ds = s->steps_with_d_drive_and_Q;
  w.m_file[w.m_file_line].B_rewards_nofd = s->rewards_without_drivefd;
  w.m_file[w.m_file_line].B_steps_below_sub = s->steps_below_sublevel;
  w.m_file[w.m_file_line].number_of_B_tells = s->number_of_B_tells;
}

void display_graph(short line)
{ short i, j;
  char bufd[10], buft[10];
  wf->DisplayAndFile("\n\nBelow here replace z by percent sign for MatLab.", 0);
  wf->DisplayAndFile("\n\nzGraph as M file for MATLAB.", 0);
  sprintf(wf->wBuf, "\nzFile: %s on %s at %s. " ,
										wf->File->Main, _strdate(bufd), _strtime(buft) );
  wf->FileOnly(wf->wBuf);
  wf->FileOnly(
 	"\nz:Cycs Asbs/l ArwdsF/DtotF/D GD BrwdsF/DtotF/DnoFDsbl tells BEass/F/D/FD/nov plansf TCH/PR/F/W/DN ");
  wf->FileOnly("\ngr= [");
  for (i=0; i<=line; i++) display_graph_line(i);
  wf->FileOnly("\n                                                      ];");
  wf->FileOnly("\nloglog(gr(:,1),gr(:,2),gr(:,1),gr(:,3),gr(:,1),gr(:,4),...");
  wf->FileOnly(
			 "\ngr(:,1),gr(:,5),gr(:,1),gr(:,6),gr(:,1),gr(:,7),gr(:,1),gr(:,8))");
  sprintf(wf->wBuf, "\ntitle('SQUASH-POP World.  %s ');",  _strdate(bufd) );
  wf->FileOnly(wf->wBuf);
//  sprintf(wf->wBuf, "\nxlabel('%ds of steps');", w.memDumpJump );
//  wf->FileOnly(wf->wBuf);
  wf->FileOnly("\nylabel('Rewards, Associations, Plans Followed');");
  FileOnly_world_data();
  sprintf(wf->wBuf,"\nzpp->reward-rate-threshold=%d ",pp->reward_rate_threshold);
  wf->DisplayAndFile(wf->wBuf, 2);
  for (i=0; i < pp->ntemplates;i++)
   {sprintf(wf->wBuf,"\nzTemplate(%d)%s %s:", i,pp->templates[i].tname,
								kindofpred_string[pp->templates[i].kindofpred]);
	wf->DisplayAndFile(wf->wBuf, 2);
	for (j=0; j < pp->templates[i].noEvTypesInContext; j++)
	  display_type_and_shift(pp->templates[i].eventdef[j]);
	wf->DisplayAndFile("\nz  >>", 2);
	for (j=0; j < pp->templates[i].npreds; j++)
	  {sprintf(wf->wBuf, " %s",
						  event_type_names[pp->templates[i].predict_event_type[j]]);
	   wf->DisplayAndFile(wf->wBuf, 2);
	  }
   }
 }

void display_reward_getting_associations()
{ short i;
  wf->DisplayAndFile("\n\nzReward-getting associations: ", 0);
  for (i=0; i<=pp->highest_reward_getting_association; i++)
		{sprintf(wf->wBuf, "\nzStep %d: ", pp->rgass[i].step);
		 wf->FileOnly(wf->wBuf);
		 display_node_to_file(pp->rgass[i].node, pp->rgass[i].temp);
		 event_to_string(pp->rgass[i].evtyp.type, pp->rgass[i].evtyp.event);
		 wf->FileOnly(wf->wBuf);
		}
}

void display_array_assA()
{ short i, k;
  for (i=0; i < pp->naclusters; i++)
    {sprintf(wf->wBuf, "\nArray assA[] for cluster %s on step=%d, \nempty_assA_list points to %d",
        cluster_namesA[i], s->step, pp->clustersA[i].empty_assA_list);
     wf->DisplayAndFile(wf->wBuf, 0);
     for (k=0; k < pp->maxnodeA[i]; k++)
	   {sprintf(wf->wBuf, "\nassA[%d]: step_last_used=%d, pei=%d, back=%d, ctxtel=%d, next=%d", k,
                       pp->clustersA[i].assA[k].step_last_used,
			           pp->clustersA[i].assA[k].pei,
			           pp->clustersA[i].assA[k].back,
			           pp->clustersA[i].assA[k].ctxtel,
			           pp->clustersA[i].assA[k].next);
        wf->FileOnly(wf->wBuf);
       }
    }
}


void display_array_prdA()
{ short i;
  long k;
  for (i=0; i < pp->naclusters; i++)
   {sprintf(wf->wBuf, "\nArray prdA[] for cluster %s, step=%d, \nempty_prdA_list starts %d",
          cluster_namesA[i], s->step, pp->clustersA[i].empty_prdA_list);
    wf->DisplayAndFile(wf->wBuf, 0);
    for (k=0; k < pp->maxpredA[i]; k++)
	 {sprintf(wf->wBuf, "\nprdA[%d]: mark=%d, event=%X, ptr_prob=%d, next=%d", k,
                       pp->clustersA[i].prdA[k].mark,     // temp addition 26jly01
                       pp->clustersA[i].prdA[k].event.event,
			           pp->clustersA[i].prdA[k].ptr_prob,
			           pp->clustersA[i].prdA[k].next);
      wf->FileOnly(wf->wBuf);
     }
   }
}


void display_array_pprb()
{ short i;
  long k;
  for (i=0; i < pp->naclusters; i++)
   {sprintf(wf->wBuf, "\nArray pprb[] for cluster %s, step=%d, \nempty_pprb_list points to %d",
            cluster_namesA[i], s->step, pp->clustersA[i].empty_pprb_list);
    wf->DisplayAndFile(wf->wBuf, 0);
    for (k=0; k < pp->maxprobA[i]; k++)
	 {sprintf(wf->wBuf, "\npprb[%d]: node=%d, prob=%d, next=%d", k,
                       pp->clustersA[i].pprb[k].node,
			           pp->clustersA[i].pprb[k].prob,
			           pp->clustersA[i].pprb[k].next);
      wf->FileOnly(wf->wBuf);
     }
   }
}

void display_array_bptr()
{ short i;
  long k;
  for (i=0; i < pp->naclusters; i++)
    {sprintf(wf->wBuf, "\nArray bptr[] for cluster %s on step=%d, \nempty_bkptr_list points to %d",
              cluster_namesA[i], s->step, pp->clustersA[i].empty_bkptr_list);
     wf->DisplayAndFile(wf->wBuf, 0);
     for (k=0; k < MAX_BACK_POINTERS; k++)
	   {sprintf(wf->wBuf, "\nbptr[%d]: node=%d, next=%d", k,
                       pp->clustersA[i].bptr[k].node,
			           pp->clustersA[i].bptr[k].next);
        wf->FileOnly(wf->wBuf);
       }
    }
}

void display_array_assS()
{ short i, k;
  for (i=0; i < pp->nsclusters; i++)
    {sprintf(wf->wBuf,
      "\nArray assS[] for cluster %s on step=%d, \nempty_assS_list starts %d",
            cluster_namesS[i], s->step, pp->clustersS[i].empty_assS_list);
     wf->DisplayAndFile(wf->wBuf, 0);
     for (k=0; k < pp->maxnodeS[i]; k++)
	    {sprintf(wf->wBuf,
                   "\nassS[%d]: step_last_used=%d, pei=%d, ctxtel=%d, next=%d",
                       k,
                       pp->clustersS[i].assS[k].step_last_used,
			           pp->clustersS[i].assS[k].pei,
			           pp->clustersS[i].assS[k].ctxtel,
			           pp->clustersS[i].assS[k].next);
         wf->FileOnly(wf->wBuf);
        }
    }
}


void display_array_prdS()
{ short i;
  long k;
  for (i=0; i < pp->nsclusters; i++)
    {sprintf(wf->wBuf,
      "\nArray prdS[] for cluster %s on step=%d, \nempty_prdS_list starts %d",
               cluster_namesS[i], s->step, pp->clustersS[i].empty_prdS_list);
     wf->DisplayAndFile(wf->wBuf, 0);
     for (k=0; k < pp->maxpredS[i]; k++)
	   {sprintf(wf->wBuf, "\nprdS[%d]: event=%X, next=%d", k,
                       pp->clustersS[i].prdS[k].event.event,
			           pp->clustersS[i].prdS[k].next);
        wf->FileOnly(wf->wBuf);
       }
    }
}


void display_array_ctxtA()
{ long k;
  short i, j, temp;
  for (i=0; i < pp->naclusters; i++)
    {sprintf(wf->wBuf,
      "\nLTM Array ctxtA[]: cluster %s, step=%d, \nempty_ctxtA_list starts %d",
             cluster_namesA[i], s->step, pp->clustersA[i].empty_ctxtA_list);
     wf->DisplayAndFile(wf->wBuf, 0);
     for (j=0; j < pp->clustersA[i].ntemps; j++)
      {temp = pp->clustersA[i].tem[j];
       sprintf(wf->wBuf,"\nTemplate %s,base-->%d", pp->templates[temp].tname,
                                               pp->templates[temp].base);
       wf->FileOnly(wf->wBuf);
      }
     for (k=0; k < MAX_CONTEXT_LINKS_A; k++)
	    {sprintf(wf->wBuf,
          "\nctxtA[%d]: type=%d, event=%X, next=%d, next_list=%d, linkbk=%d", k,
                       pp->clustersA[i].ctxtA[k].event.type,
                       pp->clustersA[i].ctxtA[k].event.event,
			           pp->clustersA[i].ctxtA[k].next,
			           pp->clustersA[i].ctxtA[k].next_list,
			           pp->clustersA[i].ctxtA[k].linkbk);
         wf->FileOnly(wf->wBuf);
        }
    }
}

void display_array_ctxtS()
{ long k;
  short i, j, temp;
  for (i=0; i < pp->nsclusters; i++)
    {sprintf(wf->wBuf,
       "\nLTM Array ctxtS[] for cluster %s on step=%d, \nempty_ctxtS_list starts%d",
                cluster_namesS[i], s->step, pp->clustersS[i].empty_ctxtS_list);
     wf->DisplayAndFile(wf->wBuf, 0);
     for (j=0; j < pp->clustersS[i].ntemps; j++)
      {temp = pp->clustersS[i].tem[j];
       sprintf(wf->wBuf,"\nLTM Tree for template %s,base-->%d",
                   pp->templates[temp].tname, pp->templates[temp].base);
       wf->FileOnly(wf->wBuf);
      }
     for (k=0; k < MAX_CONTEXT_LINKS_S; k++)
	    {sprintf(wf->wBuf,
          "\nctxtS[%d]: type=%d, event=%X, next=%d, next_list=%d, linkbk=%d", k,
                       pp->clustersS[i].ctxtS[k].event.type,
                       pp->clustersS[i].ctxtS[k].event.event,
			           pp->clustersS[i].ctxtS[k].next,
			           pp->clustersS[i].ctxtS[k].next_list,
			           pp->clustersS[i].ctxtS[k].linkbk);
         wf->FileOnly(wf->wBuf);
        }
    }
}

void  display_arrays_A()
{ display_array_assA();
  display_array_prdA();
  display_array_pprb();
  display_array_bptr();
  display_array_ctxtA();
}

void display_arrays_S()
{ display_array_assS();
  display_array_prdS();
  display_array_ctxtS();
}

