// ppworld.cpp     PURRPUSS                          jha: 15aug98-16jly01

//             SQUASH-POP WORLD

// Having Robot help Robot A increases the number of rewards obtained by
// Robot A, which speeds learning, and also makes Robot A's environment
// more predictable, which also speeds learning.

// Calculation of Numbers of Events at end of this program.
// Widened canvas to 5x5, although only 3x3 is used as before. The extra
//  rows and columns should eliminate most of the ?'s in the 3x3. 8nov99

// Strengthened Robot B's strategy to be more helpful and less random. 21jan00
// 28mar00  Corrected program implementing Robot B's help-A strategy.
// 10apr00  Increased resolution of PROPRIOCEP and included it in template BE.
// 17apr00  PROPRIOCEP used in B-helps-A strategy.
// 20apr00  Increased resolution of PROPRIOCEP to 5x5 cells inside NN,EE,SS,WW
// 04jly00  With double corner world, Robot B also helps by favouring clockwise.

#include "c:\Program Files\Borland\CBuilder3\examples\foodrink\ppheader.hpp"

extern robot_info *s;
extern robot_info *sa;
extern robot_info *sb;
extern pp_info *pp;
extern world w;
extern TWindFile *wf;


 char *event_type_names[] =
		{"BodyMove", "Forward", "Left", "Right", "Turn",
		 "EyeMove", "EyeStay", "EyeNorth", "EyeEast", "EyeSouth", "EyeWest",
		 "NotYEyeMove",
		 "BodyEye",
		 "Say",
		 "Touch", "Propr", "Fovea",
		 "Wide", "WideNOnly", "WideEOnly", "WideSOnly", "WideWOnly",
		 "Dirn",
		 "Hear", "HearSF", "HearOR", "HearFO",
         "Desire",
		 "MARKER"		 };

 char *template_names[] =
		{"BE",
		 "SA",
		 "Tch",
		 "PR",
		 "F",
		 "W",
 		 "DN", "DNU",
		 "SS",
         "DE",
		 "NOTEMP"       };

char *cluster_namesA[] =
	  {"ClBE", "ClSA", "NOCLUSTERA"  };
char *cluster_namesS[] =
	  {"ClTch", "ClPR", "ClFs",
		"ClW",
		"ClDN", "ClDNU",
		"ClSS",
    "ClDE",
		"NOCLUSTERS"     };

char *stream_names[] =
	  {"BEStr", "SAStr",
	   "TchStr", "PropStr",
       "FovStr", "WideStr", "DirnStr",
       "SSStr",
       "DEStr",
//       "LMStr",
	   "NOSTREAM"     };


//w.board[BOARD_CELLS]
//	  = { ULONG_WALL, ULONG_WALL, ULONG_WALL, ULONG_WALL, ULONG_WALL,
//	  	   ULONG_WALL, 0X00004100, 0X00000000, 0X00000000, ULONG_WALL,
//	  	   ULONG_WALL, 0X00410045, 0X00000000, 0X00000000, ULONG_WALL,
//	  	   ULONG_WALL, 0X004F0000, 0X0042004E, 0X00004200, ULONG_WALL,
//	  	   ULONG_WALL, ULONG_WALL, ULONG_WALL, ULONG_WALL, ULONG_WALL,
//	    };

// *****  FUNCTION: init_actions_stim()  *****
// DESCRIPTION: Loads all default symbols.
void init_actions_stim()
{ short j;     //  k;
  for (j=0; strcmp(event_type_names[j],"MARKER"); j++)
	  {//wf->DisplayAndFile(event_type_names[j], 2);
		if ( w.diag & 16 )
		  {sprintf(wf->wBuf, "\nEvent string %d is %s ", j, event_type_names[j]);
			wf->DisplayAndFile(wf->wBuf, 2);
		  }
	  }
  sa->body.bodypos.row  = 2;
  sa->body.bodypos.col  = 1;
  sa->body.bodypos.dirn = ULONG_E;
  sb->body.bodypos.row  = 3;
  sb->body.bodypos.col  = 2;
  sb->body.bodypos.dirn = ULONG_N;
  sa->body.eyepos.row   = 1;
  sa->body.eyepos.col   = 1;
  sb->body.eyepos.row   = 3;
  sb->body.eyepos.col   = 3;
  w.object.row          = 3;
  w.object.col          = 1;
  w.board[0] = w.board[1] = w.board[2] = w.board[3] = w.board[4] = w.board[5]
	= w.board[5] = w.board[9] = w.board[10] = w.board[14]
	= w.board[15] = w.board[19] = w.board[20] = w.board[21] = w.board[22]
	= w.board[23] = w.board[24] = 0X003D3D3D;
  w.board[6] = 0X00006100;
  w.board[7] = w.board[8] = w.board[12] = w.board[13] = 0X00000000;
  w.board[11] = 0X00410045;
  w.board[16] = 0X004F0000;
  w.board[17] = 0X0042004E;
  w.board[18] = 0X00006200;

}

void draw_board()
 { short cell;
	unsigned long cell_content;
	char a_byte, b_byte, c_byte;
	for (cell=0; cell<BOARD_CELLS; cell++)
		{ cell_content = w.board[cell];
		  a_byte = (char) ( cell_content &  0X000000FF);
		  b_byte = (char) ((cell_content >>  8 ) & 0X000000FF);
		  c_byte = (char) ((cell_content >> 16 ) & 0X000000FF);
          if (a_byte == 0) a_byte = 0X0000002D;
          if (b_byte == 0) b_byte = 0X0000002D;
          if (c_byte == 0) c_byte = 0X0000002D;
		  if ( !( (cell + 1)%5 ) )      // last cell in row has \n
				 sprintf(wf->wBuf, "%c%c%c\n", c_byte, b_byte, a_byte);
		  else sprintf(wf->wBuf, "%c%c%c ",  c_byte, b_byte, a_byte);
		  wf->DisplayAndFile(wf->wBuf, 1);
		}
 }

short row_col_to_cell_no(short row, short col)
{  return( (short) ((row * 5) + col) );
}

struct board_posn cell_no_to_row_col(short cell_no )
{ struct board_posn bp;
  bp.row =  cell_no/5;
  bp.col =  cell_no%5;
  return( bp );
}

unsigned long subsumption_body_eye_move()
{ unsigned long body_move, eye_move;
  short type;
  struct event_type evtype;
  evtype.type = BODYMOVE;
  body_move = evtype.event = subsumption_body_move();
  do_action_in_world(evtype); // Must be done here so that eye move is correct.
  evtype.type = EYEMOVE;
  eye_move  = evtype.event = subsumption_eye_move(body_move);
  do_action_in_world(evtype);
  return ( (body_move << 8) | eye_move );
}

// Subsumption body move is random but favours pushing object and does not
// push wall or other robot.
// If nothing or food object ahead, Left 10%, Right 10%, Forward 80%.
// If wall or robot ahead, Left 60%, Right 40%  i.e. favours Left (anticlockwise).
unsigned long subsumption_body_move()
{ unsigned long ultouch, touch_front, help_action, hear_other;
  int random_no;
  if ( w.robot == 'A' ) s->boredom = 0; // Assumes subsumption breaks loops
//  sprintf(wf->wBuf,"\nRand for move=%d ",random_no);
//  wf->DisplayAndFile(wf->wBuf, 0);
  if ((w.robot == 'B') && (!(sa->drive & 6))      // Works in conjunction with
        && ((s->touch_evty.event == 0X002D4F3D)   // telling A on last step
            || (s->touch_evty.event == 0X002D513D) // to give robot B rewards
            || (s->touch_evty.event == 0X003D4F2D) // when A not hungry/thirsty
            || (s->touch_evty.event == 0X003D512D)))
     return(ULONG_F); // If robot A not hungry or thirsty, push object in corner.
  if (w.robot == 'B')
   {hear_other = s->hear_evty.event & 0X000000FF;
    if ((hear_other != ULONG_DASH) && (hear_other != ULONG_G))
      {help_action = hear_other; // Do what heard from other
       return( help_action );
      }
    if ( w.robot_B_helps )
	  {help_action = help_A_move_strategy();
	   if ( help_action )
		 {w.help++;
		  wf->DisplayAndFile(" b ", 0);
		  return ( help_action );
		 }
	  }
   }
  ultouch = s->touch_evty.event;  // = get_feeling_event();
  if ( w.diag & 16 )
	{sprintf(wf->wBuf, "\ntouch event for subsumption = %X ", ultouch);
	 wf->DisplayAndFile(wf->wBuf, 2);
	}
  touch_front = (( ultouch >> 8 ) & 0X000000FF);  // Removes side touching
  random_no = random(10);
  switch ( touch_front )
	 {case ULONG_DASH :			// same strategy for - and O.
	  case ULONG_O :
      case ULONG_Q : if ( random_no == 1 )      return( ULONG_L );
						 else if( random_no == 2 )  return( ULONG_R );
							  else return( ULONG_F );
	  case ULONG_WALL :			// same strategy for = and R.
	  case ULONG_R : if ( random_no > 3 )  return( ULONG_L ); // prefers left
												 else return( ULONG_R );
	  case 0X000000FF : if (s->step > 1) error("touch_front is 0X000000FF.");
							  else return( ULONG_R );
	  default  : error("Subsumption body move - touch_front:", touch_front);
	 }
  return( 0 );    // to avoid compiler warning
}

// Simple strategy for deterministic moves by B, a little helpful to A.
// If robot or wall ahead, turn right.
// If wall on right, turn right
// If nothing ahead and food or drink object on right, turn right.
// If food or drink object ahead and last action was forward, turn left.
// Else move forward.

unsigned long help_A_move_strategy()
{ unsigned long ultch; 
  int random_no;
  ultch = s->touch_evty.event;  //Assumes this is after subsumption_body_move
// If wall or robot ahead, or wall on right, exit with turn right.
  if  (((ultch & 0X0000FF00) == 0X00005200)
		 || ((ultch & 0X0000FF00) == 0X00003D00)
		 || ((ultch & 0X000000FF) == 0X0000003D)
// If nothing ahead and food/drink on right, exit with turn right.
		 || ((ultch & 0X0000FFFF) == 0X00002D4F)
		 || ((ultch & 0X0000FFFF) == 0X00002D51))
//	  {s->before_last_body_move = s->last_action[BESTR].event;
		return( ULONG_R );
//	  }
// If food/drink ahead and last or before-last action was forward, turn left.
  if ((((ultch & 0X0000FF00) == 0X00004F00)
		|| ((ultch & 0X0000FF00) == 0X00005100))
		&& (((s->last_action[BESTR].event & 0X0000FF00) == 0X00004600)
		    || ((s->before_last_body_move & 0X0000FF00) == 0X00004600)))
//	  {s->before_last_body_move = s->last_action[BESTR].event;
		return( ULONG_L );
//	  }
// Otherwise, move forward.
  if (s->events[SAY].tim_shift_reg[0] == NULLEVENT)
	 return( ULONG_F );
  else return( ULONG_L);   // after B's SAY action.
}

// Subsumption eye move:  (9mar01 move to wide before stay)
// If on wall, get off.
// If O/Q in wide, move to O/Q.
// If robot(s) in wide, move to (one of them at random) robot.
// If fovea on O/Q, staY.
// If robot in fovea, staY.
// If robot(s) in wide, move to (one of them at random) robot.
// Move North, East, South or West at random.
// Note that this strategy, with O/Q in the fovea and the two patterns
// ==AB  and  =BA= in wide, record rewardable contexts with a Forward move.
// No help-A strategy needed for robot B.
unsigned long subsumption_eye_move(unsigned long body_move)
{ short objcnt = 0;
  int randno;
  unsigned long clist[4], dlist[4], help_action;
  unsigned long ulfov, ulwdn, ulwde, ulwds, ulwdw;
  unsigned long ulwdreln, ulwdrele, ulwdrels, ulwdrelw;
  ulfov = s->events[FOVEA].tim_shift_reg[0];
  ulwdn  = s->events[WIDENONLY].tim_shift_reg[0];
  ulwde  = s->events[WIDEEONLY].tim_shift_reg[0];
  ulwds  = s->events[WIDESONLY].tim_shift_reg[0];
  ulwdw  = s->events[WIDEWONLY].tim_shift_reg[0];
  switch (body_move)
	{case (ULONG_F): ulwdreln = ulwdn;
					 ulwdrele = ulwde;
					 ulwdrels = ulwds;
					 ulwdrelw = ulwdw;
					 break;
	 case (ULONG_L): ulwdreln = ulwdw;
					 ulwdrele = ulwdn;
					 ulwdrels = ulwde;
					 ulwdrelw = ulwds;
					 break;
	 case (ULONG_R): ulwdreln = ulwde;
					 ulwdrele = ulwds;
					 ulwdrels = ulwdw;
					 ulwdrelw = ulwdn;
					 break;
	 default: error("Body-move in subsumption-eye-move is ", body_move);
	}
// If robot B telling, holds eye still to see A's move
  if ((w.robot == 'B') && (w.robot_B_tells) && (!(sa->drive & 6))
        && ((s->events[FOVEA].tim_shift_reg[0] & 0X000000FF) == ULONG_A))
     return(ULONG_Y);
// If on wall, get off.
  if ( s->events[FOVEA].tim_shift_reg[0] == ULONG_WALL )   // move eye off wall
	 {if ( s->body.eyepos.col < 1 )          return( abs_to_rel_dirn(ULONG_E));
	  if ( s->body.eyepos.col > BOARD_COLS ) return( abs_to_rel_dirn(ULONG_W));
	  if ( s->body.eyepos.row < 1 ) 		 return( abs_to_rel_dirn(ULONG_S));
	  if ( s->body.eyepos.row > BOARD_ROWS ) return( abs_to_rel_dirn(ULONG_N));
	  error("Eye is not over wall.");
	 }
  else
	 {//if ( w.robot == 'A' ) s->boredom = 0;   // Assumes subsumption breaks loops
// Robot B always does staY after SAY action. NO! It would never move its eye.
//1mar01	  if ((w.robot == 'B') && (s->events[SAY].tim_shift_reg[0] != NULLEVENT))
//1mar01		  return( ULONG_Y );
// If O or Q in wide, move to O or Q.
	  if (ulwdreln == w.current_goal) return( ULONG_N );
	  if (ulwdrele == w.current_goal) return( ULONG_E );
	  if (ulwdrels == w.current_goal) return( ULONG_S );
	  if (ulwdrelw == w.current_goal) return( ULONG_W );
// If A OR B in wide, move to it, or one at random.
	  if ((ulwdreln == ULONG_A) || (ulwdreln == ULONG_B)) clist[objcnt++] = ULONG_N;
	  if ((ulwdrele == ULONG_A) || (ulwdrele == ULONG_B)) clist[objcnt++] = ULONG_E;
	  if ((ulwdrels == ULONG_A) || (ulwdrels == ULONG_B)) clist[objcnt++] = ULONG_S;
	  if ((ulwdrelw == ULONG_A) || (ulwdrelw == ULONG_B)) clist[objcnt++] = ULONG_W;
	  if ( objcnt == 1 ) return( clist[0] ); 	// One robot in wide
	  if ( objcnt == 2 ) return( clist[ random( 2 ) ] ); // Move to one of two
// If fovea on O or Q, staY.
	  if (ulfov == w.current_goal) return( ULONG_Y );
// If robot in fovea, staY.
	  if ((ulfov == ULONG_A) || (ulfov == ULONG_B)) return( ULONG_Y );
// Move North, East, South or West at random.
	  randno = random( 4 );    // to choose one of 4 actions N,E,S and W
//		  sprintf(wf->wBuf,"\nRand for eye=%d ",randno);
//		  wf->DisplayAndFile(wf->wBuf, 0);
	  switch  (randno)
			 {case 0 : return(ULONG_N);
			  case 1 : return(ULONG_E);
			  case 2 : return(ULONG_S);
			  case 3 : return(ULONG_W);
			  default: error("Something wrong with random number.", randno);
			 }
	 }
}

unsigned long subsumption_speechB()    // for robot B
{ unsigned long ulmove, ultemp;
  ulmove = s->events[BODYMOVE].tim_shift_reg[0];
  ultemp = NULLEVENT;  // Default action.
// If robot-B told A to do an action last step and it did,
//  on TWO consecutive steps, then say "Good" to reward it. Should work out A's
//  move by position of A in B's wide, but easier just to give robot B
//  the information needed.
  if ((w.ul_B_told_A != NULLEVENT) && (w.ul_B_told_A_prev != NULLEVENT) &&
       ((w.ul_B_told_A & 0X000000FF) == sa->events[BODYMOVE].tim_shift_reg[0]) &&
       ((w.ul_B_told_A_prev & 0X000000FF) == sa->events[BODYMOVE].tim_shift_reg[1])
       )
    {wf->DisplayAndFile(" Say SG ",0);
     w.ul_B_told_A = NULLEVENT;
     w.ul_B_told_A_prev = NULLEVENT;
     return(ULONG_SG);
    }
// NB. I have put update_ltmA after get_stimuli_HN both to avoid 'preconscious'
//    rewarding and for mimic-speech.
//
// Assuming here that robot B can see whether robot A is hungry or thirsty.
// If robot-B-tells required and robot A is neither hungry nor thirsty
// and robot A is in robot B's fovea, then robot B tells robot A what
// move to make and rewards robot A with GOOD if it obliges.
  if ((w.robot_B_tells) && (!(sa->drive & 6))
         && ((s->events[FOVEA].tim_shift_reg[0] & 0X000000FF) == ULONG_A))
    {w.ul_B_told_A_prev = w.ul_B_told_A;
     w.ul_B_told_A = (B_tells_A() | 0X00005300 );  // S + move
     s->number_of_B_tells++;
     sprintf(wf->wBuf,"\nB-tells %X ",w.ul_B_told_A);
     wf->DisplayAndFile(wf->wBuf, 0);
     return(w.ul_B_told_A);
    }
  else
    {w.ul_B_told_A_prev = w.ul_B_told_A = NULLEVENT;
    }
// If robot B hears nothing from robot A, it says what it is doing
  if (w.sound_A == ULONG_DADASH)
	 ultemp = ( ulmove | 0X00005300 );   // S plus body move
  return( ultemp );
}

// Robot B tells robot A what body move to make, when A is in its fovea.
// B tells A to turn if B in position to squash object, so it can on next move.
unsigned long B_tells_A()
{ unsigned long ulBtouch, ulBprop, ulAdirn;
  unsigned long ulBwdn, ulBwde, ulBwds, ulBwdw;
  ulAdirn  = s->events[DIRECTION].tim_shift_reg[0];
  ulBtouch = s->events[TOUCH].tim_shift_reg[0];
  ulBprop  = s->events[PROPRIOCEP].tim_shift_reg[0];
  if ((ulBtouch == 0X002D4F3D) || (ulBtouch == 0X002D513D))
    {if (ulBprop == 0X00000604) return(ULONG_R); // Let B squash
     if ((ulBprop == 0X00000603) && (ulAdirn == ULONG_E))
       return(ULONG_F); // then B can squash   11may01
    }
  if ((ulBtouch == 0X003D4F2D) || (ulBtouch == 0X003D512D))
    {if (ulBprop == 0X00000606) return(ULONG_L); // Let B squash
     if ((ulBprop == 0X00000607) && (ulAdirn == ULONG_W))
       return(ULONG_F); // then B can squash   11may01
    }
  ulBwdn  = s->events[WIDENONLY].tim_shift_reg[0];
  ulBwde  = s->events[WIDEEONLY].tim_shift_reg[0];
  ulBwds  = s->events[WIDESONLY].tim_shift_reg[0];
  ulBwdw  = s->events[WIDEWONLY].tim_shift_reg[0];
  switch (ulAdirn)
   {case ULONG_N : if (ulBwdn == ULONG_WALL) return(ULONG_R);
                   if (ulBwds == ULONG_WALL)
                     {if (ulBwdw == ULONG_WALL)
                       {if (ulBwdn != ULONG_B) return(ULONG_F);
                        else return(ULONG_R);
                       }
                      else return(ULONG_L);
                     }
                   if ((ulBwde == ULONG_WALL) || (ulBwdw == ULONG_WALL))
                     return(ULONG_R);
                   if (ulBwdn != ULONG_B) return(ULONG_F);
                   else return(ULONG_R); break;
    case ULONG_E : if (ulBwde == ULONG_WALL) return(ULONG_R);
                   if (ulBwdw == ULONG_WALL)
                     {if (ulBwdn == ULONG_WALL)
                       {if (ulBwde != ULONG_B) return(ULONG_F);
                        else return(ULONG_R);
                       }
                      else return(ULONG_L);
                     }
                   if ((ulBwds == ULONG_WALL) || (ulBwdn == ULONG_WALL))
                     return(ULONG_R);
                   if (ulBwde != ULONG_B) return(ULONG_F);
                   else return(ULONG_R); break;
    case ULONG_S : if (ulBwds == ULONG_WALL) return(ULONG_R);
                   if (ulBwdn == ULONG_WALL)
                     {if (ulBwde == ULONG_WALL)
                       {if (ulBwds != ULONG_B) return(ULONG_F);
                        else return(ULONG_R);
                       }
                      else return(ULONG_L);
                     }
                   if ((ulBwdw == ULONG_WALL) || (ulBwde == ULONG_WALL))
                     return(ULONG_R);
                   if (ulBwds != ULONG_B) return(ULONG_F);
                   else return(ULONG_R); break;
    case ULONG_W : if (ulBwdw == ULONG_WALL) return(ULONG_R);
                   if (ulBwde == ULONG_WALL)
                     {if (ulBwds == ULONG_WALL)
                       {if (ulBwdw != ULONG_B) return(ULONG_F);
                        else return(ULONG_R);
                       }
                      else return(ULONG_L);
                     }
                   if ((ulBwdn == ULONG_WALL) || (ulBwds == ULONG_WALL))
                     return(ULONG_R);
                   if (ulBwdw != ULONG_B) return(ULONG_F);
                   else return(ULONG_R); break;
   }
}

unsigned long abs_to_rel_dirn(unsigned long abs_action)
{ switch ( s->body.bodypos.dirn )	// because eye moves are rel to body dirn
	{case ULONG_N : return( abs_action );
	 case ULONG_E : switch ( abs_action )
							{case ULONG_N : return( ULONG_W );
							 case ULONG_E : return( ULONG_N );
							 case ULONG_S : return( ULONG_E );
							 case ULONG_W : return( ULONG_S );
							 case ULONG_Y: return( ULONG_Y);
							 default: error("Abs_action for E: ", abs_action);
							}
	 case ULONG_S : switch ( abs_action )
							{case ULONG_N : return( ULONG_S );
							 case ULONG_E : return( ULONG_W );
							 case ULONG_S : return( ULONG_N );
							 case ULONG_W : return( ULONG_E );
							 case ULONG_Y: return( ULONG_Y);
							 default: error("Abs_action for S: ", abs_action);
							}
	 case ULONG_W : switch ( abs_action )
							{case ULONG_N : return( ULONG_E );
							 case ULONG_E : return( ULONG_S );
							 case ULONG_S : return( ULONG_W );
							 case ULONG_W : return( ULONG_N );
							 case ULONG_Y: return( ULONG_Y);
							 default: error("Abs_action for W: ", abs_action);
							}
	 default: error("Body direction is not N,E,S or W: ", s->body.bodypos.dirn);
	}
 return( 0 );		// to avoid compiler warning
}

unsigned long rel_to_abs_dirn(unsigned long rel_action)
{ switch ( s->body.bodypos.dirn )	// because eye moves are rel to body dirn
	 {case ULONG_N : return( rel_action );
	  case ULONG_E : switch ( rel_action )
							 {case ULONG_N : return( ULONG_E );
							  case ULONG_E : return( ULONG_S );
							  case ULONG_S : return( ULONG_W );
							  case ULONG_W : return( ULONG_N );
							  case ULONG_Y : return( ULONG_Y);
							  default: error("Rel_action for E is ", rel_action);
							 }
	 case ULONG_S : switch ( rel_action )
							{case ULONG_N : return( ULONG_S );
							 case ULONG_E : return( ULONG_W );
							 case ULONG_S : return( ULONG_N );
							 case ULONG_W : return( ULONG_E );
							 case ULONG_Y : return( ULONG_Y);
							 default: error("Rel_action for S is ", rel_action);
							}
	 case ULONG_W : switch ( rel_action )
							{case ULONG_N : return( ULONG_W );
							 case ULONG_E : return( ULONG_N );
							 case ULONG_S : return( ULONG_E );
							 case ULONG_W : return( ULONG_S );
							 case ULONG_Y : return( ULONG_Y);
							 default: error("Rel_action for W is ", rel_action);
							}
	 default: error("Body dirn is not N,E,S or W but ", s->body.bodypos.dirn);
	}
  return( 0 );		// to avoid compiler warning.
}

// If the other robot didn't make a sound, hear what you said, otherwise hear it.
unsigned long get_hearing_event()
{//  if ( w.diag & 16 )
//	 {sprintf(wf->wBuf, "\nSound-A = %X, Sound-B = %X ", w.sound_A, w.sound_B);
//	  wf->DisplayAndFile(wf->wBuf, 2);
//	 }
 if (w.robot == 'A')
  {if ((w.sound_B == ULONG_SG) && (s->mode == H_N ))
     {wf->DisplayAndFile(" GOOD ",0);
      reward(ULONG_GD);
     }
   return( (w.sound_A << 16) | w.sound_B );
  }
 if (w.robot == 'B') return( (w.sound_B << 16) | w.sound_A );
}

unsigned long get_feeling_event()
{ short left_cell, front_cell, right_cell, row, col;
  unsigned long left, front, right, dirn;
  unsigned long long_A = ULONG_A;
  unsigned long long_B = ULONG_B;
  unsigned long long_R = ULONG_R;
  unsigned long whole;
  row =  s->body.bodypos.row;
  col =  s->body.bodypos.col;
  dirn = s->body.bodypos.dirn;
  switch (dirn)
	 {case ULONG_N : left_cell = row_col_to_cell_no( row, col - 1 );
						  front_cell = row_col_to_cell_no( row - 1, col );
						  right_cell = row_col_to_cell_no( row, col + 1 );  break;
	  case ULONG_E : left_cell = row_col_to_cell_no( row - 1, col );
						  front_cell = row_col_to_cell_no( row, col + 1 );
						  right_cell = row_col_to_cell_no( row + 1, col );  break;
	  case ULONG_S : left_cell = row_col_to_cell_no( row, col + 1 );
						  front_cell = row_col_to_cell_no( row + 1, col );
						  right_cell = row_col_to_cell_no( row, col - 1 );  break;
	  case ULONG_W : left_cell = row_col_to_cell_no( row + 1, col );
						  front_cell = row_col_to_cell_no( row, col - 1 );
						  right_cell = row_col_to_cell_no( row - 1, col );  break;
	  default  : error("Inadmissible direction-1: ", dirn);
	 }
  left  = (( w.board[left_cell]  >> 16 ) & 0X000000FF );
  front = (( w.board[front_cell] >> 16 ) & 0X000000FF );
  right = (( w.board[right_cell] >> 16 ) & 0X000000FF );
  if ( (left  == long_A) || (left  == long_B) ) left  = long_R; // R for A or B
  else if (left == ULONG_ZERO) left = ULONG_DASH;
  if ( (front == long_A) || (front == long_B) ) front = long_R; // R for A or B
  else if (front == ULONG_ZERO) front = ULONG_DASH;
  if ( (right == long_A) || (right == long_B) ) right = long_R; // R for A or B
  else if (right == ULONG_ZERO) right = ULONG_DASH;
  whole = ( (left << 16) | (front << 8) | right );
  return (whole);
}

unsigned long get_proprioception_event()  // Eye posn rel to body posn.
{ short brow, bcol, erow, ecol;           // Place body at 55
  short rowdif, coldif, frontdif, sidedif;
  unsigned long code, dirn;               // NN NN NN NN NN NN NN
  unsigned long Nbyte = ULONG_N;          // NN NN NN NN NN NN NN
  unsigned long Ebyte = ULONG_E;          // WW 73 74 75 76 77 EE
  unsigned long Sbyte = ULONG_S;          // WW 63 64 65 66 67 EE    10apr00
  unsigned long Wbyte = ULONG_W;          // WW 53 54 55 56 57 EE
  brow =  s->body.bodypos.row;            // WW 43 44 45 46 47 EE
  bcol =  s->body.bodypos.col;            // WW 33 34 35 36 37 EE    20apr00
  dirn =  s->body.bodypos.dirn;           // SS SS SS SS SS SS SS
  erow =  s->body.eyepos.row;             // SS SS SS SS SS SS SS
  ecol =  s->body.eyepos.col;
  rowdif = erow - brow;
  coldif = ecol - bcol;
  switch ( dirn )
	 {case ULONG_N : frontdif = 0 - rowdif;
						  sidedif  = coldif;     break;
	  case ULONG_E : frontdif = coldif;
						  sidedif  = rowdif;     break;
	  case ULONG_S : frontdif = rowdif;
						  sidedif  = 0 - coldif; break;
	  case ULONG_W : frontdif = 0 - coldif;
						  sidedif  = 0 - rowdif; break;
	  default  : error("Inadmissible direction-2: ", dirn);
	 };
  if      (frontdif > 2)  code = ((Nbyte << 8) | Nbyte );  // NN
  else if (frontdif < -2) code = ((Sbyte << 8) | Sbyte );  // SS
  else if (sidedif  > 2)  code = ((Ebyte << 8) | Ebyte );  // EE  10apr00
  else if (sidedif  < -2) code = ((Wbyte << 8) | Wbyte );  // WW  10apr00
  else code = (unsigned long) (((frontdif + 5) << 8) | (sidedif + 5));
  return( code );
}

// Added seeing of an eye(s) to fovea on 8sep99
unsigned long get_fovea_event()
{ short eyerow, eyecol, eyecell_no;
  unsigned long eyecell_contents, dirn;
  eyerow =  s->body.eyepos.row;
  eyecol =  s->body.eyepos.col;
  eyecell_no = row_col_to_cell_no( eyerow, eyecol );
  eyecell_contents = (w.board[eyecell_no] & 0X00FF0000) >> 16; // 8aug00
  if ((eyecell_contents & 0X000000FF) == ULONG_ZERO)
	  eyecell_contents |= 0X0000002D;   // replace 00 by 2D  (dash)
//  if ((eyecell_contents & 0X0000FF00) == ULONG_ZERO)
//	  eyecell_contents |= 0X00002D00;   // replace 00 by 2D  (dash)
//  dirn = eyecell_contents & 0X000000FF;
//  if (dirn == ULONG_ZERO) dirn = 0X0000002D;   // replace 00 by 2D  (dash)
//  else if ( !(dirn == ULONG_WALL) )
//		  dirn = abs_to_rel_dirn( dirn );       // absolute to relative
//  eyecell_contents = (eyecell_contents & 0X00FFFF00) | dirn; // removed 7aug00
//c   pp->canvas[FOVEA_CELL] = eyecell_contents;      // 'A', 'B', 'O', '-' or ' '
//c   pp->decay[FOVEA_CELL] = STEPSTODECAY;
  return( eyecell_contents);
}

unsigned long get_wide_event()    // get-surround in Scheme program
{ short eyerow, eyecol;
  unsigned long ncell, ecell, scell, wcell, body_dirn, ulwid;
  unsigned long nncell, eecell, sscell, wwcell;
  eyerow =  s->body.eyepos.row;
  eyecol =  s->body.eyepos.col;
  body_dirn = s->body.bodypos.dirn;
  ncell = get_left_byte_board_cell(eyerow - 1, eyecol);
  ecell = get_left_byte_board_cell(eyerow, eyecol + 1);
  scell = get_left_byte_board_cell(eyerow + 1, eyecol);
  wcell = get_left_byte_board_cell(eyerow, eyecol - 1);
  switch ( body_dirn )
	 {case ULONG_N : nncell = (ncell << 24);
						  eecell = (ecell << 16);
						  sscell = (scell << 8);
						  wwcell = wcell;
						  break;
	  case ULONG_E : nncell = (ecell << 24);
						  eecell = (scell << 16);
						  sscell = (wcell << 8);
						  wwcell = ncell;
						  break;
	  case ULONG_S : nncell = (scell << 24);
						  eecell = (wcell << 16);
						  sscell = (ncell << 8);
						  wwcell = ecell;
						  break;
	  case ULONG_W : nncell = (wcell << 24);
						  eecell = (ncell << 16);
						  sscell = (ecell << 8);
						  wwcell = scell;
						  break;
	  default  : error("Inadmissible direction-3: ", body_dirn);
	 }
  ulwid =  nncell | eecell | sscell | wwcell;
//c   if (w.robot == 'A') canvas_from_wide(ulwid);
  return( ulwid );
}

unsigned long get_dirn_event()  // Rel. dirn of other robot
{ short eyerow, eyecol;
  unsigned long fcell, ncell, ecell, scell, wcell, body_dirn, robname;
  unsigned long absdirn;
  if (w.robot == 'A') robname = ULONG_B;  // Other robot's name.
  else robname = ULONG_A;
  absdirn = ULONG_DASH;      // Unless other robot is seen in fovea or wide
  eyerow =  s->body.eyepos.row;
  eyecol =  s->body.eyepos.col;
  body_dirn = s->body.bodypos.dirn;
  fcell = get_left_byte_board_cell(eyerow, eyecol);
  if (fcell == robname)
	 absdirn = get_right_byte_board_cell(eyerow, eyecol);
  else
	{ncell = get_left_byte_board_cell(eyerow - 1, eyecol);
	 if (ncell == robname)
		absdirn = get_right_byte_board_cell(eyerow - 1, eyecol);
	 else
	  {ecell = get_left_byte_board_cell(eyerow, eyecol + 1);
		if (ecell == robname)
		  absdirn = get_right_byte_board_cell(eyerow, eyecol + 1);
		else
		 {scell = get_left_byte_board_cell(eyerow + 1, eyecol);
		  if (scell == robname)
			 absdirn = get_right_byte_board_cell(eyerow + 1, eyecol);
		  else
			{wcell = get_left_byte_board_cell(eyerow, eyecol - 1);
			 if (wcell == robname)
				absdirn = get_right_byte_board_cell(eyerow, eyecol - 1);
			}
		 }
	  }
	}
  if (absdirn == ULONG_DASH) return(ULONG_DASH);  // Robot not in view.
  switch ( body_dirn )
	{case ULONG_N : return( absdirn );
	 case ULONG_E : switch ( absdirn )
							{case ULONG_N : return( ULONG_W );
							 case ULONG_E : return( ULONG_N );
							 case ULONG_S : return( ULONG_E );
							 case ULONG_W : return( ULONG_S );
							 case ULONG_Y: return( ULONG_Y);
							 default: error("absdirn for E: ", absdirn);
							}
	 case ULONG_S : switch ( absdirn )
							{case ULONG_N : return( ULONG_S );
							 case ULONG_E : return( ULONG_W );
							 case ULONG_S : return( ULONG_N );
							 case ULONG_W : return( ULONG_E );
							 case ULONG_Y: return( ULONG_Y);
							 default: error("absdirn for S: ", absdirn);
							}
	 case ULONG_W : switch ( absdirn )
							{case ULONG_N : return( ULONG_E );
							 case ULONG_E : return( ULONG_S );
							 case ULONG_S : return( ULONG_W );
							 case ULONG_W : return( ULONG_N );
							 case ULONG_Y: return( ULONG_Y);
							 default: error("absdirn for W: ", absdirn);
							}
	 default: error("Body dirn is not N,E,S or W: ", s->body.bodypos.dirn);
	}
 return( 0 );		// to avoid compiler warning
}

unsigned long get_left_byte_board_cell(short row, short col)
{ unsigned long lbyte;
  if ((row < 1) || (col < 1) || (row > BOARD_ROWS) || (col > BOARD_COLS))
	 lbyte = ULONG_WALL;
  else
	{lbyte = ((w.board[row_col_to_cell_no(row, col)] & 0X00FF0000 ) >> 16 );
	 if (lbyte == 0) lbyte = ULONG_DASH;
	}
  return( lbyte );
}

unsigned long get_mid_byte_board_cell(short row, short col)
{ unsigned long mbyte;
  mbyte = ((w.board[row_col_to_cell_no(row, col)] & 0X0000FF00 ) >> 8 );
  if (mbyte == 0) mbyte = ULONG_DASH;
  return( mbyte );
}

unsigned long get_right_byte_board_cell(short row, short col)
{ unsigned long rbyte;
  rbyte = ( w.board[row_col_to_cell_no(row, col)]  & 0X000000FF );
  if (rbyte == 0) rbyte = ULONG_DASH;
  return( rbyte );
}

void set_left_byte_board_cell(short row, short col, unsigned long ulbyte)
{ if (ulbyte == ULONG_DASH) ulbyte = 0;
  w.board[row_col_to_cell_no(row, col)] &= 0X0000FFFF;
  w.board[row_col_to_cell_no(row, col)] |= ( ulbyte << 16);  }

void set_mid_byte_board_cell(short row, short col, unsigned long ulbyte)
{ if (ulbyte == ULONG_DASH) ulbyte = 0;
  w.board[row_col_to_cell_no(row, col)] &= 0X00FF00FF;
  w.board[row_col_to_cell_no(row, col)] |= ( ulbyte << 8);   }

void set_right_byte_board_cell(short row, short col, unsigned long ulbyte)
{ if (ulbyte == ULONG_DASH) ulbyte = 0;
  w.board[row_col_to_cell_no(row, col)] &= 0X00FFFF00;
  w.board[row_col_to_cell_no(row, col)] |= ulbyte;           }

unsigned long get_desire_event()
{ return( (unsigned long) s->drive);
}

// Taking landmarks only from CLBE at present <<<<<<<<<<<<
//unsigned long get_landmark_event()
//{ return( pp->clustersA[CLBE].landmark_event );
//}


// ***** Moves eye by changing character on board positions.
void move_eye(short erow, short ecol, short nrow, short ncol)
{ unsigned long ulmid, nlmid, uleft;    //    nleft;  not used
  if ((nrow < 0) || (nrow > (BOARD_ROWS + 2)) ||
		(ncol < 0) || (ncol > (BOARD_COLS + 2)) )
	 error("Inadmissible destination for eye move.");
  ulmid = get_mid_byte_board_cell(erow, ecol);
  nlmid = get_mid_byte_board_cell(nrow, ncol);
  uleft = get_left_byte_board_cell(erow, ecol);
  if ((( ulmid == ULONG_a ) && ( w.robot == 'A' )) ||
		(( ulmid == ULONG_b ) && ( w.robot == 'B' )))
	 {if ( uleft == ULONG_WALL ) set_mid_byte_board_cell(erow, ecol, ULONG_WALL);
	  else set_mid_byte_board_cell(erow, ecol, ULONG_DASH);
	 }    // Have now reset the exited cell if it had a or b.
  else if ( ulmid == ULONG_x )
	 {if ( w.robot == 'A' ) set_mid_byte_board_cell(erow, ecol, ULONG_b);
	  else if ( w.robot == 'B' ) set_mid_byte_board_cell(erow, ecol, ULONG_a);
			 else error("X must mean A and B eyes over cell.");
	 }    // Have now reset the exitted cell if it had x.
  if ((( nlmid == ULONG_a ) && ( w.robot == 'B' )) ||
		(( nlmid == ULONG_b ) && ( w.robot == 'A' )))
	  set_mid_byte_board_cell(nrow, ncol, ULONG_x);  // sets new cell if A or B
  else if (( nlmid == ULONG_DASH ) || ( nlmid == ULONG_WALL ))
	 {if ( w.robot == 'A' ) set_mid_byte_board_cell(nrow, ncol, ULONG_a);
	  else if ( w.robot == 'B' ) set_mid_byte_board_cell(nrow, ncol, ULONG_b);
				else error("Robot must be A or B.");
	 }  // Have now set the new cell if it was - or =.
  s->body.eyepos.row = nrow;
  s->body.eyepos.col = ncol;
}

// As it is, this does not allow the pushing of another robot even when
// it is facing in the same direction.
BOOL can_move_forward(short brow, short bcol, unsigned long dirn)
{ short nrow, ncol;
  BOOL can_move;
  unsigned long newleft;
  switch ( dirn )
	 {case ULONG_N : nrow = (brow - 1); ncol = bcol; break;
	  case ULONG_S : nrow = (brow + 1); ncol = bcol; break;
	  case ULONG_E : nrow = brow; ncol = (bcol + 1); break;
	  case ULONG_W : nrow = brow; ncol = (bcol - 1);
	 }
  newleft =	get_left_byte_board_cell(nrow, ncol);
  if ( w.diag & 16 )
	{sprintf(wf->wBuf,
		"\ncan_move_forward: to nrow=%d,ncol=%d,dirn=%X, newleft=%X ",
														nrow,ncol,dirn,newleft);
	 wf->DisplayAndFile(wf->wBuf, 2);    }
  switch ( newleft )
	 {case ULONG_A :
	  case ULONG_B :
	  case ULONG_WALL : can_move = FALSE; break;
	  case ULONG_DASH : change_body_posn(brow,bcol,nrow,ncol,dirn);
							  can_move = TRUE; break;
	  case ULONG_O : if ( can_move_or_squash_object(nrow,ncol,dirn) )
							 {change_body_posn(brow,bcol,nrow,ncol,dirn);
							  can_move = TRUE;}
						  else {object_squashed(nrow,ncol,ULONG_O);
								  can_move = FALSE;}
						  break;
	  case ULONG_Q : if ( can_move_or_squash_object(nrow,ncol,dirn) )
							 {change_body_posn(brow,bcol,nrow,ncol,dirn);
							  can_move = TRUE;}
						  else {object_squashed(nrow,ncol,ULONG_Q);
								  can_move = FALSE;}
						  break;
	  default : error("Inadmissible cell contents: ", newleft);
	 }
  return( can_move );
}

// Clears cell where object was.
void object_squashed( short orow, short ocol, unsigned long object )
{ if (object == w.current_goal) reward(w.current_goal);
  set_left_byte_board_cell(orow, ocol, ULONG_DASH);
  w.old_object_posn.row = orow;
  w.old_object_posn.col = ocol;
  w.object_squashed = TRUE;
  wf->DisplayAndFile("\nObject squashed ", 2);
}

// Places new food/drink object in an empty, not new corner square.
void new_object_in_random_empty_posn()
{ short row, col, cellpos, oldpos, randno;
  unsigned long uleft;      // unsigned long left byte of cell
// New food/drink object is not put into corner square.
  oldpos = row_col_to_cell_no(w.old_object_posn.row, w.old_object_posn.col);
  randno = random(6) + 1; // There are 6 empty positions without A, B or O
  for (row = 1; ((row < 4) && (randno)); row++)
	  for (col = 1; (col < 4) && (randno); col++)
		  {cellpos = row_col_to_cell_no(row, col);
			uleft = (w.board[cellpos] & 0X00FF0000 ) >> 16;
			if ((cellpos == oldpos) || (uleft == ULONG_A) || (uleft == ULONG_B))
			  continue;
			else randno--;
		  }
  w.board[cellpos] &= 0X0000FF00;			// put O/Q in left char position
  w.board[cellpos] |= (w.current_goal << 16);   // of board cell at cellpos.
  w.board[oldpos] &= 0X0000FF00;			   // remove O/Q from old position
  w.object_squashed = FALSE;
}

// Sees what is in cell beyond object to see if object can be moved.
// Returns TRUE if can move, and FALSE if it will be squashed.
BOOL can_move_or_squash_object(short row, short col, unsigned long dirn)
{ short far_row, far_col;
  unsigned long uleft;
  switch (dirn)
	 {case ULONG_N : far_row = row - 1;
						  far_col = col; break;
	  case ULONG_E : far_row = row;
						  far_col = col + 1; break;
	  case ULONG_S : far_row = row + 1;
						  far_col = col; break;
	  case ULONG_W : far_row = row;
						  far_col = col - 1; break;
	  default : error("Inadmissible direction-4: ", dirn);
	 }
  uleft = get_left_byte_board_cell(far_row, far_col);
  if ( w.diag & 16 )
	{sprintf(wf->wBuf,
			 "\ncan_move_or_sq_obj to far_row=%d,far_col%d,dirn=%X,uleft= %X ",
													  far_row,far_col,dirn,uleft);
	 wf->DisplayAndFile(wf->wBuf, 2);     }
  switch ( uleft )
	 {case ULONG_DASH : move_object(row, col, far_row, far_col); return(TRUE);
	  case ULONG_A :
	  case ULONG_B :
	  case ULONG_WALL : return( can_pop_object_sideways(row, col, dirn) );
	  case ULONG_O : error("Illegal second object: ", uleft);
	  case ULONG_Q : error("Illegal second object: ", uleft);
	  default : error("Illegal contents in cell.", uleft);
	 }
  return( FALSE );		// to avoid compiler warning
}

void move_object(short row, short col, short far_row, short far_col)
{ set_left_byte_board_cell(row, col, ULONG_DASH);
  set_left_byte_board_cell(far_row, far_col, w.current_goal);
  set_right_byte_board_cell(row, col, ULONG_DASH);
  set_right_byte_board_cell(far_row, far_col, ULONG_DASH);
  w.object.row = far_row;
  w.object.col = far_col;
  w.old_object_posn.row = row;
  w.old_object_posn.col = col;
  if ( w.diag & 16 )
	{sprintf(wf->wBuf,
		 "\nObj moved from row=%d,col=%d:%X, to far_row=%d,far_col=%d:%X ",
						 row,col,w.board[row_col_to_cell_no(row, col)],
				 far_row,far_col,w.board[row_col_to_cell_no(far_row, far_col)]);
	 wf->DisplayAndFile(wf->wBuf, 2);    }
}

// Wall or robot beyond object, so test if it can be moved sideways.
BOOL can_pop_object_sideways(short row, short col, unsigned long dirn)
{ short lrow, lcol, rrow, rcol;
  unsigned long leftchleft, leftchright, ldirn, rdirn;
  switch ( dirn )
	 {case ULONG_N : lrow = row; lcol = col - 1; ldirn = ULONG_W;
						  rrow = row; rcol = col + 1; rdirn = ULONG_E; break;
	  case ULONG_E : lrow = row - 1; lcol = col; ldirn = ULONG_N;
						  rrow = row + 1; rcol = col; rdirn = ULONG_S; break;
	  case ULONG_S : lrow = row; lcol = col + 1; ldirn = ULONG_E;
						  rrow = row; rcol = col - 1; rdirn = ULONG_W; break;
	  case ULONG_W : lrow = row + 1; lcol = col; ldirn = ULONG_S;
						  rrow = row - 1; rcol = col; rdirn = ULONG_N; break;
	  default : error("Direction not N, S, E or W: ", dirn);
	 }
  leftchleft  = get_left_byte_board_cell( lrow, lcol);
  leftchright = get_left_byte_board_cell( rrow, rcol);
  if ( w.diag & 16 )
	{sprintf(wf->wBuf,
	  "\npop to lrow=%d,lcol=%d,ldirn=%X,lchl=%X,or rrow=%d,rcol=%d,rdirn=%X,lchr=%X ",
						lrow,lcol,ldirn,leftchleft,rrow,rcol,rdirn,leftchright);
	 wf->DisplayAndFile(wf->wBuf, 2);     }
  if ((leftchleft == ULONG_DASH) && (leftchright == ULONG_DASH)) // either poss
	 if (random(10) > 4) return( can_move_or_squash_object(row, col, ldirn) );
	 else  return( can_move_or_squash_object(row, col, rdirn) );
  if ((leftchleft == ULONG_WALL)  && (leftchright == ULONG_WALL)) // For new
	 return( FALSE );                                              // corner
  if (leftchleft == ULONG_DASH)       //  || (leftchright == ULONG_WALL))
	  return(can_move_or_squash_object(row, col, ldirn) );
  if (leftchright == ULONG_DASH)      //  || (leftchleft == ULONG_WALL))
	  return(can_move_or_squash_object(row, col, rdirn) );
  return( FALSE );		// includes immovable robot being at side
  }

// *****  FUNCTION: do_action_in_world()  *****
// DESCRIPTION: Performs given action according to the world type.

void do_action_in_world(struct event_type evtyp)
{ unsigned long  action, actionb, actione, abseyeaction;      // 9may00
  short type, typeb, typee;
  short brow, bcol, erow, ecol;
  unsigned long bdir;
  brow  = s->body.bodypos.row;
  bcol  = s->body.bodypos.col;
  bdir  = s->body.bodypos.dirn;
  erow  = s->body.eyepos.row;
  ecol  = s->body.eyepos.col;
  action = evtyp.event;
  type = evtyp.type;
  typeb = typee = NULLTYPE;
  if (type == BODYEYE)
	 {typeb = BODYMOVE;
	  typee = EYEMOVE;
	  actionb = action >> 8;
	  actione = action & 0X000000FF;
	 }
  else if (type == BODYMOVE)
			{typeb = BODYMOVE;
			 actionb = action;
			}
  else if (type == EYEMOVE)
			{typee = EYEMOVE;
			 actione = action;
			}
  if (typeb == BODYMOVE)
	 {w.object_squashed = FALSE;
	  switch (actionb)
		  {case ULONG_F :
			  if (w.robot == 'A') (s->events[FORWARD].tim_shift_reg[0] = ULONG_F);
			  if ( can_move_forward(brow, bcol, bdir) )
				 {wf->DisplayAndFile(" moves forward ", 2);
				  s->resource_f *= w.fooddec;
				  s->resource_d *= w.drinkdec;
				 }
			  else
                 {wf->DisplayAndFile(" can't move forward ", 2);
				  s->resource_d *= w.drinkdec;
                 }
			  break;
			case ULONG_L    :
			  if (w.robot == 'A') {(s->events[LEFT].tim_shift_reg[0] = ULONG_L);
										 }
			  s->resource_d *= w.drinkdec;
			  change_body_posn(brow, bcol, brow, bcol, rotate(ULONG_L, bdir));
			  break;
			case ULONG_R   :
			  if (w.robot == 'A') {(s->events[RIGHT].tim_shift_reg[0] = ULONG_R);
										 }
			  s->resource_d *= w.drinkdec;
			  change_body_posn(brow, bcol, brow, bcol, rotate(ULONG_R, bdir));
			  break;
			default: error("\nIllegal body action: ", actionb);
		  }
	  if  (s->resource_f < 0) s->resource_f = 0;
	  if  (s->resource_d < 0) s->resource_d = 0;
	  if ( w.object_squashed ) new_object_in_random_empty_posn();
	  update_drives();
	 }
  if (typee == EYEMOVE)
	 {if ( w.robot == 'A' )  //c  No canvas for robot B
		  switch (actione)
			 {case ULONG_Y: s->events[EYESTAY].tim_shift_reg[0]  = ULONG_Y;
								  break;
			  case ULONG_N:  s->events[EYENORTH].tim_shift_reg[0] = ULONG_N;
								  s->events[NOTYEYEMOVE].tim_shift_reg[0] = ULONG_N;
								  break;
			  case ULONG_E:  s->events[EYEEAST].tim_shift_reg[0]  = ULONG_E;
								  s->events[NOTYEYEMOVE].tim_shift_reg[0]  = ULONG_E;
								  break;
			  case ULONG_S:  s->events[EYESOUTH].tim_shift_reg[0] = ULONG_S;
								  s->events[NOTYEYEMOVE].tim_shift_reg[0] = ULONG_S;
								  break;
			  case ULONG_W:  s->events[EYEWEST].tim_shift_reg[0]  = ULONG_W;
								  s->events[NOTYEYEMOVE].tim_shift_reg[0]  = ULONG_W;
								  break;
			  default: error("\nIllegal eye action: ", actione);
			 }
	  abseyeaction = rel_to_abs_dirn(actione);
//	  sprintf(wf->wBuf, "\nAbs Eye action = %X ",abseyeaction);
//	  wf->DisplayAndFile(wf->wBuf, 0);
	  switch (abseyeaction)
		  {case ULONG_Y:  break;		// stay - no movement
			case ULONG_N:  if (erow >= 1)
								  move_eye(erow, ecol, (erow-1), ecol); break;
			case ULONG_E:  if (ecol <= BOARD_COLS)
								  move_eye(erow, ecol, erow, (ecol+1)); break;
			case ULONG_S:  if (erow <= BOARD_ROWS)
								  move_eye(erow, ecol, (erow+1), ecol); break;
			case ULONG_W:  if (ecol >= 1)
								  move_eye(erow, ecol, erow, (ecol-1)); break;
			default: error("\nIllegal absolute eye action: ", abseyeaction);
		  }
	 }
  if ( type == SAY )
	 {if (w.robot == 'A')
		  {if (action == NULLEVENT) w.sound_A = ULONG_DADASH; // - or 2D
		   else w.sound_A = action;
		  }
	  else      // robot B
		  {if (action == NULLEVENT) w.sound_B = ULONG_DADASH; // - or 2D
		   else w.sound_B = action;
		  }
	 }
}

unsigned long rotate(unsigned long action, unsigned long dirn)
{ switch (action)
	 {case ULONG_L : switch (dirn)
							 {case ULONG_N: return( ULONG_W );
							  case ULONG_E: return( ULONG_N );
							  case ULONG_S: return( ULONG_E );
							  case ULONG_W: return( ULONG_S );
							  default: error("Dirn not N, S, E or W: ", dirn);
							 }
	  case ULONG_R : switch (dirn)
							 {case ULONG_N: return( ULONG_E );
							  case ULONG_E: return( ULONG_S );
							  case ULONG_S: return( ULONG_W );
							  case ULONG_W: return( ULONG_N );
							  default: error("Dirn is neither N, S, E or W: ", dirn);
							 }
	  default : return( dirn );
	 }
}

// This changes the body position of the current robot only. If robots
// can be pushed, a more general function will be needed (as in Scheme version).
void change_body_posn(short row, short col, short nrow, short ncol,
																		unsigned long ndirn)
{ short boardcell, nboardcell;
  boardcell = row_col_to_cell_no(row, col);
  nboardcell = row_col_to_cell_no(nrow, ncol);
  if ( w.diag & 16 )
	{sprintf(wf->wBuf, "\nchange_body_posn to row %d col %d contents %X ",
													nrow, ncol, w.board[nboardcell]);
	 wf->DisplayAndFile(wf->wBuf, 2);    }
  if ((row == nrow) && (col == ncol))		// only a turn
	 {s->body.bodypos.dirn = ndirn;
	  w.board[boardcell] = ((w.board[boardcell] & 0X00FFFF00) | ndirn);
	 }
  else
	 {if (w.board[nboardcell] == (w.board[nboardcell] & 0X0000FF00)) //OK to move
		 {if ( w.robot == 'A' ) w.board[nboardcell] |= (ndirn | (ULONG_A << 16 ));
		  else  w.board[nboardcell] |= (ndirn | (ULONG_B << 16 ));
		  nboardcell = row_col_to_cell_no(nrow, ncol);
		  s->body.bodypos.row = nrow;
		  s->body.bodypos.col = ncol;
		  s->body.bodypos.dirn = ndirn;
		  w.board[boardcell] &= 0X0000FF00;	// remove object and direction
		 }
	  else error("Robot can't move into occupied cell.", w.board[nboardcell]);
	 }
}

//c void canvas_from_wide(unsigned long ulwid)
//c { pp->canvas[NORTH_CELL] = ((ulwid & 0XFF000000) >> 24);
//c   pp->decay[NORTH_CELL]  = STEPSTODECAY;
//c   pp->canvas[EAST_CELL]  = ((ulwid & 0X00FF0000) >> 16);
//c   pp->decay[EAST_CELL]   = STEPSTODECAY;
//c   pp->canvas[SOUTH_CELL] = ((ulwid & 0X0000FF00) >>  8);
//c   pp->decay[SOUTH_CELL]  = STEPSTODECAY;
//c   pp->canvas[WEST_CELL]  =  (ulwid & 0X000000FF);
//c   pp->decay[WEST_CELL]   = STEPSTODECAY;
//c }

//c void extra_events_from_wide_and_canvas( unsigned long surround, short delay)
void extra_events_from_wide( unsigned long surround, short delay)
{ s->events[WIDENONLY].tim_shift_reg[delay] = (surround >> 24);
  s->events[WIDEEONLY].tim_shift_reg[delay] = (surround & 0X00FF0000) >> 16;
  s->events[WIDESONLY].tim_shift_reg[delay] = (surround & 0X0000FF00)>>  8;
  s->events[WIDEWONLY].tim_shift_reg[delay] = (surround & 0X000000FF);
//c  if (w.robot == 'A')
//c	 {s->events[NCANVAS].tim_shift_reg[delay]  =
//c					 (((pp->canvas[NN_CELL]    & 0X000000FF) << 24) |
//c					  ((pp->canvas[NE_CELL]    & 0X000000FF) << 16) |
//c					  ((pp->canvas[FOVEA_CELL] & 0X000000FF) <<  8) |
//c						(pp->canvas[NW_CELL]    & 0X000000FF)          );
//c	  s->events[ECANVAS].tim_shift_reg[delay]  =
//c					 (((pp->canvas[EE_CELL]    & 0X000000FF) << 24) |
//c					  ((pp->canvas[SE_CELL]    & 0X000000FF) << 16) |
//c					  ((pp->canvas[FOVEA_CELL] & 0X000000FF) <<  8) |
//c						(pp->canvas[NE_CELL]    & 0X000000FF)          );
//c	  s->events[SCANVAS].tim_shift_reg[delay]  =
//c					 (((pp->canvas[SS_CELL]    & 0X000000FF) << 24) |
//c					  ((pp->canvas[SW_CELL]    & 0X000000FF) << 16) |
//c					  ((pp->canvas[FOVEA_CELL] & 0X000000FF) <<  8) |
//c						(pp->canvas[SE_CELL]    & 0X000000FF)          );
//c	  s->events[WCANVAS].tim_shift_reg[delay]  =
//c					 (((pp->canvas[WW_CELL]    & 0X000000FF) << 24) |
//c					  ((pp->canvas[NW_CELL]    & 0X000000FF) << 16) |
//c					  ((pp->canvas[FOVEA_CELL] & 0X000000FF) <<  8) |
//c						(pp->canvas[SW_CELL]    & 0X000000FF)          );
//c	  s->events[CANVAS].tim_shift_reg[delay]  =
//c					 (((pp->canvas[NW_CELL] & 0X000000FF) << 24) |
//c					  ((pp->canvas[NE_CELL] & 0X000000FF) << 16) |
//c					  ((pp->canvas[SE_CELL] & 0X000000FF) <<  8) |
//c						(pp->canvas[SW_CELL] & 0X000000FF)          );
//c	 }
}

void extra_action_events(short stream, unsigned long action)
{ switch (stream)
	 {case 0 :  switch (action)		// Body move stream
					  {case ULONG_F : s->events[FORWARD].tim_shift_reg[0] = action;
						case ULONG_L : s->events[LEFT].tim_shift_reg[0] = action;
						case ULONG_R : s->events[RIGHT].tim_shift_reg[0] = action;
					  }
	  case 1 :  switch (action)     // Eye move stream
					  {case ULONG_N  : s->events[EYENORTH].tim_shift_reg[0] = action;
						case ULONG_E  : s->events[EYEEAST].tim_shift_reg[0] = action;
						case ULONG_S  : s->events[EYESOUTH].tim_shift_reg[0] = action;
						case ULONG_W  : s->events[EYEWEST].tim_shift_reg[0] = action;
						case ULONG_Y : s->events[EYESTAY].tim_shift_reg[0] = action;
					  }
	  default: error("Stream is neither 0 or 1.");
	 }
}

// Robots increase their resources with reward even if they are not hungry/thirsty
// as long as their resource level is below w.sat_up.
void update_drives()
{ s->drive_has_changed = FALSE;
  if ((s->reward == w.food)  && (s->resource_f < w.sat_up))
	 s->resource_f += w.foodinc;
  if ((s->resource_f >= w.sat_up) && (s->drive & w.food))
	{s->drive &= w.drink;  // removes hunger and keeps thirst if there
	 if (!w.min_file_record_while_jumping)
       {sprintf(wf->wBuf, "\nHunger satisfied, drive=%d", s->drive);
		wf->DisplayAndFile(wf->wBuf, 0);
       }
	 s->drive_has_changed = TRUE;
	}
  if ((s->reward == w.drink) && (s->resource_d < w.sat_up))
	 s->resource_d += w.drinkinc;
  if ((s->resource_d >= w.sat_up) && (s->drive & w.drink))
	{s->drive &= w.food;   // removes thirst and keeps hunger if there
	 if (!w.min_file_record_while_jumping)
       {sprintf(wf->wBuf, "\nThirst quenched, drive=%d", s->drive);
		wf->DisplayAndFile(wf->wBuf, 0);
       }
	 s->drive_has_changed = TRUE;
	}
  if ((s->resource_f < w.sat_down)  && (!(s->drive & w.food)))
	 {s->drive |= w.food;    // becomes hungry
	  if (!w.min_file_record_while_jumping)
        {sprintf(wf->wBuf, "\nHungry, drive=%d", s->drive);
	     wf->DisplayAndFile(wf->wBuf, 0);
        }
	  s->drive_has_changed = TRUE;
	 }
  if ((s->resource_d < w.sat_down)  && (!(s->drive & w.drink)))
	 {s->drive |= w.drink;   // becomes thirsty
	  if (!w.min_file_record_while_jumping)
         {sprintf(wf->wBuf, "\nThirsty, drive=%d", s->drive);
	      wf->DisplayAndFile(wf->wBuf, 0);
         }
	  s->drive_has_changed = TRUE;
	 }
}





//				CALCULATION OF NUMBERS OF EVENTS        23sep99

// Number of BodyMove events:  F, L and R      							Total = 3
// Number of EyeMove events:  ST, N, E, S, W   							Total = 5

// Number of Feel events: --- =-- -=- --= ==- -==               	  6
//  --? -?- ?-- -=? -?= ?-= =-? =?- ?=- ==? ?== where ? is O R     22
//  -?? ?-? ??- =?? ?=? ??= where ?? is  OR or RO                  12
//																						Total = 40

// Number of Proprioceptive events:
//               NN EE SS WW 74 75 76 64 65 66 54 55 56 44 45 46  Total = 16

// Number of Foveal events:
//        ?A? ?X? where ?? is == -- O- AN AE AS AW BN BE BS BW    Total = 22

// Number of Wide events:
// On wall: ===? ==?= =?== ?=== where ? is - O A B                     16
// Corner: ==?? ?==? ??== =??= where ?? is -- O- -O B- -B A- -B
//                                            OB BO OA AO AB BA        52
// Side: =??? ?=?? ??=? ???= where ??? is --- O-- -O- --O B-- -B- --B
//                                            OB- O-B BO- -OB B-O -BO
//                                                        A-- -A- --A
//                                            OA- O-A AO- -OA A-O -AO
//                                            OAB OBA AOB BOA ABO BAO 112
// Middle: ???? including ---- O--- -O-- --O- ---O B--- -B-- --B- ---B
//                             OB-- O-B- O--B BO-- -OB- -O-B
//                             B-O- -BO- --OB B--O -B-O --BO
//                             OA-- O-A- O--A AO-- -OA- -O-A
//                             A-O- -AO- --OA A--O -A-O --AO
//                             BA-- B-A- B--A AB-- -BA- -B-A
//                             A-B- -AB- --BA A--B -A-B --AB
//                             ABO- AOB- BAO- BOA- OAB- OBA-
//                             AB-O AO-B BA-O BO-A OA-B OB-A
//                             A-BO A-OB B-AO B-OA O-AB O-BA
//                             -ABO -AOB -BAO -BOA -OAB -OBA          59
//                                                               Total = 239


